﻿
/* - Functions -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/* - Site Chrome / Layout ------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/* - Prototype Code ----------------------------------------------------------------------------------------------------------------------------------------------------------------*/

var xhr = null;
var isPageTransitioning = null;
var isSpreadTransitioning = null;
var isDragging = false;
var globalPageReferrer = document.referrer;
var globalPageLocation = document.location.href;
var lastRequest = null;

function toggleFixedProductViewer() {																									// Check to see if the footer is in the correct state for the document's scroll position.
    if ($("ProductViewer")) {
        var PVB = $(document).scrollTop() + $(".ProductViewer").height() + 130; 														// (VPB = View Port Bottom) Calculates the position of the bottom of the users browser viewport on the document
        var FTB = $(".FooterPromotions").position().top; 			 																	// (FTB = Footer Toolbar Bottom) Calculates the position of the bottom of the footer toolbar, when not fixed and in document flow
        if (PVB < FTB) {																												// If the View Port Bottom Position is less than the normal position of the bottom of the footer toolbar when it's in the document flow (ie the toolbar would be out of view) then
            if (parseInt($(".PageHeader").height()) == 48 && $(document).scrollTop() >= 32) {
                pinProductViewer()																											// Pin the Footer Toolbar to the bottom of the browser chrome
            } else {
                releaseProductViewer();
            }
        } else {																														// Otherwise (ie the toolbar would be fully in view
            releaseProductViewer("Bottom"); 																										// Unpin the toolbar from the browser chrome, and drop it back in to the document flow.
        }
    }
}

function pinProductViewer() {
    /*
    if ($(".ProductViewer").hasClass("Top")) {
    $(".ProductViewer").removeClass("Top");
    }																										
    */
    if ($(".ProductViewer").hasClass("Bottom")) {
        $(".ProductViewer").removeClass("Bottom");
    }
    if (!$(".ProductViewer").hasClass("Fixed")) {
        $(".ProductViewer").addClass("Fixed");
    } else {
        $(".ProductViewer").removeAttr("style");
    }
}

function releaseProductViewer(className) {
    /*
    if ($(".ProductViewer").hasClass("Top")) {
    $(".ProductViewer").removeClass("Top");
    }																										
    */
    if ($(".ProductViewer").hasClass("Fixed")) {
        $(".ProductViewer").removeClass("Fixed");
    }

    if (className == "Bottom" && !$(".ProductViewer").hasClass("Bottom")) {
        $(".ProductViewer").addClass("Bottom");
    }
    $(".ProductViewer").removeAttr("style");
}

/* - Page / Data Handlers ----------------------------------------------------------------------------------------------------------------------------------------------------------*/

function LoadHTMLFragment(Path, Parameters, TargetElement) {
  //  alert("Remove This Call!");
    $.get(Path, Parameters, function (data) { document.getElementById(TargetElement).innerHTML = data; });
}

// Method:      LoadHTMLContent
// Description: This is the main method called by pages when a link is clicked
//              It will check whether the link is the current page, whether another page is already loading and also whether the browser can use the HTML5 History Object (Pushstate)
//              If it passes these checks then it will load the respective data and kick off a transition
// Params:
//              Path:               [REQUIRED] String - The URL of the content to be loaded - e.g. '/women'
//              Title:              [OPTIONAL] String - The title of the conent to be loaded (used for history object) - e.g. 'Next.co.uk - Women'
//              Transition:         [OPTIONAL] String - This will override the default transition UP/DOWN/LEFT/RIGHT - e.g. 'RIGHT'
//              AddToHistory:       [OPTIONAL] Boolean - This will determine whether the history stack needs to be updated - e.g. true
//              ScrollPoint:        [OPTIONAL] Integer - This will scroll the document to the specified point after loading - e.g. 0
//              DocState:           [OPTIONAL] JSON - This is an object that contains querystring params that are specific to the page. These will be appended to the path and used on page load. If a variable name begins with 'hidden', it will not be appended to the path and the hashtag variable is reserved & placed at the end of the querystring - e.g. { spreadview: true, hiddenSearchbreadcrumb: '<div>secret</div>', hashtag: '123456x50' }
//              FormData:           [OPTIONAL] JSON - If form data (page params) needs to be sent with the $.get request, it can be specified here - e.g. { w: 'dress' }
//              CompletionCallback: [OPTIONAL] Function - Once the transition is complete, this method will be called - e.g. function() { ConsoleLog('Page has loaded...'); }

function LoadHTMLContent(Path, Title, Transition, AddToHistory, ScrollPoint, DocState, FormData, CompletionCallback) {
   
    var $ = jQuery;
    var allowTransition = true;

    // Check whether the parent of the DOM element that called this has a class "Inactive"
    // This is mainly for Mouse Ears, where the user is on the last Spread in a Department and they select the Right Mouse Ear to load up a malformed sread page
    if ((this.event != undefined) && this.event.srcElement && this.event.srcElement.parentNode && this.event.srcElement.parentNode.parentNode) {
        var srcWrapper = this.event.srcElement.parentNode.parentNode;
        if ($(srcWrapper).hasClass("Inactive")) {
            return false;
        }
    }

    //This ensures, no matter what happens, we don't lock the UI for more than 2 seconds
    //In theory this wont be needed but acts as a fallback should something go wrong
    var newRquest = new Date().getTime(); 
    if (lastRequest != null) {
        if((newRquest - lastRequest) > 2000){
          isPageTransitioning = false;
      }
    }
    lastRequest = newRquest;

    //$("section.BreadcrumbNavigation div.Content a.ContinueShopping").remove(); // this will remove 'continue shopping' link from all other pages - Raj

    //Check if we're loading an external URL - external URLs should be loaded in a new window
    if (Path.indexOf(location.hostname) == -1 && Path.indexOf("http://") == 0) {
        window.open(Path, "_blank");
        return false;
    }
    
    //If page is transitioning, ignore request
    if (isPageTransitioning || isDragging) {
        return false;
    }

    //This is for browsers that support pushState - if the user loads a page by manipulating the url or clicks on a standard link with no onclick event
    //the browser will fully load the requested page. If the user then hits the back button the loadHTML content will fire at the same time as a full refresh,
    //effectively requesting the same content twice. This stops a transition happening on the same page AFTER the content has loaded.
    //Previously, this only comapred the Path element, but it has been modified to compare the full url as it was causing issues on the search page when consecutive searches were made
    var newUrl = new UrlHelper(Path);
    var currUrl = new UrlHelper(PageURLInput);

    if (newUrl.ServerUrl() == currUrl.ServerUrl()) {
        isPageTransitioning = false;
        return false;
    }

    $("section.BreadcrumbNavigation div.Content a.ContinueShopping").remove(); // this will remove 'continue shopping' link from all other pages - Raj

    // If we are on an error page, then we should not transition to the next page as the DOM may be in a bad state
    if (window.location.pathname.indexOf('error') > -1) {
        allowTransition = false;
    }

    // Temporary solution to force lipsy homepage to be loaded without transitions - this is required until the storefronts are moved into the MVC architechure
    if ((newUrl.Path() == '/lipsy') || (newUrl.Path() == 'lipsy/index.html')) {
        allowTransition = false;
    }

    // Check if the DocState was passed in and make it blank if it wasn't
    if (typeof DocState === "undefined") {
        DocState = {};
    }

    //Check we're not passing in the full URL the same as current location
    if (location.href == Path && !PagePopped) {
        isPageTransitioning = false;
        return false;
    }

    globalPageReferrer = globalPageLocation;
    globalPageLocation = Path;

    // Disable all transitions except spread to grid and grid to spread.
    if (Transition != 'SPREADTOGRID' && Transition != 'GRIDTOSPREAD') {
        allowTransition = false;
    }

    /* ASP pages do not contain ContentArea, so transitions cannot be used for them. */
    if (allowTransition && typeof window.history.pushState != "undefined" && document.getElementById("ContentArea") != null) {

        //Clean up path - remove http://domain
        var siteURL = window.location.protocol + "//" + window.location.host;
        Path = Path.replace(siteURL, '');

        //Kill hero carousel from home page if it still exists
        if (typeof cInterval != "undefined") {
            try {
                clearInterval(cInterval);
                cInterval = null;
            } catch (ex) { }
        }
    
        //Kill any current async page requests.
        //The only time this can happen is if the user has clicked a link again before the previous xhr request has completed
        //As soon as the xhr succeeds we will be transitioning the page so this wont apply.
        //This just allows the user the click something else if the request is taking too long
        if (xhr != null) {
            xhr.abort();
            xhr = null;
        }

        //Store outgoing page's resource array (jscript and css) so we can remove them from header when transition is complete
        PreviousPageResources = DynamicResources;
        DynamicResources = new Array();
        var backTransition;
        var forwardTransition = Transition;
        var currentPageURL = window.location.pathname;

        var addToHistory = true;
        if (AddToHistory == false) {
            addToHistory = false;
            currentPageURL = PageURLInput;
            //currentPageURL = Path;
            //ConsoleLog(PageURLInput);
        }
        
        // Figure out what transition we need to use
        var currentHContext = getHTransitionContext(currentPageURL);

        var currentVContext = getVTransitionContext(currentPageURL);
        var newHContext = getHTransitionContext(Path);
        var newVContext = getVTransitionContext(Path);
        var productPageURLPattern = /^\/[xgXG](l)?(L)?\d{2}\d+[sS]\d+$/gi;

        var productPageTransition = false;
        if (currentPageURL.search(productPageURLPattern) != -1 || Path.search(productPageURLPattern) != -1) {
            productPageTransition = true;
        }

        if (Transition == null || Transition == "") {
            if (Path == "index.html") {																									// Homepage Handler
                forwardTransition = "DOWN"; 																					// Moving to the homepage is always a DOWN
            } else {
                if (currentHContext == -1) {																					// Currently on a root level page (ie homepage), all transitions are UP
                    if (currentPageURL.search(productPageURLPattern) != -1) {
                        forwardTransition = "DOWN";
                    } else {
                    if (newVContext < currentVContext) {
                        forwardTransition = "DOWN";
                    } else if (newVContext > currentVContext) {
                        forwardTransition = "UP";
                    } else {
                        forwardTransition = "LEFT";
                    }
                        //If next page is a product page, regardless of where we are, animate up
                        if (Path.search(productPageURLPattern) != -1) {
                            forwardTransition = "UP";
                        }
                    }
                } else if (currentHContext > newHContext) {																		// Changing Department RIGHT
                    if (Path.search(productPageURLPattern) != -1) {
                        forwardTransition = "UP";
                    } else {
                        forwardTransition = "RIGHT";
                    }
                } else if (currentHContext < newHContext) {																		// Changing Department LEFT
                    forwardTransition = "LEFT";
                } else if (currentHContext == newHContext) {																	// Within the same Department
                    if (currentVContext > newVContext) {																		// Current Vertical Context is higher in Context Tree than New Vertical Context
                        forwardTransition = "DOWN";
                    } else if (currentVContext < newVContext) {																	// Current Vertical Context is lower in Context Tree than New Vertical Context
                        forwardTransition = "UP";
                    } else if (currentVContext == newVContext) {																// Current Vertical Context is same as New Vertical Context (Maybe a different horizontal context)
                        //forwardTransition = "UP";
                        return false; 																							// At the same vertical Context Level - Should be horizontal transition?
                    }
                }
            }
        }

        //If we're moving between departments
        if (Path != "/" & !productPageTransition) {
        var curDept = currentPageURL.split('index.html')[1];
        var newDept = Path.split('index.html')[1];

            if ((newDept != "" && curDept != "") &&    newDept != curDept) {

                var currentDeptLink = $("ul.PrimaryNavigation a[href='" + siteURL + "/" + curDept + "']");
                var newDeptLink = $("ul.PrimaryNavigation a[href='" + siteURL + "/"  + newDept + "']");

                if ($(currentDeptLink).parent().index() > $(newDeptLink).parent().index()) {

                    forwardTransition = "RIGHT";
                } else {
                    forwardTransition = "LEFT";
                }
               
            }
        }

        //Shopping bag
        if (Path.toLowerCase() == "/shoppingbag") {
            forwardTransition = "UP";
        }
        if (currentPageURL.toLowerCase() == "/shoppingbag") {
            forwardTransition = "DOWN";
        }

        // Build up the request and get the content from the server
        if (Path != currentPageURL || addToHistory == false) {
            // We are about to build up the request path, but we need to get rid of the hash temporarily so we can append some querystring params
            // If we don't do this then we will end up with a malformed request and this causes issues when we go from a redirected product page with hashtag to a spread view and back again
            var hashSplit = Path.split('#');
            var reqPath = hashSplit[0];

            // Add contentonly=true so that we are not pulling back the header and footer
            if (reqPath.toLowerCase().indexOf("?") >= 0)
                reqPath += '&';
            else
                reqPath += '?';
            reqPath += "contentonly=true";

            // Build up a docstate string that we can append to the Url
            var docStateString = getDocStateString(DocState);

            // Add the docstate string
            if (docStateString !== '') {
                if (docStateString.charAt(0) === '?')
                    reqPath += docStateString.replace('?', '&');
                else if (docStateString.charAt(0) === '&' || docStateString.charAt(0) === '#')
                    reqPath += docStateString;
                else
                    reqPath += '&' + docStateString;
            }

            // If the original path already had a hash on it, add it back on
            if (hashSplit.length > 1) {
                // If the getDocStateString brought back a hashtag, then replace it with the original
                if (reqPath.indexOf('#') > -1) {
                    reqPath = reqPath.substring(0, reqPath.indexOf('#'));
                }
                reqPath += '#' + hashSplit[1];
            }

            // Get the form data defined if it isn't
            var formData = ""
            if (typeof FormData != "undefined" && FormData != null) {
                formData = FormData;
            }

            // Send the request
            xhr = $.ajax({
                type: "GET",
                url: reqPath,
                timeout: 5000,
                data: formData,
                success: function (data, textStatus, jqXHR) { // 200 (and non cross domain 301 redirects)
                	checkAndRedirectForAjaxError(jqXHR, false, 'AJAXv1.js: LoadHTMLContent');
                    if (jqXHR.getResponseHeader('X-RequestUrl') != null) {
                        // We cannot detect whether there was a redirect (e.g. 301) as the browser handles this and gets the redirect content before bubbling anything back up to the JavaScript
                        // So lets check if our custom header with the requested url on the actual server matches the url that we sent in the initial request
                        try {
                            var serverRequestUrl = jqXHR.getResponseHeader('X-RequestUrl');
                            var clientUrl = new UrlHelper(reqPath);
                            var serverUrl = new UrlHelper(serverRequestUrl);
                            if (clientUrl.ServerUrl() !== serverUrl.ServerUrl()) {
                                // If they are different, reload the page with the original URL so that we are redirected with a hashtag
                                window.location = Path;
                                return false;
                            }
                        }
                        catch (exp) {
                            // Let it carry on and transition
                        }
                    }

                    TransitionHandler("success", data, forwardTransition, Path, addToHistory, ScrollPoint, DocState, CompletionCallback);
                },
                error: function (data) { // 404 etc (and cross domain 301 redirects which are handled in the TransitionHandler)
                    TransitionHandler("error", data, forwardTransition, Path, addToHistory, ScrollPoint, DocState, CompletionCallback);
                }
            });
        }
        return false;
    } else {
        //Browser doesn't support pushstate, load page the 'traditional' way.
        isPageTransitioning = false;

        // Add leading slash to path if required (bug in ie means this is not included).
        if ($.browser.msie && Path.substr(0,4) != ('http') && Path.charAt(0) != 'index.html') {
            Path = "/" + Path;
        }

        //Check if there's a hash param in the docstate
        if (DocState['hashtag'] !== undefined && DocState['hashtag'] !== null) {
            window.location = Path + '#' + DocState['hashtag'];
        } else { 
            window.location = Path;
        }
        return false;
    }
}

function TransitionHandler(type, data, forwardTransition, Path, addToHistory, ScrollPoint, DocState, CompletionCallback) {
    var $ = jQuery;
    //Could change animation interval here
    //The default is 13 - giving a smooth, approx 75 fps
    //But - this might kill some browsers. By increasing the interval between 'frames' we decrease the fps 
    //potentially improving performance but a less smooth transition.
    //Setting the interval to 40 gives an approximate fps of 24 - shouldn't really go any lower than that.
    //jQuery.fx.interval = 20;

    //No need to track users aborting the rerquest,
    //Just cancel
    if (data.statusText == "abort") {
        isPageTransitioning = false;
        xhr = null;
        return false;
    }

    //Set the transition lock before we bind anything to the page as scripts contained in the incoming data
   //may need to fire after the transtion finishes - this prevents those scripts firing until we want them to
    isPageTransitioning = true;
    var Title
    Path = Path.toLowerCase();

    switch (type) {
        case "success":
            TrackGAPageView(Path);
            $(".NextContent").html(data);
            xhr = null;
            break;
        case "error":
            var StatusCode = "" + data.status
            var Details = "";

            if (data.statusText == "timeout") {
                StatusCode = "408";
            }

            switch (StatusCode) {
                case "404":
                    StatusCode += " - File Not Found"
                    Details = "Referrer: " + window.location.href;
                    break;
                case "408":
                    TrackGAEvent(StatusCode + " - " + data.statusText, Path, Details, 0);
                    xhr.abort();
                    xhr = null;
                    isPageTransitioning = false;
                    return false;
                    break;
                case "500":
                    Details = data.responseText
                    break;
            }

            TrackGAEvent(StatusCode + " - " + data.statusText, Path, Details, 0);

            if (data.responseText != "") {
                $(".NextContent").html(data.responseText);
            } else {
                // If we hit any cross domain redirect issues or the request is malformed, then we need to reload the page
                // We catch this instance with the status code 0. 
                // The browser will make the initial request, get a 301, try to get the redirect url and hit a permission denyed if it is cross domain, then it will return a 0 instead of a 301
                if (data.status === 0)
                    window.location = Path;
                return false;
            }
            break;
    }



    //Check if we are currently on a spread page and the user has navigated to a spread in the same dept
    //If so, we need to trigger the spread animation instead
    if ($(".CurrentContent .SpreadsPage").length && $(".NextContent .SpreadsPage").length) {

        var nextSpread = $(".NextContent .Spread");
        var nextDept = $(".NextContent .SpreadsPage #hdnDeptName").val();
        var curDept = $(".CurrentContent .SpreadsPage #hdnDeptName").val();
        var nextPage = $(".NextContent .SpreadsPage .ImageLayer").attr("data-page");
        var nextBook = $(".NextContent .SpreadsPage .ImageLayer").attr("data-book");
        var nextOccurrence = $(".NextContent .SpreadsPage .ImageLayer").attr("data-occurrence");

      $(".NextContent").html("");
        //If we're in the same dept
      if (nextDept == curDept) {
      //Target the item in the current carousel we need to click to load incoming spread
            var targetCarouselLI = $(".CurrentContent .SpreadsPage li[data-page='" + nextPage + "'][data-book='" + nextBook + "'][data-occurrence='" + nextOccurrence + "']");
            $(targetCarouselLI).find("a").first().click();
            //Scroll carousel to display selected carousel item
            scrollThumbNailBar($(targetCarouselLI).offset().left, targetCarouselLI, true);
            
        } else {
            //Else - we're navigating between spread pages of different departments
            //Load the new spread carousel
            LoadSpreadCarousel(nextDept);
            //Update attributes on current spread - this allows us to target the correct carousel item once the carousel has loaded
            $(".ImageLayer").attr("data-page", nextPage);
            $(".ImageLayer").attr("data-book", nextBook);
            $(".ImageLayer").attr("data-occurrence", nextOccurrence);
            $(".ImageLayer").attr("data-reloadContent", true);
            $(".CurrentContent .SpreadsPage #hdnDeptName").val(nextDept);
            initPage();

        }
        //Return false here as we've passed transitioning over to the spread transition handler (via a carousel click).
        return false;
    }

    //Update breadcrumb/SEO
    if ($(".NextContent #PageParams").length) {
        var BCHTML = $(".NextContent #PageParams #BreadcrumbWrapper").html();
        if (BCHTML.length) {
            UpdateBreadcrumbTrail(BCHTML);
        }

       var seoTitle =  $(".NextContent #PageParams #seoTitle").val();
       var seoDescription = $(".NextContent #PageParams #seoDescription").val();
       var seoKeywords = $(".NextContent #PageParams #seoKeywords").val();
       var seoRobots = $(".NextContent #PageParams #seoRobots").val();
       var seoCanonical = $(".NextContent #PageParams #seoCanonical").val();

       updateSeo(seoTitle, seoDescription, seoKeywords, seoRobots, seoCanonical);
    
        //Remove page params from page
        $(".NextContent #PageParams").remove();

    }

    if (addToHistory && !preventReplaceState) {																											// If we're navigating the site rather than clicking back or forward
        window.history.replaceState({ "url": window.location.href, "DocState": documentState, "title": document.title, "scrollPoint": $(window).scrollTop() }, document.title, window.location.href); 			// On load, attempt to replace the last state object on the history stack with one that is populated with the relevent transition data (although in all likely hood this will just insert a new item)
    }

    var Animation = createAnimation()

    var siteURL = window.location.protocol + "//" + window.location.host;
    var relPath = Path.replace(siteURL, '');

    if (relPath == "index.html") {
        $(".PageHeader").addClass("home");
        if ($(".PageHeader").hasClass("Large")) {
            addToAnimation(Animation, '$("footer.ToolBar").animate({bottom: -50}, 1000);', 0, false);
            addToAnimation(Animation, '$("#SpreadsGridTitle").fadeOut(350);', 0, false);
            addToAnimation(Animation, '$(".PageHeader .BreadcrumbNavigation").fadeOut(350);', 350, true);
            //addToAnimation(Animation, '$(".HeaderSpacer").animate({ "height": "-=' + $(".BreadcrumbNavigation").height() + 'px" }, 250);', 250, true);
            addToAnimation(Animation, '$(".PageHeader").removeClass("Large")', 0, false);
            //addToAnimation(Animation, '$(".HeaderSpacer").removeClass("Large")', 0, false);
            //addToAnimation(Animation, '$(".HeaderSpacer").removeAttr("style")', 0, false);
        }
    } else {
        $(".PageHeader").removeClass("home");
        if (!$(".PageHeader").hasClass("Large")) {
            addToAnimation(Animation, '$("footer.ToolBar").animate({bottom: 0}, 1000);', 0, false);
            addToAnimation(Animation, '$(".PageHeader").addClass("Large")', 0, false);
            //addToAnimation(Animation, '$(".HeaderSpacer").animate({ "height": "+=' + $(".BreadcrumbNavigation").height() + 'px" }, 250);', 250, true);
            //addToAnimation(Animation, '$(".HeaderSpacer").addClass("Large")', 0, false);
            //addToAnimation(Animation, '$(".HeaderSpacer").removeAttr("style")', 0, false);
            addToAnimation(Animation, '$(".PageHeader .BreadcrumbNavigation").fadeIn(650);', 150, true);
        }
    }



    addToAnimation(Animation, 'PageTransition' + forwardTransition + '(' + ScrollPoint + ')', 0, false);
    if (typeof CompletionCallback != "undefined")
        addToAnimation(Animation, CompletionCallback, 0, true);  


    runAnimation(Animation);

    //If hash value was passed, add this to path
    if (DocState['hashtag'] !== undefined && DocState['hashtag'] !== null) {
        Path += '#' + DocState['hashtag'];
    }

    //eval("PageTransition" + forwardTransition + "(" + ScrollPoint + ")");
    if (addToHistory) {
        var historyObject
        //if (Transition == null || Transition == "") {
        historyObject = { "url": Path, "title": Title, "DocState": DocState, "scrollPoint": ScrollPoint }
        //} else {
        //    historyObject = { "url": Path, "title": Title, "transition": Transition }
        //}
        window.history.pushState(historyObject, Title, Path);
    }
    //document.title = Title;
    PageURLInput = Path;
    preventReplaceState = false;
  
}

function LoadSpread(Path, Title, Transition, AddToHistory, ScrollPoint, DocState) {
    
  




    var $ = jQuery;

    // Check whether the parent of the DOM element that called this has a class "Inactive"
    // This is mainly for Mouse Ears, where the user is on the last Spread in a Department and they select the Right Mouse Ear to load up a malformed sread page
    if ((this.event != undefined) && this.event.srcElement && this.event.srcElement.parentNode && this.event.srcElement.parentNode.parentNode) {
        var srcWrapper = this.event.srcElement.parentNode.parentNode;
        if ($(srcWrapper).hasClass("Inactive")) {
            return false;
        }
    }

    // If there is a hash at the end of the Url, strip it off
    if (Path.indexOf('#', Path.length - 1) !== -1) {
        Path = Path.substring(0, Path.length - 1)
    }

    //Check we're not passing in the full URL the same as current location
    if (location.href == Path && !PagePopped) {
        return false;
    }

    // This prevents the spread from being loaded twice when Chrome incorrectly fires onpopstate on page load.
    var newUrl = new UrlHelper(Path);
    var currUrl = new UrlHelper(PageURLInput);
    if (newUrl.ServerUrl() == currUrl.ServerUrl()) {
        return false;
    }
    
    if (typeof window.history.pushState != "undefined") {

        //Prevents spread locking completely
        var newRquest = new Date().getTime();
        if (lastRequest != null) {
            if ((newRquest - lastRequest) > 1500) {
                isSpreadTransitioning = false;
            }
        }
        lastRequest = newRquest;


        //Prevent using building up a stack of clicks/transtions
        if (isSpreadTransitioning) {
            return false;
        }
        //Set isSpreadTransitioning to true - indicates we're in a spread transition
        isSpreadTransitioning = true;

        var currentPageURL = window.location.pathname;
        var siteURL = window.location.protocol + "//" + window.location.host;

        Path = Path.replace(siteURL, '');
        //If we're moving between departments
            var curDept = currentPageURL.split('index.html')[1];
            var newDept = Path.split('index.html')[1];
  
            if (newDept != curDept) {
                ConsoleLog(newDept);
                ConsoleLog(curDept);
                var currentDeptLink = $("ul.PrimaryNavigation a[href='" + siteURL + "/" + curDept + "']");
                var newDeptLink = $("ul.PrimaryNavigation a[href='" + siteURL + "/" + newDept + "']");

                if ($(currentDeptLink).parent().index() > $(newDeptLink).parent().index()) {

                    Transition = "RIGHT";
                } else {
                    Transition = "LEFT";
                }

            }
 

        if (PageTransitionLock == false) {
            PageTransitionLock = true;
            var backTransition;
            var forwardTransition = Transition;
            
            var addToHistory = true;
            if (AddToHistory == false) {
                addToHistory = false;
                currentPageURL = PageURLInput;
            }

            // Check if the DocState was passed in and make it blank if it wasn't
            if (typeof DocState === "undefined") {
                DocState = {};
            }

            if (Path != currentPageURL || addToHistory == false) {
                // Add contentonly=true so that we are not pulling back the header and footer
                var reqPath = Path;
                if (reqPath.toLowerCase().indexOf("?") >= 0)
                    reqPath += '&';
                else
                    reqPath += '?';
                reqPath += "contentonly=true&spreadonly=true";

                // Build up a docstate string that we can append to the Url
                var docStateString = getDocStateString(DocState);

                // Add the docstate string
                if (docStateString !== '') {
                    if (docStateString.charAt(0) === '?')
                        reqPath += docStateString.replace('?', '&');
                    else if (docStateString.charAt(0) === '&' || docStateString.charAt(0) === '#')
                        reqPath += docStateString;
                    else
                        reqPath += '&' + docStateString;
                }

                var request = $.get(reqPath);
                request.success(function (data) {

                    Path = Path.toLowerCase();
                    TrackGAPageView(Path);

                    $(".NextSpread").html(data);

                    //Update breadcrumb/SEO
                    if ($(".NextSpread #PageParams").length) {
                        var BCHTML = $(".NextSpread #PageParams #BreadcrumbWrapper").html();
                        if (BCHTML.length) {
                            UpdateBreadcrumbTrail(BCHTML);
                        }


                        var seoTitle = $(".NextSpread #PageParams #seoTitle").val();
                        var seoDescription = $(".NextSpread #PageParams #seoDescription").val();
                        var seoKeywords = $(".NextSpread #PageParams #seoKeywords").val();
                        var seoRobots = $(".NextSpread #PageParams #seoRobots").val();
                        var seoCanonical = $(".NextSpread #PageParams #seoCanonical").val();

                        updateSeo(seoTitle, seoDescription, seoKeywords, seoRobots, seoCanonical);


                        //Remove page params from page
                        $(".NextSpread #PageParams").remove();

                    }

                    if (addToHistory) {																										// If we're navigating the site rather than clicking back or forward
                        window.history.replaceState({ "url": window.location.href, "spreadView": true, "DocState": documentState, "title": document.title, "scrollPoint": $(window).scrollTop() }, document.title, window.location.href); 			// On load, attempt to replace the last state object on the history stack with one that is populated with the relevent transition data (although in all likely hood this will just insert a new item)
                        //ConsoleLog(documentState);
                    }

                    if (Title == '')
                        Title = seoTitle;

                    eval("SpreadTransition" + forwardTransition + "()");
                    if (addToHistory) {
                        var historyObject
                        if (Transition == null || Transition == "") {
                            historyObject = { "url": Path, "title": Title, "spreadView": true, "DocState": DocState, "scrollPoint": ScrollPoint }
                        } else {
                            historyObject = { "url": Path, "title": Title, "transition": Transition, "spreadView": true, "DocState": DocState, "scrollPoint": ScrollPoint }
                        }
                        window.history.pushState(historyObject, Title, Path);
                    }
                    document.title = Title;
                    PageURLInput = Path;

                    UpdateContinueShopping(Path)
                });
                request.error(function (data) { // 404, 500 Response => To Error Page
                    isSpreadTransitioning = false;
                    PageTransitionLock = false;
                    TransitionHandler("error", data, forwardTransition, Path, addToHistory, ScrollPoint, DocState);
                });
            } else {
                isSpreadTransitioning = false;
                PageTransitionLock = false;
            }
        }
        return false;
    } else {

        var siteURL = window.location.protocol + "//" + window.location.host;

        Path = Path.replace(siteURL, '');

        window.location.pathname = Path;
    }
}


/* - Transition Handlers / Definitions ---------------------------------------------------------------------------------------------------------------------------------------------*/


/* Available easings ----------------------------------------------------
linea, swing, jswing, easeInQuad, easeOutQuad, easeInOutQuad, easeInCubic, 
easeOutCubic, easeInOutCubic, easeInQuart, easeOutQuart, easeInOutQuart, 
easeInQuint, easeOutQuint, easeInOutQuint, easeInSine, easeOutSine, easeInOutSine, 
easeInExpo, easeOutExpo, easeInOutExpo, easeInCirc, easeOutCirc, easeInOutCirc, 
easeInElastic, easeOutElastic, easeInOutElastic, easeInBack, easeOutBack, easeInOutBack, 
easeInBounce, easeOutBounce, easeInOutBounce
*/


var pageTransitionSpeed = 800;
var leftRightTransitionSpeed = 900;
var pageTransitionEasing = 'easeOutCirc';
var pageTransitionEasingIn = 'easeInQuint';
var fadeContent = false;

//TODO - Need to decide whether fading next content in is required
//In chrome it can give the appearance of a smoother transition, firefox maybe not 
//if ($.browser.mozilla == true) {
//    fadeContent = false;
// 
//}

//Set page up correctly for any transition
function PreparePageForTransition() {
    var $ = jQuery;
    $(window).scrollTop(0);

    if (fadeContent) {
        $(".NextContent").css("position", "absolute").css("opacity", "0").css("display", "block");
    } else {
    $(".NextContent").css("position", "absolute").css("display", "block");
    }
    $("#ContentArea").removeAttr("style").removeClass("HideOverflow");

    if (!$(".ProductImagery").hasClass("PinBottom")) {
        $(".ProductImagery").css("position", "static").css("margin-top", 0);
    } else {
        $(".ProductImagery").removeClass("PinBottom").addClass("Static");
    }

    var newContentHeight = $(".NextContent").height();
    var ViewportHeight = $(window).height();

    $(".NextContent").height(ViewportHeight);
 
}

function PageTransitionGRIDTOSPREAD(scrollPoint) {
    var $ = jQuery;
    PreparePageForTransition();

    var targetLink = $("a.selectedGrid");
    //var targetImg = $(targetLink).find("img").clone();
    var targetImg = $(".NextContent .ImageLayer").find("img").clone();
    $(".NextContent .ImageLayer").find("img").css("opacity", 0);
    var targetOffset = $(".SpreadGridSection").offset();

    var tLinkOffset = $(targetLink).offset();
    //var animateElemnt = $("<div style=\"background-color:#23978E;\">.</div>");
    //var animateElemnt = $("<div style=\"border: 3px solid #23978E;\">.</div>");
    var animateElemnt = targetImg;


    $(".CurrentContent").animate({ opacity: 0 }, 700);

    $(animateElemnt).css("position", "absolute")
   .css("top", tLinkOffset.top + 3)
   .css("left", tLinkOffset.left + 3)
   .width(304)
   .height(129).css("border","none").css("margin","").css("z-index","1000");

    $(".NextContent").after(animateElemnt);

    $(animateElemnt).animate({
        height: 411,
        width: 964,
        top: 127,
        left: targetOffset.left + 6
    }, 800, "easeOutExpo", function () {});

    $(".NextContent").css("top", 0).css("left", 0).css("opacity", 0);

    setTimeout(function(){
                        $(".NextContent").animate({ opacity: 1 }, 600, pageTransitionEasing, function () {
                            $(".NextContent .ImageLayer").find("img").css("opacity", 1);
                            $(animateElemnt).remove()
                            PageTransitionTidy();

                        });
    }, 200)

}

function PageTransitionSPREADTOGRID(scrollPoint) {
    var $ = jQuery;
    PreparePageForTransition();
    $(".NextContent").css("top", 0).css("left", 0).css("opacity", 0);

    var srcPage = $(".CurrentContent .ImageLayer").attr("data-page");
    var srcImg = $(".CurrentContent .ImageLayer").find("img").clone();
    var targetImg = $(".NextContent img[data-page='" + srcPage + "']");

    var targetParent = $(targetImg).parent();
    $(targetParent).addClass("StorySelected");

    var srcOffset = $(".CurrentContent .ImageLayer").find("img").offset();

    var targetIndex = $(targetImg).attr("data-index");
    var targetRow = Math.ceil(targetIndex / 3);
    var targetCol = (targetIndex / 3) - (targetRow - 1);
    var targetParentOffset = $(".NextContent .SpreadGridSection").offset();

    var targetTop = targetParentOffset.top + (141 * (targetRow - 1)) + 11;
    var targetLeft = targetParentOffset.left + (969 * (targetCol - (1 / 3))) + 13;


//    if ($.browser.mozilla == true) {
//        targetTop = $(targetImg).offset().top;
//    }


    $(".NextContent").after(srcImg);
    $(srcImg).css("position", "absolute")
    $(srcImg).offset({ left: srcOffset.left, top: srcOffset.top });

    $(".CurrentContent").animate({ opacity: 0 }, 200, function () {
        $(srcImg).animate({
            top: targetTop,
            left: targetLeft,
            width: 302,
            height: 126
        }, 600, "easeOutExpo");

        //        $(".NextContent").animate({ scrollTop: $(".StorySelected").offset().top }, function () {
        //            $(".NextContent").animate({ opacity: 1 }, 6000, "easeInExpo", function () {
        //                PageTransitionTidy();
        //                $(srcImg).remove();
        //            });
        //        });

        $(".NextContent").animate({ opacity: 1 }, 600, "easeInExpo", function () {
            PageTransitionTidy();
            $(srcImg).remove();
            $("html,body").animate({ scrollTop: $(".StorySelected").offset().top - 198 }, 200);
        });
    });
}

function PageTransitionGRIDLEFT(scrollPoint) {
    var $ = jQuery;
    PreparePageForTransition();
    var ViewportHeight = $(window).height();
    $(".NextContent").css("top", 0).css("left", 0).css("opacity", 1).css("background-color", "transparent");
    $(".NextContent .SpreadsGridTitle").css("opacity", 0);

    $(".NextContent .SpreadGridSection").height(ViewportHeight).css("background-color", "#fff"); ;

    $(".NextContent .SpreadGridSection").offset({ left: $(".NextContent .SpreadGridSection").offset().left + 970 });
    $(".NextContent .SpreadGridSection").animate({
        left: "-=" + 970
    }, 900, "easeOutExpo", function () {
        $(".NextContent .SpreadGridSection").css("height", "");
        PageTransitionTidy();

    });

//    $(".CurrentContent .SpreadGridSection").animate({
//        left: "-=" + 970
//    }, 700, "easeOutExpo");

    $(".NextContent .SpreadsGridTitle").animate({opacity: 1}, 700);
    $(".CurrentContent .SpreadsGridTitle").animate({ opacity: 0 }, 700);


}


function PageTransitionGRIDRIGHT(scrollPoint) {
    var $ = jQuery;
    PreparePageForTransition();
    var ViewportHeight = $(window).height();
    $(".NextContent").css("top", 0).css("left", 0).css("opacity", 1).css("background-color", "transparent").css("z-index",100);
    $(".NextContent .SpreadsGridTitle").css("opacity", 0);
    $(".NextContent .SpreadGridSection").offset({ left: $(".NextContent .SpreadGridSection").offset().left});



    $(".CurrentContent .SpreadGridSection").css("background-color", "#fff").css("z-index",101).css("height",ViewportHeight);

//    $(".NextContent .SpreadGridSection").animate({
//        left: "+=" + 970
//    }, 700, "easeOutExpo");

    $(".CurrentContent .SpreadGridSection").animate({
        left: "+=" + 970
    }, 900, pageTransitionEasingIn, function () {
        PageTransitionTidy();
        ScrollToPoint(scrollPoint);
    });

    $(".NextContent .SpreadsGridTitle").animate({ opacity: 1 }, 700);
    $(".CurrentContent .SpreadsGridTitle").animate({ opacity: 0 }, 700);

}

function PageTransitionUP(scrollPoint) {
    var $ = jQuery;
    PreparePageForTransition();
    var ViewportHeight = $(window).height();
    var HeaderHeight = $(".PageHeader").height();
    $(".NextContent").css("top", ViewportHeight).css("left", "0px");
    var animateJSON;

    if (fadeContent) {
        animateJSON = {
            top: "-=" + ViewportHeight,
            opacity: 1
        };
    } else {
        animateJSON = {
            top: "-=" + ViewportHeight
        };

    }

    $(".NextContent").animate(animateJSON, pageTransitionSpeed, pageTransitionEasing, function () {
        PageTransitionTidy();
        ScrollToPoint(scrollPoint);
    });
}

function PageTransitionDOWN(scrollPoint) {
    var $ = jQuery;
    PreparePageForTransition();
    var ViewportHeight = $(window).height();
    var HeaderHeight = $(".PageHeader").height();
    var ContentViewportHeight = ViewportHeight - HeaderHeight;
    var newContentHeight = $(".NextContent").height();
    var newContentPositon = 0 - newContentHeight;

    $(".CurrentContent").css("z-index", "1000")
                        .css("position", "absolute")
                        .css("overflow", "hidden")
                        .height(ViewportHeight);

    $(".NextContent").css("top", "0px")						   
                        .css("left", "0px")
                        .css("opacity", "1");
    var animateJSON;

    if (fadeContent) {
        animateJSON = {
            top: "+=" + ViewportHeight,
            opacity: 0
        };
    } else {
        animateJSON = {
            top: "+=" + ViewportHeight
        };
    }

    $(".CurrentContent").animate(animateJSON, pageTransitionSpeed, pageTransitionEasingIn, function () {
        PageTransitionTidy();
        ScrollToPoint(scrollPoint);
    });
}

//Page transition for going BACK - content transtions to the right, user clicked on LEFT mouse ear
function PageTransitionRIGHT(scrollPoint) {
    var $ = jQuery;
    PinMouseEars();
    PreparePageForTransition();

   

    var tempClip = $("<div />");
    $(tempClip).addClass("tempClip");
    $(tempClip).height($(window).height());
    $(tempClip).append($(".NextContent"));
    $(tempClip).append($(".CurrentContent"));
    $("#ContentArea").append(tempClip);

    $(".NextContent .TitleBar").first().addClass("newTitle");
    $(".CurrentContent .TitleBar").first().addClass("newTitle");

    if ($(".NextContent .TitleBar").length) {
        $(".NextContent .TitleBar").parent().css("margin-top", 48);
    }

    if ($(".CurrentContent .TitleBar").length) {
        $(".CurrentContent .TitleBar").parent().css("margin-top", 48);
    }

    var ViewportHeight = $(window).height();
    var ViewportWidth = $(window).width();
    var HeaderHeight = $(".PageHeader").height();
    var ContentViewportHeight = ViewportHeight - HeaderHeight;
    var newContentHeight = $(".NextContent").height();
    var newContentWidth = $(".NextContent").width();
    var newContentPositon = 0 - 976;
    $(".NextContent").css("left", 0).css("width", 976).css("top", "0px").css("z-index",100);
    $(".CurrentContent").css("left", 0).css("width", 976).css("top", "0px").css("position", "absolute").css("z-index", 101).css("height",ViewportHeight);
    var animateJSON;
    if (fadeContent) {
        animateJSON = {
            left: "+=" + 976,
            opacity: 1
        };
    } else {
        animateJSON = {
            left: "+=" + 976
        };
    }

    //$(".NextContent").animate(animateJSON, pageTransitionSpeed, pageTransitionEasing);

    $(".CurrentContent").animate(animateJSON, leftRightTransitionSpeed, 'easeInCubic', function () {
        var cnt = $(".tempClip").contents()
        $(".tempClip").replaceWith(cnt);

        PageTransitionTidy();
        ScrollToPoint(scrollPoint);

    });

    $(".NextContent .TitleBar").first().animate({ opacity: 1 }, 300);
 
}

function PageTransitionLEFT(scrollPoint) {
    var $ = jQuery;
    PinMouseEars();

    PreparePageForTransition();

    var tempClip = $("<div />");

    $(tempClip).addClass("tempClip");
    $(tempClip).height($(window).height());
    $(tempClip).append($(".NextContent"));
    $(tempClip).append($(".CurrentContent"));
    $("#ContentArea").append(tempClip);
    $(".NextContent .TitleBar").first().addClass("newTitle");
    $(".CurrentContent .TitleBar").first().addClass("newTitle");

    if ($(".NextContent .TitleBar").length) {
        $(".NextContent .TitleBar").parent().css("margin-top", 48);
    }

    if ($(".CurrentContent .TitleBar").length) {
        $(".CurrentContent .TitleBar").parent().css("margin-top", 48);
    }


    $("body").css("overflow-x", "hidden");
    var ViewportHeight = $(window).height();
    var ViewportWidth = $(window).width();
    var HeaderHeight = $(".PageHeader").height();
    var ContentViewportHeight = ViewportHeight - HeaderHeight;
    var newContentHeight = $(".NextContent").height();
    var newContentWidth = $(".NextContent").width();
    var newContentPositon = ViewportWidth;
    $(".NextContent").css("left", 976).css("width", 976).css("top", "0px").css("height", ViewportHeight) ;
    $(".CurrentContent").css("left", 0).css("width", 976).css("top", "0px").css("position", "absolute");

  

    var animateJSON;
    if (fadeContent) {
        animateJSON = {
            left: "-=" + 976,
            opacity: 1
        };
    } else {
        animateJSON = {
            left: "-=" + 976
        };
    }

    $(".NextContent").animate(animateJSON, leftRightTransitionSpeed, pageTransitionEasing, function () {
        var cnt = $(".tempClip").contents()
        $(".tempClip").replaceWith(cnt);

        PageTransitionTidy();
        ScrollToPoint(scrollPoint);
    });

    //$(".CurrentContent").animate(animateJSON, pageTransitionSpeed, pageTransitionEasing);

      $(".NextContent .TitleBar").first().animate({ opacity: 1 }, 300);

}



function PinMouseEars() {

    return false;
    var oldContent = $(".CurrentContent");
    var newContent = $(".NextContent");

    var oldMouseEarLeft = $(".CurrentContent").find(".MouseEar.Left");
    var oldMouseEarRight = $(".CurrentContent").find(".MouseEar.Right");

    var newMouseEarLeft = $(".NextContent").find(".MouseEar.Left");
    var newMouseEarRight = $(".NextContent").find(".MouseEar.Right");

    var omeLPOS = $(oldMouseEarLeft).offset();
    var omeRPOS = $(oldMouseEarRight).offset();

    $(oldMouseEarLeft).css("position", "fixed").css("left", "0px").css("top", omeLPOS.top);
    $(oldMouseEarRight).css("position", "fixed").css("right", "0px").css("top", omeRPOS.top);

    $(newMouseEarLeft).css("position", "fixed").css("left", "0px").css("top", omeLPOS.top).css("opacity", "0");
    $(newMouseEarRight).css("position", "fixed").css("right", "0px").css("top", omeRPOS.top).css("opacity", "0");

    $(oldMouseEarLeft).animate({ opacity: 0 }, 700);
    $(oldMouseEarRight).animate({ opacity: 0 }, 700);

    $(newMouseEarLeft).animate({ opacity: 1 }, 700);
    $(newMouseEarRight).animate({ opacity: 1 }, 700);


}

/////////////Spread transitions

function SpreadTransitionLEFT() {
    var $ = jQuery;
    // Transition Data
    var Animation = createAnimation();
    var ContentViewportWidth = $(".SpreadCarousel").width();
    var currentSpreadOffset = $(".CurrentSpread").offset();
    var targetOffset = currentSpreadOffset.left + ContentViewportWidth;
    var scrolltimer = 400;
    var scrollTop = 0;

    // Transition Set Up				
    $(".NextSpread").offset({ left: currentSpreadOffset.left }).css("z-index", 100);
    $(".CurrentSpread").css("z-index", 101);

    $(".CurrentSpread").animate({ left: "-=" + targetOffset }, 700, 'easeInSine', function () {
        Animation = SpreadTransitionUpdateNavigationAids(Animation)
        Animation = SpreadTransitionClearDown(Animation);
        runAnimation(Animation);
        isSpreadTransitioning = false;
    });

    
}

function SpreadTransitionRIGHT() {
    var $ = jQuery;
    // Transition Data
    var Animation = createAnimation();
    var ContentViewportWidth = $(".SpreadCarousel").width();
    var currentSpreadOffset = $(".CurrentSpread").offset();
    var targetOffset = currentSpreadOffset.left - ContentViewportWidth;
    var scrolltimer = 400;
    var scrollTop = 0;

    // Transition Set Up				
    $(".NextSpread").offset({ left: currentSpreadOffset.left }).css("z-index", 100);
    $(".CurrentSpread").css("z-index", 101);

    $(".CurrentSpread").animate({ left: "+=" + ContentViewportWidth },700, 'easeInSine', function () {
        Animation = SpreadTransitionUpdateNavigationAids(Animation)
        Animation = SpreadTransitionClearDown(Animation);
        runAnimation(Animation);
        isSpreadTransitioning = false;
    });
 
}


function SpreadTransitionUpdateNavigationAids(Animation) {
    var $ = jQuery;
    addToAnimation(Animation, 'ClearMouseEarStates();', 0, true);

    if ($(".BreadcrumbTrail").html() != "") {
       // addToAnimation(Animation, '$(".Breadcrumbs").html($(".NextSpread .BreadcrumbTrail .Breadcrumbs").html())', 0, false);
    }

    if ($(".NextSpread .NextPageURL").val() == "") {
        addToAnimation(Animation, '$(".MouseEar.Right").addClass("Inactive").removeClass("Active");', 0, false);
        addToAnimation(Animation, '$(".MouseEar.Right a")[0].href = "#";', 0, false);
    } else {
        addToAnimation(Animation, '$(".MouseEar.Right").addClass("Active").removeClass("Inactive");', 0, false);
        addToAnimation(Animation, '$(".MouseEar.Right a")[0].href = $(".NextSpread .NextPageURL").val();', 0, false); //
    }

    if ($(".NextSpread .PreviousPageURL").val() == "") {
        addToAnimation(Animation, '$(".MouseEar.Left").addClass("Inactive").removeClass("Active");', 0, false);
        addToAnimation(Animation, '$(".MouseEar.Left a")[0].href = "#";', 0, false);
    } else {
        addToAnimation(Animation, '$(".MouseEar.Left").addClass("Active").removeClass("Inactive");', 0, false);
        addToAnimation(Animation, '$(".MouseEar.Left a")[0].href = $(".NextSpread .PreviousPageURL").val();', 0, false);

    }

    if ($(".NextSpread .NextPageIMG").val() == "") {
        addToAnimation(Animation, '$(".MouseEar.Right").attr("data-img","");', 0, false);
    } else {
        addToAnimation(Animation, '$(".MouseEar.Right").attr("data-img","' + $(".NextSpread .NextPageIMG").val() + '");', 0, false);
    }

    if ($(".NextSpread .PreviousPageIMG").val() == "") {
        addToAnimation(Animation, '$(".MouseEar.Left").attr("data-img","");', 0, false);
    } else {
        addToAnimation(Animation, '$(".MouseEar.Left").attr("data-img","' + $(".NextSpread .PreviousPageIMG").val() + '");', 0, false);
    }

    if ($(".NextSpread .NextPageName").val() == "") {
        addToAnimation(Animation, '$(".MouseEar.Right").attr("data-name","");', 0, false);
    } else {
        addToAnimation(Animation, '$(".MouseEar.Right").attr("data-name","' + $(".NextSpread .NextPageName").val() + '");', 0, false);
    }

    if ($(".NextSpread .PreviousPageName").val() == "") {
        addToAnimation(Animation, '$(".MouseEar.Left").attr("data-name","");', 0, false);
    } else {
        addToAnimation(Animation, '$(".MouseEar.Left").attr("data-name","' + $(".NextSpread .PreviousPageName").val() + '");', 0, false);
    }


    return Animation;
}

function SpreadTransitionClearDown(Animation, UpdateMeta) {
    var $ = jQuery;
    // Tidy Up Function For Page Transitions - makes sure everything is reset correctly for next time.
    addToAnimation(Animation, '$(".CurrentSpread").removeClass("CurrentSpread").addClass("Held");', 0, false); 					// Change Class Of CurrentContent To Held - It will ultimately become NextContent
    addToAnimation(Animation, '$(".NextSpread").removeClass("NextSpread").addClass("CurrentSpread");', 0, false); 				// Reassign the classes on the NextContent container to reflect it's new position (CurrentContent)
    addToAnimation(Animation, '$(".Held").removeClass("Held").addClass("NextSpread");', 0, true); 									// Reassign the classes on the Held container to reflect it's new position (NextContent)
    addToAnimation(Animation, '$(".NextSpread").html("");', 0, false);

    addToAnimation(Animation, '$(".NextSpread").css("-webkit-transform", ""); ', 0, false);
    addToAnimation(Animation, '$(".CurrentSpread").css("-webkit-transform", ""); ', 0, false);
    addToAnimation(Animation, '$(".CurrentSpread").removeClass("animate"); ', 0, false);
    addToAnimation(Animation, '$(".NextSpread").removeClass("animate"); ', 0, false);
    
    														
    addToAnimation(Animation, '$(".NextSpread").removeAttr("style");', 0, false); 													// Remove dynamically added css styles.
    addToAnimation(Animation, '$(".CurrentSpread").removeAttr("style");', 0, false); 												// Remove dynamically added css styles.
    addToAnimation(Animation, 'PageTransitionLock = false;', 0, true);

    addToAnimation(Animation, 'AddMouseEarHoverStates();', 0, true);

    if (UpdateMeta) {
        addToAnimation(Animation, 'makeSpreadDaraggable(false, true);', 0, true);
    } else {
        addToAnimation(Animation, 'makeSpreadDaraggable();', 0, true);
    }

    return Animation;
}


function PageTransitionTidy() {
    var $ = jQuery;
    $("body").css("overflow-x", "");

    var oldContent = $(".CurrentContent");
    var newContent = $(".NextContent");

    $(oldContent).html("").removeClass("CurrentContent")
                        .addClass("NextContent")
                        .css("position", "absolute")
                        .css("display", "none")
                        .css("opacity", "")
                        .css("width", "")
                        .css("overflow", "")
                        .css("z-index", "")
                        .css("height", "");

    $(newContent).addClass("CurrentContent")
                        .removeClass("NextContent")
                        .css("position", "")
                        .css("opacity", "")
                        .css("width", "")
                        .css("top", "")
                        .css("left", "")
                        .css("height", "")
                        .css("background-color", "#fff");

    $(".CurrentContent .TitleBar").parent().css("margin-top", 0);

    $(".ProductImagery").css("position", "").css("margin-top","");
    $("#ContentArea").removeAttr("style").removeClass("HideOverflow").addClass("LargeHeader");

    RemoveDynamicResources();




}

function PageTransitionClearDown(Animation, scrollPoint) {
    var $ = jQuery;
    // Tidy Up Function For Page Transitions - makes sure everything is reset correctly for next time.

    //Potential to do something with ContentArea here to make the transition to the scroll point better?
    addToAnimation(Animation, '$(".CurrentContent").removeClass("CurrentContent").addClass("Held");', 0, false); 					// Change Class Of CurrentContent To Held - It will ultimately become NextContent
    addToAnimation(Animation, '$(".NextContent").removeClass("NextContent").addClass("CurrentContent").addClass("BackgroundWhite");', 0, false); 				// Reassign the classes on the NextContent container to reflect it's new position (CurrentContent)
    addToAnimation(Animation, '$(".Held").removeClass("Held").addClass("NextContent");', 0, true); 									// Reassign the classes on the Held container to reflect it's new position (NextContent)
    addToAnimation(Animation, '$(".NextContent").html("");', 0, false); 																// Remove Content From NextContent Container
    addToAnimation(Animation, '$(".NextContent").removeAttr("style");', 0, false); 													// Remove dynamically added css styles.
    addToAnimation(Animation, '$(".CurrentContent").removeAttr("style");', 0, false); 												// Remove dynamically added css styles.
    //addToAnimation(Animation, 'ResizeContentAreaToContent(' + scrollPoint + ')', 0, false);

    addToAnimation(Animation, 'Resize(".ContentArea", "Y", $(".CurrentContent").height() + "px", 500, "")', 500, true);                 // The content bottom is not visible, so we cna shorten the transition by just snapping it in to place.
    // For Toolbar
    //addToAnimation(Animation, 'toggleFixedFooterToolbar("transition");', 200, true);                                                    // ...and switch the footer toolbar to fixed mode.

    addToAnimation(Animation, 'RemoveDynamicResources();', 0, false);
    //addToAnimation(Animation, 'PageTransitionComplete();', 0, true);

    // addToAnimation(Animation, '$(".CurrentContent").removeClass("BackgroundWhite");', 100, true); 


    return Animation;
}

function ResizeContentAreaToContent(scrollPoint) {
    return false;
    var scrolltimer = 500;
    var CCHeight = $(".CurrentContent").height();
    var CAHeight = $(".ContentArea").height();
    var CAMinHeight = parseInt($(".ContentArea").css('min-height'));
    var CAHeightDiff
    var timer

    if (CCHeight >= CAHeight) {
        if (CAMinHeight > CAHeight) {
            CAHeight = CAMinHeight;
        }
        CAHeightDiff = CCHeight - CAHeight
        ContentResizeComplete("+", CAHeightDiff, scrolltimer, scrollPoint);
    } else {
        CAHeightDiff = CAHeight - CCHeight
        var newContentHeight = $(".PageHeader").height() + CCHeight + $(".FooterPromotions").height();
        if (newContentHeight < $(window).height()) {
            unPinFooterToolbar('transition');
            timer = window.setTimeout(function () { ContentResizeComplete("-", CAHeightDiff, scrolltimer, scrollPoint); }, 300)			// Wait for animation to complete, then continue
        } else {
            ContentResizeComplete("-", CAHeightDiff, scrolltimer, scrollPoint);
        }
    }
}

function ContentResizeComplete(animationDirection, animationDistance, animationDuration, scrollPoint) {

    //$(".ContentArea").animate({ "height": animationDirection + "=" + animationDistance + "px" }, animationDuration);
    timer = window.setTimeout(function () { ResetScrollPoint(scrollPoint) }, animationDuration + 10)									// Wait for animation to complete, then continue
}

function ResetScrollPoint(scrollPoint) {
    $(".CurrentContent").scrollTop(1); 																								// Match content's scroll point to the window scrollpoint and...
    $(window).scrollTop(scrollPoint);
    toggleFixedFooterToolbar('transition'); 																							// Reset the window's scroll point to 0 - this ensures that the new page's content starts at the top, rather than at the scroll point from the previous page!
}


function ToggleMiniBag(TriggerEvent) {
    var $ = jQuery;
    // This function is called via a scroll event trigger, therefore it requires a transition lock to ensure that it does not get repeatedly called.
    // We may also need to lock the header / navigation to ensure that other conflicting transitions do not fire.
    if (!$(".MiniBag").hasClass("Locked")) {                                                                                                                        // Only run when not locked
        $(".MiniBag").addClass("Locked");                                                                                                                               // apply transition locks
        if (!$(".PageHeader").hasClass("Locked")) {
            $(".PageHeader").addClass("Locked");                                                                                                                        // Prevent Header Transitions
        }
        var Animation = createAnimation();
        if (!$(".BagSummary").hasClass("Open")) {
            //ConsoleLog("Show MiniBag");
            addToAnimation(Animation, '$(".BagSummary").addClass("Open")', 0, false);
            addToAnimation(Animation, '$(".MiniBag").addClass("Open")', 0, true);
            addToAnimation(Animation, '$(".MiniBag").animate({"top":"' + $(".HeaderTopBar").height() + '"},500)', 500, false)
            //if (!$(".PageHeader").hasClass("Small")) {
            addToAnimation(Animation, '$(".HeaderSpacer").animate({"height": "+=' + $(".MiniBag").height() + 'px"},500)', 500, false);
            // }
            addToAnimation(Animation, '$(".HeaderNavigation").animate({"top":"' + ($(".HeaderTopBar").height() + $(".MiniBag").height()) + '"},500)', 500, true)
            addToAnimation(Animation, '$(".HeaderNavigation").removeClass("Hidden")', 0, false);
        } else {

            //ConsoleLog("Hide MiniBag");
            //if (!$(".PageHeader").hasClass("Small")) {
            addToAnimation(Animation, '$(".HeaderSpacer").animate({"height": "-=' + $(".MiniBag").height() + 'px"},500)', 500, false);
            //}
            if ($(".PageHeader").hasClass("Large") || mouseOverHeader == true) {
                addToAnimation(Animation, '$(".HeaderNavigation").animate({"top":"' + ($(".HeaderTopBar").height() - 1) + '"},500)', 500, false);
            } else {
                addToAnimation(Animation, '$(".HeaderNavigation").addClass("Hidden")', 0, false);
                addToAnimation(Animation, '$(".HeaderNavigation").animate({"top": "0"},500)', 500, false);
            }
            addToAnimation(Animation, '$(".MiniBag").animate({"top":"' + ($(".HeaderTopBar").height() - $(".MiniBag").height()) + '"},500)', 500, true)

            addToAnimation(Animation, '$(".BagSummary").removeClass("Open")', 0, false);
            addToAnimation(Animation, '$(".MiniBag").removeClass("Open")', 0, false);
        }
        addToAnimation(Animation, '$(".PageHeader").removeClass("Locked")', 0, false);
        addToAnimation(Animation, '$(".MiniBag").removeClass("Locked")', 0, false);                                                         // Removing The Transition Lock(s) should always be the last step, unless linking a further animation

        if (TriggerEvent == "onScroll") {
            if ($(".PageHeader").hasClass("Small")) {
                if ($(document).scrollTop() == 0) {

                    addToAnimation(Animation, 'resizeHeader("Large")', 0, false);
                }
            } else {
                if ($(document).scrollTop() != 0) {
                    addToAnimation(Animation, 'resizeHeader("Small")', 0, false);
                }
            }
        }
        runAnimation(Animation);
    } else {
        //ConsoleLog("MiniBag Locked")
    }
}

function ToggleMoreCollections(target) {
    ToggleResize(target, "Y", "Expanded");
    if (!$("#" + target).hasClass("Expanded")) {
        if ($("#CollectionsShowMoreImg")) {
            $("#CollectionsShowMoreImg").attr("src", $("#CollectionsShowMoreImg").attr("src").toLowerCase().replace("down", "up"));
        }
        if ($("#CollectionsShowMoreText")) {
            $("#CollectionsShowMoreText").text($("#CollectionsShowMoreText").text().replace("More", "Less"));
        }
        addParamToDocState('CollectionViewport', 'Expanded');
    } else {
        if ($("#CollectionsShowMoreImg")) {
            $("#CollectionsShowMoreImg").attr("src", $("#CollectionsShowMoreImg").attr("src").toLowerCase().replace("up", "down"));
        }
        if ($("#CollectionsShowMoreText")) {
            $("#CollectionsShowMoreText").text($("#CollectionsShowMoreText").text().replace("Less", "More"));
        }
        addParamToDocState('CollectionViewport', '');
    }
}

function ToggleExpander(target, ExpanderID) {
    ToggleExpanderResize(target, "Expanded");

    if (!$(target).hasClass("Expanded")) {
      
        if (!$(target).is("#CategoryViewport")) {

            if ($(ExpanderID + "Img")) {
                $(ExpanderID + "Img").attr("src", $(ExpanderID + "Img").attr("src").toLowerCase().replace("down", "up"));
            }
            if ($(ExpanderID + "Text")) {
                $(ExpanderID + "Text").text($(ExpanderID + "Text").text().replace("More", "Less"));
            }

        }
       
       if ($(target).hasClass("ExpansionFinished")) {
      
           if ($(ExpanderID + "Img")) {
               $(ExpanderID + "Img").attr("src", $(ExpanderID + "Img").attr("src").toLowerCase().replace("down", "up"));
           }
           if ($(ExpanderID + "Text")) {
               $(ExpanderID + "Text").text($(ExpanderID + "Text").text().replace("More", "Less"));
           }

           $(target).removeClass("ExpansionFinished");
       }

        addParamToDocState(target, 'Expanded');
    } else {
  
        if ($(ExpanderID + "Img")) {
            $(ExpanderID + "Img").attr("src", $(ExpanderID + "Img").attr("src").toLowerCase().replace("up", "down"));
        }
        if ($(ExpanderID + "Text")) {
            $(ExpanderID + "Text").text($(ExpanderID + "Text").text().replace("Less", "More"));
        }
        addParamToDocState(target, '');
    }
}

function ToggleExpanderResize(target, toggleClass) {
    var value


    if (!$(target).hasClass(toggleClass)) {

        if ($(target).is("#CategoryViewport")) {
            var maxHeight = $(target).children().height();
            var unitHeight = $(target).find("article").first().height();
            var unitMargin = parseInt($(target).find("article").first().css("margin-top")) * 2;
            var curentHeight = $(target).height();
            var baseAdjust = parseInt($(target).css("min-height")) - (unitHeight + unitMargin);
            var hiddenUnitsLeft = parseInt((maxHeight - (curentHeight - baseAdjust)) / (unitHeight + unitMargin));

            if (unitHeight * 2 > curentHeight && unitHeight * 2 <= maxHeight) {

                //add two more rows
                value = curentHeight + ((unitHeight + unitMargin) * 2);
            }
            else {

                //add more rows based on where we are in the visible and hidden grid
                                
                if (hiddenUnitsLeft > 3) {
                    hiddenUnitsLeft = 3;
                }
               
               // calcualte the new height to show 
                value = curentHeight + ((unitHeight + unitMargin) * hiddenUnitsLeft);
            }

            // chack to see if we are at the end of the collection
            if (value > maxHeight) {
                $(target).addClass("ExpansionFinished"); 
            }

            if (value < maxHeight) {
                toggleClass = "";
            }
           
        }
        else {
            value = $(target).children(1).height();
        }
    } else {
        value = parseInt($(target).css("min-height"));
    }

    ResizeExpander(target, value, 500, toggleClass);
}

function ResizeExpander(target, value, duration, toggleClass) {
    var Animation = createAnimation();
    var newHeight = $(".ContentArea").height() - $(target).height() + value;

    addToAnimation(Animation, '$("' + target + '").animate({"height": "' + value + '"}, ' + duration + ')', 0, false);
    addToAnimation(Animation, '$(".ContentArea").animate({"height": "' + newHeight + '"}, ' + duration + ')', duration, true);

    if (toggleClass != '') {
        if (!$(target).hasClass(toggleClass)) {
            addToAnimation(Animation, '$("' + target + '").addClass("' + toggleClass + '")', 0, false);
        } else {
            addToAnimation(Animation, '$("' + target + '").removeClass("' + toggleClass + '")', 0, false);
        }
    }

    runAnimation(Animation);
}

function ToggleResize(target, axis, toggleClass) {
    var newvalue
    var startvalue

    if (axis == "Y") {
        newvalue = $("#" + target).children(1).height()
        startvalue = parseInt($("#" + target).css("min-height"));
    }
    if (axis == "X") {
        newvalue = $("#" + target).children(1).width()
        startvalue = parseInt($("#" + target).css("min-width"));
    }

    if (!$("#" + target).hasClass(toggleClass)) {
        Resize("#" + target, axis, newvalue, 500, toggleClass);
    } else {
        Resize("#" + target, axis, startvalue, 500, toggleClass);
    }
}

function Resize(target, axis, value, duration, toggleClass) {
    var Animation = createAnimation();
    var dimension
    switch (axis) {
        case "Y":
            dimension = "height";
            break;
        case "X":
            dimension = "width";
            break;
    }

    addToAnimation(Animation, '$("' + target + '").animate({"' + dimension + '": "' + value + '"}, ' + duration + ')', duration, true);

    if (toggleClass != '') {
        if (!$("" + target).hasClass(toggleClass)) {
            addToAnimation(Animation, '$("' + target + '").addClass("' + toggleClass + '")', 0, false);
        } else {
            addToAnimation(Animation, '$("' + target + '").removeClass("' + toggleClass + '")', 0, false);
        }
        addToAnimation(Animation, '$("' + target + '").removeAttr("style")', 0, false);
    }

    //addToAnimation(Animation, 'ResizeContentAreaToContent(' + $(window).scrollTop() + ')', 0, false);

    runAnimation(Animation);
}

function ToggleView(View1, View2, Trigger, DocStateParam) {
    var Animation = createAnimation();
    var scrollTimer = 500
    var ToggleClass = 'Hide'

    if ($(View1.className).hasClass(ToggleClass)) {
        addToAnimation(Animation, '$(".' + View2.className + '").fadeOut(' + scrollTimer + ')', scrollTimer, true);
        addToAnimation(Animation, '$("' + View2.className + '").addClass("FadedOut")', 0, false);
        addToAnimation(Animation, '$("' + View1.className + '").removeClass("' + ToggleClass + '")', 0, false);
        addToAnimation(Animation, '$("' + View2.className + '").addClass("' + ToggleClass + '")', 0, false);
        addToAnimation(Animation, '$(".' + View1.className + '").fadeIn(' + scrollTimer + ');', scrollTimer, true);
        addToAnimation(Animation, '$("' + View1.className + '").removeClass("FadedOut")', 0, false);
        addToAnimation(Animation, '$("' + View1.className + '").removeAttr("style")', 0, false);
        addToAnimation(Animation, '$("' + View2.className + '").removeAttr("style")', 0, false);
        if (Trigger.TextID && Trigger.TextID != "" && View2.trigger.text && View2.trigger.text != '') {
            addToAnimation(Animation, '$("#' + Trigger.TextID + '").text("' + View2.trigger.text + '")', 0, false);
        }

        if (DocStateParam != '') {
            if (View1.DocStateValue) {
                addParamToDocState(DocStateParam, View1.DocStateValue)
            } else {
                addParamToDocState(DocStateParam, '')
            }
        }
    } else {
        addToAnimation(Animation, '$(".' + View1.className + '").fadeOut(' + scrollTimer + ')', scrollTimer, true);
        addToAnimation(Animation, '$("' + View1.className + '").addClass("FadedOut")', 0, false);
        addToAnimation(Animation, '$("' + View2.className + '").removeClass("Hide")', 0, false);
        addToAnimation(Animation, '$("' + View1.className + '").addClass("Hide")', 0, false);
        addToAnimation(Animation, '$(".' + View2.className + '").fadeIn(' + scrollTimer + ')', scrollTimer, true);
        addToAnimation(Animation, '$("' + View2.className + '").removeClass("FadedOut")', 0, false);
        addToAnimation(Animation, '$("' + View1.className + '").removeAttr("style")', 0, false);
        addToAnimation(Animation, '$("' + View2.className + '").removeAttr("style")', 0, false);
        if (Trigger.TextID && Trigger.TextID != "" && View1.trigger.text && View1.trigger.text != '') {
            addToAnimation(Animation, '$("#' + Trigger.TextID + '").text("' + View1.trigger.text + '")', 0, false);
        }
        if (DocStateParam != '') {
            if (View2.DocStateValue) {
                addParamToDocState(DocStateParam, View2.DocStateValue)
            } else {
                addParamToDocState(DocStateParam, '')
            }
        }
    }

    runAnimation(Animation);
}

/*function ZoomTarget(e) {
if ($(".ProductViewer").hasClass("ShowZoom")) {
debugger;
} else {
return false;
}
}*/
