﻿/* - Footer Functions -------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/* - Actively Used ------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

function toggleFooterCountrySelector() {

    if (!$(".CountrySelector").hasClass("Locked")) {                                                                                                            // If an animation is not in progress
       // var Animation = createAnimation();                                                                                                                      // Create a new animation
        if (!$(".CountrySelector").hasClass("Open")) {                                                                                                          // If the country selector is currently closed
            $("#ContentArea").height($("#ContentArea").height() + $(".CountrySelector").height());
            $(".CountryOpener .Arrow").css({ "background-position": "-0px -32px" });
            $('html, body').animate({ scrollTop: $(document).height() - $(window).height() }, 500);
            $(".CountrySelector").addClass("Open");
            $("#ContentArea").css("overflow", "");
        } else {
            $("#ContentArea").css("overflow", "hidden");
            $(".CountryOpener .Arrow").css({ "background-position": "-16px -32px" });
            $("#ContentArea").animate({
                height: "-=" + $(".CountrySelector").height()
            }, 500);
            $(".CountrySelector").removeClass("Open");
        }
        //runAnimation(Animation);                                                                                                                                // Run the animation.
    }
}

function SocialSelect(CurrentIcon, href, displayhref) {
    $(".PageFooter .SocialNetworks .Icons .Icon").removeClass("Current");
    $(CurrentIcon).addClass("Current");
    $(".PageFooter .SocialNetworks .URLBox")[0].href = href;
    $(".PageFooter .SocialNetworks .URLBox .URL").html(displayhref);
}

/* - Inactive -----------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

function toggleFixedFooterToolbar(mode) {																								                        // Check to see if the footer is in the correct state for the document's scroll position.
    if ($(".FooterPromotions").position() != null) {
        var VPB = $(document).scrollTop() + $(window).height(); 																			                    // (VPB = View Port Bottom) Calculates the position of the bottom of the users browser viewport on the document
        var FTB = $(".FooterPromotions").position().top + $(".FooterPromotions").height() + $(".FooterToolbar").height(); 			 	                        // (FTB = Footer Toolbar Bottom) Calculates the position of the bottom of the footer toolbar, when not fixed and in document flow
        if (VPB < FTB) {																													                    // If the View Port Bottom Position is less than the normal position of the bottom of the footer toolbar when it's in the document flow (ie the toolbar would be out of view) then
            pinFooterToolbar(mode); 																											                    // Pin the Footer Toolbar to the bottom of the browser chrome
        } else {																															                    // Otherwise (ie the toolbar would be fully in view
            unPinFooterToolbar(mode); 																									                        // Unpin the toolbar from the browser chrome, and drop it back in to the document flow.
        }
    }
}

function pinFooterToolbar(mode) {																										                        // Pin The Footer Toolbar To Bottom Of The Browser Viewport
    if (!$(".PageFooter").hasClass("Fixed")) {																							                        // If PageFooter doesn't have a class of Fixed then
        switch (mode) {																													                        // Mode detection
            case "transition": 																										                            // If in transition mode
                var scrollTimer = 250; 																								                            // Set Animation duration
                $(".FooterToolbar").css({ "position": "fixed", "width": "100%", "top": $(window).height() + "px" }); 				                            // Set the necessary css properties for the animation
                $(".FooterToolbar").animate({ "top": "-=" + $(".FooterToolbar").height() + "px" }, scrollTimer); 					                            // Define and start the animation
                var timer = window.setTimeout(function () { footerToolbarTransitionComplete() }, scrollTimer + 10)						                        // Wait for animation to complete, then continue
                break; 																													                        // END of Transition Mode
            default: 																												                            // All Other Modes
                $(".PageFooter").addClass("Fixed"); 																					                        // Apply the Fixed class to the the PageFooter
                break; 																													                        // END
        }
    } else {																															                        // otherwise (it's already pinned)
        $(".FooterToolbar").removeAttr("style"); 																						                        // Take the opportunity to remove any dynamically added css styles
    }
}

function footerToolbarTransitionComplete() {																							                        // Post animation tidy-up function for Footer Toolbar Transtions
    if ($(".PageFooter").hasClass("Fixed")) {																							                        // If Page Footer has class of Fixed then
        $(".PageFooter").removeClass("Fixed"); 																						                            // Unpinning, so remove Fixed class
    } else {																															                        // Otherwise
        $(".PageFooter").addClass("Fixed"); 																							                        // Pinning, so add Fixed class
    }
    $(".FooterToolbar").removeAttr("style"); 																							                        // Take the opportunity to remove any dynamically added css styles
}

function unPinFooterToolbar(mode) {																										                        // Unpin The Footer Toolbar From Bottom Of The Browser Viewport, Put It Back In The Document Flow
    if ($(".PageFooter").hasClass("Fixed")) {																							                        // If PageFooter has a class of Fixed then
        switch (mode) {																													                        // Mode Detection
            case "transition": 																										                            // If in transtition mode
                var scrollTimer = 250; 																								                            // Set Animation Dureation
                $(".FooterToolbar").css({ "position": "fixed", "width": "100%", "top": $(".FooterToolbar").position().top + "px" });                            // Set the necessary CSS Properties for the animation
                $(".FooterToolbar").animate({ "top": "+=" + $(".FooterToolbar").height() + "px" }, scrollTimer); 					                            // Define and start the animation
                var timer = window.setTimeout(function () { footerToolbarTransitionComplete() }, scrollTimer + 10)						                        // Wait for animation to complete, then continue
                break; 																													                        // END of transition mode
            default: 																												                            // All Other Modes
                $(".PageFooter").removeClass("Fixed"); 																				                            // Remove the Fixed class from PageFooter
                break; 																													                        // END
        }
    } else {																															                        // Otherwise (ie it's already unpinned)
        $(".FooterToolbar").removeAttr("style"); 																						                        // Take the opportunity to remove any dynamically added css styles
    }
}


var footerItemOver = false;

//Fade footer item in
function footerItemIn(fi, p) {

    var tSpeed = 500;
    var offset = 20;

    if ($.browser.msie && $.browser.version < 8) {
        tSpeed = 0;
        offset = 18;
    }

    //Set parent LI to active
    $(p).addClass("Active");
    var targetHeight = $(fi).height() + offset;
    $(fi).css('display', 'block')
            .addClass("opened")
            .offset({ left: $(p).offset().left + 1, top: $(p).offset().top });
    $(fi).animate({
        opacity: 1,
        top: "-=" + (targetHeight)
    }, tSpeed, 'easeOutBack', function () {

    });
}

//Fade footer item out
function footerItemOut(fi, p) {

    var tSpeed = 300;
    if ($.browser.msie && $.browser.version < 8) {
        tSpeed = 0;
    }

    $(fi).removeClass('opened');
    $(p).removeClass('Active');
    $(fi).animate({
        opacity: 0,
        top: "+=" + $(fi).height()
    }, tSpeed, 'easeInOutSine', function () {
        $(fi).css('display', 'none');

    });
}


//Toggle between footer menu item states
function toggleFooterSubItem(p) {
    //Close any other open menu items
    $(p).parent().find("li.Active").each(function () {
        if ($(this).index() != $(p).index()) {
            footerItemOut($(this).find(".opened"), $(this));
        }
    });
    //Toggle current item
    var footerSubItem = $(p).find(".footerSubItem");
    if (!$(footerSubItem).hasClass("opened")) {
        footerItemIn(footerSubItem, p);
    } else {
        footerItemOut(footerSubItem, p);
    }
}


function bindFooterEvents() {
    $("li.FooterSection").each(function () {
        //Create click event method for item
        $(this).bind('click', function () {
            toggleFooterSubItem(this);
        });

        if ($.browser.msie) {

            if ($.browser.version < 9 && $.browser.version > 7) {
                $(this).addClass("ie8");
            }
            if ($.browser.version < 8) {
                $(this).addClass("ie7");
            }
        }

        //Set hover state
        $(this).hover(
                        function () {
                            footerItemOver = true;
                        },
                        function () {
                            footerItemOver = false;
                        }
                        );
    });

    //Close item when user clicks away or scrolls
    $(document).bind('click', function () {
        if (!footerItemOver) {
            var curLiveFooterItem = $("li.FooterSection.Active");
            if (curLiveFooterItem.length) {
                var openMenuItem = $(curLiveFooterItem).find(".opened");
                footerItemOut(openMenuItem, curLiveFooterItem);
            }
        }
    });

    $(window).scroll(function () {
        if (!footerItemOver) {
            var curLiveFooterItem = $("li.FooterSection.Active");
            if (curLiveFooterItem.length) {
                var openMenuItem = $(curLiveFooterItem).find(".opened");
                footerItemOut(openMenuItem, curLiveFooterItem);
            }
        }
    });
}

$(document).ready(function () {
    var SecurePage = false;
    var Base = "";
    var SecureAssets = false;
    try {
        if (baseURL && baseURL != '') {
            Base = baseURL;
        }
        if (baseURL.indexOf("index.html") == 0) {
            SecureAssets = true;
        }
        if (SecureMode && SecureMode == true) {
            SecurePage = true;
        }

    } catch (ex) {
    }

    if (SecurePage == false) {
        var reqURL = '/footer';
        if (SecureAssets) {
            reqURL += "?SecureAssets=true";
        }
        if (Base && Base != "") {
            reqURL = Base + reqURL;
        }
        //debugger;
        $.get(reqURL, function (data) {
            $('body').append(data);
            bindFooterEvents();
        });
    }
});