var HContextArray = new Array(); 																												                            // Define Horizontal Context Array (for detecting changes in department, and the direction in which the transition should move)
var DynamicResources = new Array();                                                                                                                                         // Define an array to store the dynamically added resources for the current page, so they can be removed when we leave the page asynchronously
var PreviousPageResources;
var PageURLInput = String(window.location.pathname) + String(window.location.search); 																						// Drop the current page url in to a variable - used to detect context changes when triggering back functionality
var siteAssetsUrl;                                                                                                                                                          // This is the URL that is used to request further assests such as CSS and JS on the fly - Set by the header.xsl code
var PageTransitionLock = false;
var preventReplaceState = false;                                                                                                                                            // This is true if we don't want to replace state when leaving this page
var PagePopped = false;                                                                                                                                                     // This is true if the popstate has been triggered for this page load
var PagePoppedData = null;                                                                                                                                                  // This will contain history object data if the page is popped

var mouseOverHeader = false;
var liveSpreadPageIndex;                                                                                                                                                    // There are conditions where the header needs to know if the mouse is still over them. This variable is used to determine that. It should be set on mouseover/mouseenter, and cleared on mouseout/mouseleave as required.

var ScriptsLoadedCallback = null;                                                                                                                                           // Store the ScriptsLoadedCallback as a null function. This will get updated by indiviual pages and cleared after it has been called (this saves us from the browser keeping hold of the previous pages ScriptsLoadedCallback function and causing double init issues)
var PageVisibleCallback = null;                                                                                                                                             // Store the PageVisibleCallback as a null function. This will get updated by indiviual pages and cleared after it has been called (this saves us from the browser keeping hold of the previous pages PageVisibleCallback function and causing double init issues)

var ThirdPartiesEnabled = false;

var connectionSpeed = 0;

var isTouchEnabled = false;

if( typeof(window.ontouchstart) != 'undefined' ){
    isTouchEnabled = true;
}


var isIpad = false;
var isIOS = false;
var iOS = 0;

if (navigator.userAgent.indexOf('iPad') != -1) {
    isIpad = true;

    if (/OS [2-4]_\d(_\d)? like Mac OS X/i.test(navigator.userAgent)) {
        //Treat 2 - 4 as just 4
        iOS = 4;
    } else if (/CPU like Mac OS X/i.test(navigator.userAgent)) {
        iOS = 1;
    } else {
        //Set to 5 for all iOS 5 and above
        iOS = 5;
    }

}

if (navigator.userAgent.indexOf('iPad') != -1
    || navigator.userAgent.indexOf('iPhone') != -1
    || navigator.userAgent.indexOf('iPod') != -1) 
{
    isIOS = true;
    ConsoleLog("iOs detected");
}



// The documentState is a JSON object that contains params that are specific to the page.
// These will be appended to the path as querystring params when transitioning and used on page load. 
// If a variable name begins with 'hidden', it will not be used as a querystring param
// The hashtag variable is reserved & placed at the end of the querystring
// e.g. { spreadview: true, hiddenSearchbreadcrumb: '<div>secret</div>', hashtag: '123456x50' } Will be output as /path?speadview=true#123456x50
// The following methods can be used to manage documentState: getDocStateParamValue(Name), addParamToDocState(Name, Value), getDocStateString(documentState)
var documentState = {};                                                                                                                                                     // Declare global to store current document state

  
if (typeof window.history.replaceState != "undefined") {  																								// If we're navigating the site rather than clicking back or forward
    window.history.replaceState({ "url": window.location.href, "title": document.title, "DocState": documentState, "scrollPoint": $(window).scrollTop() }, document.title, window.location.href); 			        // On load, attempt to replace the last state object on the history stack with one that is populated with the relevent transition data (although in all likely hood this will just insert a new item)
}

/* - Global Event Handlers -------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

/* - Window Focus Detection ------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

//if (/*@cc_on!@*/false) {
//    // IE
//    document.onfocusin = onFocus;
//    document.onfocusout = onBlur;
//} else {
    // Everything Else
    window.onfocus = onFocus;
    window.onblur = onBlur;

    // Chrome detect as variable
    var is_chrome = navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
    // isolated Chrome hack for window focus
    $(window).click(function () {
        if(is_chrome) {
            $(window).focus();
        }
        else {
            // do nothing, you're not using Chrome
        };
    });


    //}


//Document ready
$(document).ready(
    function () {

        setPagePositioning();
        //Start timing requests - this is used in LoadHTMLContent in ajax.js
        lastRequest = new Date().getTime();

        //Look in current content page params - if it exists, we have fully loaded a new page (not from loadHTML ajax)
        //Update SEO and breadcrumb here

        //Update breadcrumb/SEO
        if ($(".CurrentContent #PageParams").length) {
            var BCHTML = $(".CurrentContent #PageParams #BreadcrumbWrapper").html();
            if (BCHTML.length) {
                UpdateBreadcrumbTrail(BCHTML);
            }
            //Remove page params from page
            $(".CurrentContent #PageParams").remove();
        }
    }
);

function onBlur() {
    if ($("body").hasClass("Focus")) {
        $("body").removeClass("Focus");
    }
}; 

function onFocus() {
//Need to check viewport size here as well as the user may have resized window while in a different tab
    setPagePositioning();

    if (!$("body").hasClass("Focus")) {
        $("body").addClass("Focus");
    }
};

window.onpopstate = function (stackstate) {


    if ($("body").css("overflow") == "hidden") {
        $("body").css("overflow", "visible");
    }


    // Fired when user clicks forward or back buttons in browser, or when window.history.back() or .forward() is used. WARNING: Chrome incorrectly fires this event handler on load too. This should be catered for by the replace state above.
    PagePopped = true;
    preventReplaceState = true;

    if (stackstate.state == null) {	 																												                        // stackstate tends to only be null on initial vist page OR if we have done a full page reload, ie F5 or transitioning to another page without using AJAX.
        if (!window.location.pathname.substring(0, PageURLInput.length) == PageURLInput + "#") {
            LoadHTMLContent(window.location.href, window.title, "", false, 0, {}); 																		                    // in either instance, we need to reload the relevant content.
        }
    } else {
        // The stackstate will come in handy for some pages...
        PagePoppedData = stackstate.state;

        if (stackstate.state.spreadView && $(".SpreadsPage").length > 0) {

            var targetUrl = stackstate.state.url;
            var targetLink = $(".collectionWrapper a[href$='" + targetUrl + "']");
            var targetLI = $(targetLink).parent();
            var targetIndex = parseInt($(targetLink).attr("data-globalindex"));

            var spreadAnimationDirection = "LEFT";
            if (liveSpreadPageIndex > targetIndex) {
                spreadAnimationDirection = "RIGHT";
            }
            liveSpreadPageIndex = targetIndex;
            LoadSpread(stackstate.state.url, '', spreadAnimationDirection, false);

            positionInitialPage(0, targetLI);
        } else {

            // Else
            if (stackstate.state.url != null) {
                // If the state object has a url property
                LoadHTMLContent(stackstate.state.url, stackstate.state.title, "", false, stackstate.state.scrollPoint, stackstate.state.DocState); 			                    // Load the content defined by the history object - as we're going back or forward in the history stack at this point, the 4th param is set to false to prevent a new history item being inserted in the stack.
            }
        }
    }
}

window.onload = function (event) {																													                        // Fired on initial page load or when user hits refresh or F5.
    //toggleFixedFooterToolbar('transition'); 	
    $(window).focus();
    positionMouseEars(); 																				                        // Check to see if the footer is in the correct state for the document's initial scroll position. The transition param allows the toolbar to animate in gracefully.
}

window.onscroll = function (event) {																												                        // Fired when user scrolls the page
    //if ($(".BagSummary").hasClass("Open")) {                                                                                                                                // If the MiniBag Is Open...
    //    ToggleMiniBag("onScroll");                                                                                                                                          // Close It
    //}

//    if ($(document).scrollTop() == 0) {
//        changeNavMode("Show");
//    } else {
//        changeNavMode("Hide");
//    }

    if (!$(".ContentArea").hasClass("HideOverflow")) {
        resizeContentArea();
    }

    var curLiveFooterItem = $("footer.PageFooter li.FooterSection.Active");
    if (curLiveFooterItem.length) {
        var openMenuItem = $(curLiveFooterItem).find(".opened");
        footerItemOut(openMenuItem, curLiveFooterItem);
    }

    //toggleFixedProductViewer()
    //toggleFixedFooterToolbar(); 																													                        // Check to see if the footer is in the correct state for the document's new scroll position.
}

window.onresize = function (event) {																												                        // Fired when the user resizes their browser window
    resizeContentArea();
    positionMouseEars();
    setPagePositioning();


    //toggleFixedFooterToolbar(); 																													                        // Check to see if the footer is in the correct state for the document's new scroll position.
}

$(window).keydown(function (event) {
    switch (event.keyCode) {
        case 40:
            //alert('down');
            break;
        case 38:
            //alert('up');
            break;
        case 37:
            if ($(".MouseEar.Left.Active a")) {

                $(".MouseEar.Left.Active a")[0].click()
            }
            break;
        case 39:
            if ($(".MouseEar.Right.Active a")) {
                $(".MouseEar.Right.Active a")[0].click()
            }
            break;
        default:
            //alert('???');
    }
});

/* - SEO / Social Media -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

function updateSeo(seoTitle, seoDescription, seoKeywords, seoRobots, seoCanonical) {
    var defaultTitle = "Next Official Site: Shop for Clothes, Shoes, Electricals, Homeware & More";
    var defaultDescription = "next.co.uk - shop online for the latest fashion for women, men, children and homeware. Next day delivery and free returns available.";
    var defaultKeywords = "Next,next.co.uk,Next Directory,Next Flowers,Next Electrics,fashion,clothes,womens,mens,childrens,home,furniture";
    var defaultRobots = "";
    var headEl = $("head");

    function createOrGetMeta(name, value) {
      if(value != ""){
        var el = $("meta[name='" + name + "']");
        if(el != null) {
         el.attr("content", value);
        } else {
          headEl.append($("<meta />").attr("name", name).attr("value", value));
        }
      }
    }

    function createOrGetCanonical(value) {
      if(value != ""){
        var el = $("link[rel='canonical']");
        if(el != null) {
          el.attr("rel", "canonical").attr("value", value)
        } else {
          headEl.append($("<link />").attr("rel", "canonical").attr("value", value));
        }
      }
    }

    seoTitle = seoTitle || defaultTitle;
    seoDescription = seoDescription || defaultDescription;
    seoKeywords = seoKeywords || defaultKeywords;
    seoRobots = seoRobots || defaultRobots;

    createOrGetMeta("title", seoTitle);
    createOrGetMeta("description", seoDescription);
    createOrGetMeta("keywords", seoKeywords);
    createOrGetMeta("robots", seoRobots);
    createOrGetCanonical(seoCanonical);

    document.title = seoTitle;
}

/* - Dynamic Resource Management -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

function InsertScript(scriptSrc) {                                                                                                                                          // Dynamically inserts JS file references :)
    var headID = document.getElementsByTagName("head")[0];
    var newScript = document.createElement('script');
    newScript.type = 'text/javascript';
    newScript.src = scriptSrc;
    headID.appendChild(newScript);
    DynamicResources.push({ Type: "JS", Path: scriptSrc });
}

function InsertCSS(cssSrc) {                                                                                                                                                // Dynamically inserts CSS file references :)
    var headID = document.getElementsByTagName("head")[0];
    var cssNode = document.createElement('link');
    cssNode.href = cssSrc;
    cssNode.rel = 'stylesheet';
    //cssNode.media = 'screen'; // Required?
    headID.appendChild(cssNode);
    DynamicResources.push({ Type: "CSS", Path: cssSrc });
}

function AddDynamicResource(type, path) {
    DynamicResources.push({ Type: type, Path: path });
}

function CreateDynamicResources() {
    var $ = jQuery;
    var Animation = createAnimation()

    if (PageURLInput == "/") {
        if ($(".PageHeader").hasClass("Large")) {
            Animation = HideBreadcrumbBar(Animation);
        }
    } else {
        if (!$(".PageHeader").hasClass("Large")) {
            Animation = ShowBreadcrumbBar(Animation);
        }
    }

    runAnimation(Animation);

    var headID = document.getElementsByTagName("head")[0];
    var waitForCSS = false;
    var checkPreviousPageResources = false;
    //If previous page resources exist, we'll need to check it while we add new resources
    if (PreviousPageResources != null && PreviousPageResources.length) 
    {checkPreviousPageResources = true;}

    for (var i = 0; i < DynamicResources.length; i++) {        // Split in to 2 loops to force CSS to render first.
        if (DynamicResources[i].Type == "CSS") {
            waitForCSS = true;
            var doInsert = true;

            //Check if item already exists in memory from previous page
            if (checkPreviousPageResources) {
                var exInstance = $.grep(PreviousPageResources, function (n) {
                    return n.Path == DynamicResources[i].Path;
                });
                //If the item already exists, don't add it again
                if (exInstance != null && exInstance.length) {
                    doInsert = false;
                }
            }

            if (doInsert) { 
                var cssNode = document.createElement('link');
                cssNode.href = DynamicResources[i].Path;
                cssNode.rel = 'stylesheet';
                headID.appendChild(cssNode);
            }
        }
    }
    CreateDynamicJSResources(waitForCSS)
}



function CreateDynamicJSResources(waitForCSS) {

    if (waitForCSS == false || $(".CSSLoadDetector").css("background-color") == "rgb(255, 255, 255)" || $(".CSSLoadDetector").css("background-color") == "#ffffff" || $(".CSSLoadDetector").css("background-color") == "#fff") {
       
        //ResizeContentAreaToContentV2()
      
        loadScripts(DynamicResources, 0);


        $(".CurrentContent").removeClass("FirstLoad");
    } else {
        window.setTimeout("CreateDynamicJSResources(true)", 200);
    }
}

//Loads scripts in sequence - in order to guarantee scripts have loaded before calling dependencies in other files
function loadScripts(DynamicResources, index) {
    
    if (DynamicResources[index] == null || DynamicResources.length == 0) {
        //Completed all script loading
        CallDocumentLoaded();
        return false;
    }

    //If current resource is CSS, move onto next
    if (DynamicResources[index].Type != "JS") {
        
        loadScripts(DynamicResources, index + 1);
        return false;
    }

    //If item already exists in memory
    if (PreviousPageResources != null && PreviousPageResources.length) {
        var exInstance = $.grep(PreviousPageResources, function (n) {
            return n.Path == DynamicResources[index].Path;
        });
        //If the item already exists, don't add it again
        if (exInstance != null && exInstance.length) {
        
            loadScripts(DynamicResources, index + 1);
            return false;
        }
    }

    //Create new script element
    var script = document.createElement("script")
    script.type = "text/javascript";

    //Add script load handlers - once current script has loaded, move to next. May seem slower than async loading multiple scripts but ensures we don't call non exisitent functions
    if (script.readyState) {  //IE
        script.onreadystatechange = function () {
            if (script.readyState == "loaded" ||
                    script.readyState == "complete") {
                script.onreadystatechange = null;
               
                loadScripts(DynamicResources, index + 1);
            }
        };
    } else {  //Others
        script.onload = function () {
           
            loadScripts(DynamicResources, index + 1);
        };
    }

    script.src = DynamicResources[index].Path;
    document.getElementsByTagName("head")[0].appendChild(script);

}

//Call this once all scripts have loaded
function CallDocumentLoaded(ignoreScriptCallBack) {
    
    //Implement this function if we need to fire scripts as soon as they are loaded
    //This may be during a page transition - if the scripts cause performance issues during 
    //a page transition, wait until the transition is finished i.e. implement PageVisibleCallback() instead
    if (!ignoreScriptCallBack) {
        try {
            ScriptsLoadedCallback();
            ScriptsLoadedCallback = null;
        }
        catch (ex) {
            //ignore - callback method not implemented
        }
    }
    
    //If page is transitioning, wait until that finishes
    //if (isPageTransitioning) {
//        window.setTimeout("CallDocumentLoaded(true)", 100);
//        return false;
//    }
   // HeaderScrollState();

   
    try {
        PageVisibleCallback();
        PageVisibleCallback = null;
    }
    catch (ex) {
        //ignore - callback method not implemented
    }

    AddMouseEarHoverStates();

    if (ThirdPartiesEnabled == true && AddThisEnabled == true) {
        updateSocialMediaButtons(window.location.pathname);
    }

    $("#PageLoadBlock").remove();
    setPagePositioning();
    
    // reset the PagePopped flag here as the page visible callback might need it and this is the latest we can reset it
    PagePopped = false;
    PagePoppedData = null;
       
}

function RemoveDynamicResources() {
    var $ = jQuery;
    if ((PreviousPageResources != undefined) && (PreviousPageResources.length > 0)) {
        var DRObject = PreviousPageResources.shift();

        //Check this item isn't required by current page (i.e. added to dynamic resources)
        if (DynamicResources != null && DynamicResources.length) {
            var exInstance = $.grep(DynamicResources, function (n) {
                return n.Path == DRObject.Path;
            });
            //If the item we're about to remove from DOM exists in the new DynamicResources, don't remove it
            if (exInstance != null && exInstance.length) {
                RemoveDynamicResources();
                return false;
            }
        }

        switch (DRObject.Type) {
            case "JS":
                $($('script[src="' + DRObject.Path + '"]')[0]).remove();
                break;
            case "CSS":
                $($('link[href="' + DRObject.Path + '"]')[0]).remove();
                break;
        }
        RemoveDynamicResources();
    } else {

        isPageTransitioning = false;
      
    }


}
    

/* - Animation Stack Handlers ------------------------------------------------------------------------------------------------------------------------------------------------------*/

function createAnimation() {
    var AnimationStack = new Array();
    return AnimationStack;
}

function addToAnimation(AnimationStack, CommandText, Duration, WaitForComplete) {
    var StackObject
    if (WaitForComplete) {
        StackObject = { Command: CommandText, NextActionDelay: Duration + 10 };
    } else {
        StackObject = { Command: CommandText }
    }
    AnimationStack.push(StackObject);
}

function runAnimation(stack) {
    if (stack.length > 0) {
        StackObject = stack.shift();
        //ConsoleLog(StackObject.Command);
        eval(StackObject.Command);
        if (StackObject.NextActionDelay != null && StackObject.NextActionDelay != 0) {
            var timer = window.setTimeout(function () { runAnimation(stack) }, StackObject.NextActionDelay)
        } else {
            runAnimation(stack);
        }
    }
}

/* - Document State Management -----------------------------------------------------------------------------------------------------------------------------------------------------*/

function getDocStateParamValue(Name) {
    if (documentState[Name] !== undefined)
        return documentState[Name];
    else
        return null;
}

function addParamToDocState(Name, Value) {
    if (documentState[Name] !== undefined) {
        documentState[Name] = Value;
    }
    else {
        documentState[Name] = Value;
    }

    if (window.history.replaceState) {
        window.history.replaceState({ "url": window.location.href, "DocState": documentState, "title": document.title, "scrollPoint": $(window).scrollTop() }, document.title, window.location.href); 			// On load, attempt to replace the last state object on the history stack with one that is populated with the relevent transition data (although in all likely hood this will just insert a new item)
    }
}

function getDocStateString(DocState) {
    var docStateString = ""
    var hashTag = ""
    if (typeof DocState != "undefined" && DocState != null) {
        // If it is already a string, just append it
        if (typeof DocState === "string")
            docStateString = DocState;
        // If it is a JSON object, parse it
        else if (typeof DocState === "object") {
            jQuery.each(DocState, function (varName, varVal) {
                if (varName === 'hashtag')
                    hashTag = '#' + varVal;
                // If this is not a hidden variable, then add it to the docstate string
                else if (varName.indexOf('hidden') !== 0)
                    docStateString += '&' + varName + '=' + varVal;
            });
        }
    }

    return docStateString + hashTag;
}

/* - Page Transitions ------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/* - Context Handlers --------------------------------------------------------------------------------------------------------------------------------------------------------------*/

function getVTransitionContext(url) {
    url = String(url);
    var newVTransitionContext
    if (url == "/") {
        newVTransitionContext = 0;
    } else {
        newVTransitionContext = url.split(/\//g).length - 1;
    }
    return newVTransitionContext;
}

function getHTransitionContext(url) {
    url = String(url);
    var newHTransitionContext
    if (url == "/") {
        newHTransitionContext = -1;
    } else {
        if (url.indexOf("/") != -1) {
            var urlSeg = url.split(/\//g);
            newHTransitionContext = HContextArray.indexOf(urlSeg[1])
        } else {
            newHTransitionContext = 1
        }
    }
    return newHTransitionContext;
}

/* - Layout Size Handlers ----------------------------------------------------------------------------------------------------------------------------------------------------------*/

function resizeContentArea() {
    return false; 																										// This function ensures that the bottom of the footer does not attempt to move above the bottom of the browser window
    //ConsoleLog("RCA");
    var FooterHeight = 373; 																											// Set default height, as pageFooter doesn't seem to be rendered by the time this function gets called on pageload
    if ($(".PageFooter").height() != null) {
        FooterHeight = $(".PageFooter").height();
    }
    var CAHeight = $(window).height() - $(".PageHeader").height() - FooterHeight;
    if (!$(".ContentArea").hasClass("HideOverflow")) {
        $(".ContentArea").addClass("HideOverflow");
    }
    $(".ContentArea").css('min-height', CAHeight + "px");
    $(".ContentArea").css('height', $(".CurrentContent").height());
}

function ResizeContentAreaToContentV2() {
    return false; 	
    Resize(".ContentArea", "Y", $(".CurrentContent").height() + "px", 0, "");
}

/* - CSS Dynamic Content Handlers ------------------------------------------------------------------------------------------------------------------------------------------------------*/

function scriptEnabledValidation() {
    var $ = jQuery;
    // If JS is enabled, we want to add a class to the body so that we can show/hide content in our CSS
    $('body').addClass('JSEnabled');
    //Also add browser class to body tag

    var browserName;

    if ($.browser.msie) { browserName = "msie" + $.browser.version.substring(0,1); }
    if ($.browser.webkit) { browserName = "webkit"; }
    if ($.browser.opera) { browserName = "opera"; }
    if ($.browser.mozilla) { browserName = "mozilla"; }

    $('body').addClass(browserName);
}

scriptEnabledValidation();


/* - Page Callback Handlers ------------------------------------------------------------------------------------------------------------------------------------------------------*/

function PageTransitionComplete() {
    try
    {
        PageVisibleCallback();
        PageVisibleCallback = null;
    }
    catch (ex)
    {
        //ignore - callback method not implemented
    }
}

/* - Mouse Ear Logic ------------------------------------------------------------------------------------------------------------------------------------------------------*/

function ShowMouseEarHover(params, forcePopUp) {


    if (isIpad) {
        RemoveMouseEarHover(params.element);
        return false;
    }

    var $ = jQuery;
    if (!params.img) {

        RemoveMouseEarHover(params.element);
        return false;

        }
   

    var mouseEar = params.element;

    //If mouse ear already has an associated pop up image, return false
    if ($(mouseEar).find(".MouseEarHoverPopUp").length) {
        return false;
    }
    
    $(mouseEar).addClass("hasPopUp");

    //Create wrapper element
    var hoverEl = $("<div />");
    $(hoverEl).addClass("MouseEarHoverPopUp");

    //Create pointer arrow element
    var arrow = $("<div />");
    $(arrow).addClass("MouseEarHoverArrow");
    $(hoverEl).append(arrow);

    //Create image shadow inset wrapper
    var imgWrap = $("<div />");
    $(imgWrap).addClass("MouseEarImgShadow");

    //Create image path
    var imgPath = cdnURL + "/common/items/default/default/sitemaps/" + params.sitemap + params.img;
    //Load the image - make sure the image is loaded before animating into view
    var img = $("<img/>").attr('src', imgPath).load(function () {
       
        $(imgWrap).append(img);
      
       //Append image to wrapper element
        $(hoverEl).append(imgWrap);

        //Create text node
        var textNode = $("<h5 />");
        var elName = params.name;
        $(textNode).html(elName);
        $(hoverEl).append(textNode);

        //Hide element
        $(hoverEl).css("opacity", 0);
        //Add it to the page
        $(mouseEar).append(hoverEl);

        //Animate element into view based on which mouse ear it is related to
        if ($(mouseEar).hasClass("Right")) {
            $(hoverEl).animate({
                right: "-=" + 20,
                opacity: 1
            }, 300, 'easeOutBack');
        }

        if ($(mouseEar).hasClass("Left")) {
            $(hoverEl).animate({
                left: "-=" + 20,
                opacity: 1
            }, 300, 'easeOutBack');
        }

    });


}

//Change contents of open pop-up as user pages while mouse is still over the mouseEar
function UpdateMouseEarHover(params) {
    var $ = jQuery;
    var mouseEar = params.element;

    if (!params.img) {
        RemoveMouseEarHover(mouseEar);
        return false;

    }

    var popUp = $(mouseEar).find(".MouseEarHoverPopUp");

    if (popUp.length == 0) {
        ShowMouseEarHover(params, true);
        return false;
    }

    //Create image path
    var imgPath = cdnURL + "/common/items/default/default/sitemaps/" + params.sitemap + params.img;

   $(popUp).find("h5").empty();
   $(popUp).find("h5").html(params.name);

    //Load the image
    var img = $("<img/>").attr('src', imgPath).load(function () {
     $(popUp).find(".MouseEarImgShadow img").first().replaceWith(img);
   });

}

function RemoveMouseEarHover(mouseEar) {

    var $ = jQuery;
    //Animate element away from parent mouse ear based on position of mouse ear then remove from DOM
    if ($(mouseEar).hasClass("Right")) {
        $(mouseEar).find(".MouseEarHoverPopUp")
                    .animate({ right: "+=" + 20,
                        opacity: 0
                    }, 300, 'easeInBack', function () {
                        $(mouseEar).removeClass("hasPopUp");
                        $(this).remove();
                    });
    }

    if ($(mouseEar).hasClass("Left")) {

        $(mouseEar).find(".MouseEarHoverPopUp")
                    .animate({ left: "+=" + 20,
                        opacity: 0
                    }, 300, 'easeInBack', function () {
                        $(mouseEar).removeClass("hasPopUp");
                        $(this).remove();
                    });
    }
}

function ClearMouseEarStates() {
    
    $("div.MouseEar").each(function () {
        $(this).unbind('mouseenter').unbind('mouseleave');
    });
}



//Limit mouse ear position to 1280 width - anything beyoned that, the mouse ears will be fixed
function positionMouseEars() {
    var $ = jQuery;
    if ($(window).width() > 1280) {
        $("body").addClass("LimitWidth");

    } else {
        $("body").removeClass("LimitWidth");
    }
}


//Add hover states for spread mouse ears
function AddSpreadHoverStates() {
    var $ = jQuery;
//Clear out any mouse ears from previous pages
    $(".MouseEar.Right.Proxy").remove();
    $(".MouseEar.Left.Proxy").remove();
//Make new spread mouse ears visible
    $(".MouseEar.Right").addClass("visible");
    $(".MouseEar.Left").addClass("visible");
//Unbind any existing hover event handlers
    $(".MouseEar.Right").off('hover');
    $(".MouseEar.Left").off('hover');
//If Right mouse ear has a next page image preview, build hover state
    if ($(".MouseEar.Right").attr("data-img").length) {

        var mouseEarRight = $(".MouseEar.Right");
        var paramsRight = {
            element: $(".MouseEar.Right"),
            img: $(".MouseEar.Right").attr("data-img"),
            sitemap: $(".MouseEar.Right").attr("data-sitemap"),
            name: $(".MouseEar.Right").attr("data-name")
        };
        //Create mouseEar hover event handler
        $(mouseEarRight).hover(function () { ShowMouseEarHover(paramsRight); }, function () { RemoveMouseEarHover(mouseEarRight); });
        //And close pop up on click
        $(mouseEarRight).click(function () { RemoveMouseEarHover(mouseEarRight); });
    }

//Same as above for left mouse ear
    if ($(".MouseEar.Left").attr("data-img").length) {

        var mouseEarLeft = $(".MouseEar.Left");
        var paramsLeft = {
            element: $(".MouseEar.Left"),
            img: $(".MouseEar.Left").attr("data-img"),
            sitemap: $(".MouseEar.Left").attr("data-sitemap"),
            name: $(".MouseEar.Left").attr("data-name")
        };

        $(mouseEarLeft).hover(function () { ShowMouseEarHover(paramsLeft); }, function () { RemoveMouseEarHover(mouseEarLeft); });
        $(mouseEarLeft).click(function () { RemoveMouseEarHover(mouseEarLeft); });

    }

//Move mouse ears (first time round) to outer wrapper to prevent animations overlapping ears
    if (!$(".MouseEar.Left").hasClass("spreadEar")) {
        $(".MouseEar.Left").addClass("spreadEar");    
        $(".ContentArea").prepend($(".MouseEar.Left"));
    }

    if (!$(".MouseEar.Right").hasClass("spreadEar")) {
        $(".MouseEar.Right").addClass("spreadEar");
        $(".ContentArea").prepend($(".MouseEar.Right"));
    }

    return false;

}

//Create hover event handlers for mouse ears
function AddMouseEarHoverStates() {
    var $ = jQuery;
    //If we're in a Spread page, handle mouse ears separately 
    if ($(".SpreadsPage").length) {
        AddSpreadHoverStates();
        return false;
    }

    //Clean up spread MouseEars
    $(".MouseEar.Left.spreadEar").remove();
    $(".MouseEar.Right.spreadEar").remove();

    //Hide incoming/new MouseEars
    $(".MouseEar.Right").removeClass("visible");
    $(".MouseEar.Left").removeClass("visible");

    var hasNewLeft = false;
    var hasNewRight = false;
    var hasLeftProxy = false;
    var hasRightProxy = false;

    //Check we already have a mouse ear to handle hover/click events
    if ($(".ContentArea div.MouseEar.Left.Proxy").length) {
        hasLeftProxy = true;
    }

    if ($(".ContentArea div.MouseEar.Right.Proxy").length) {
        hasRightProxy = true;
    }
    //Check incoming page has a left and right mouse ear
    if ($(".CurrentContent div.MouseEar.Left").length) {
        hasNewLeft = true;
    } else {
        //Incoming page has no left mouse ear, remove any exisitng Left mouseEar
        $(".ContentArea div.MouseEar.Left.Proxy").remove();
  
    }

    if ($(".CurrentContent div.MouseEar.Right").length) {
        hasNewRight = true;
    } else {
      $(".ContentArea div.MouseEar.Right.Proxy").remove();
   }
   //Add hover event handlers for each mouse ear
   $(".CurrentContent div.MouseEar").each(function () {


       var mouseEar = $(this);
       var params = {
           element: $(this),
           img: $(this).attr("data-img"),
           sitemap: $(this).attr("data-sitemap"),
           name: $(this).attr("data-name")
       };


       if ($(this).hasClass("Left") && hasLeftProxy) {

           var leftProxy = $(".ContentArea div.MouseEar.Left.Proxy");
           $(leftProxy).off('hover');
           params.element = leftProxy;

           $(leftProxy).attr("data-img", $(this).attr("data-img"));
           $(leftProxy).attr("data-sitemap", $(this).attr("data-sitemap"));
           $(leftProxy).attr("data-name", $(this).attr("data-name"));

           $(leftProxy).hover(function () { ShowMouseEarHover(params); }, function () { RemoveMouseEarHover(leftProxy); });

           $(leftProxy).find("a").attr("href", $(this).find("a").attr("href"));
           $(leftProxy).find("a").attr("onclick", $(this).find("a").attr("onclick"));
           
     

           if ($(this).hasClass("Active")) {
               $(leftProxy).removeClass("Inactive");
               $(leftProxy).addClass("Active");
           }

           if ($(this).hasClass("Inactive")) {
               $(leftProxy).removeClass("Active");
               $(leftProxy).addClass("Inactive");
           }


           if ($(leftProxy).hasClass("hasPopUp")) {
               UpdateMouseEarHover(params);
           }


       }

       if ($(this).hasClass("Left") && !hasLeftProxy) {
           $(this).hover(function () { ShowMouseEarHover(params); }, function () { RemoveMouseEarHover(mouseEar); });
           $(this).addClass("Proxy");
           $(".ContentArea").prepend(this);
       }

       if ($(this).hasClass("Right") && hasRightProxy) {

           var RightProxy = $(".ContentArea div.MouseEar.Right.Proxy");
           $(RightProxy).off('hover');
           params.element = RightProxy;
           $(RightProxy).attr("data-img", $(this).attr("data-img"));
           $(RightProxy).attr("data-sitemap", $(this).attr("data-sitemap"));
           $(RightProxy).attr("data-name", $(this).attr("data-name"));

           $(RightProxy).hover(function () { ShowMouseEarHover(params); }, function () { RemoveMouseEarHover(RightProxy); });

           $(RightProxy).find("a").attr("href", $(this).find("a").attr("href"));
           $(RightProxy).find("a").attr("onclick", $(this).find("a").attr("onclick"));


           if ($(this).hasClass("Active")) {
               $(RightProxy).removeClass("Inactive");
               $(RightProxy).addClass("Active");
           }

           if ($(this).hasClass("Inactive")) {
               $(RightProxy).removeClass("Active");
               $(RightProxy).addClass("Inactive");
           }


           if ($(RightProxy).hasClass("hasPopUp")) {
               UpdateMouseEarHover(params);
           }

       }

       if ($(this).hasClass("Right") && !hasRightProxy) {
           $(this).hover(function () { ShowMouseEarHover(params); }, function () { RemoveMouseEarHover(mouseEar); });
           $(this).addClass("Proxy");
           $(".ContentArea").prepend(this);
       }


   });

}

function setPagePositioning() {
    var $ = jQuery;
    var viewportWidth = $(window).width();
    var viewportHeight = $(window).height();

    if (viewportWidth < 990) {

        $(".PageHeader").css("position", "absolute")
        .css("width", "1000px");

        $(".ToolBar").css(
        {"position": "relative",
        "margin-top": "-30px",
        "clear": "both",
        "width": "1000px"
    });

    $(".ContentArea").css("min-height", "100%");


    $(".SpreadsGridTitle").css(
     { "position": "relative",
         "width": "980px",
         "margin-top": "-40px",
         "margin-bottom": "-40px"
     });

     $(".SpreadsGridTitle .TitleInner").css("padding-top", "10px");
     

    } else {
        $(".PageHeader").css("position", "")
        .css("width", "");

           $(".ToolBar").css(
        {"position": "",
        "margin-top": "",
        "clear": "",
        "width": ""
    });

    $(".ContentArea").css("min-height", "");

    $(".SpreadsGridTitle").css(
     { "position": "",
         "width": "",
         "margin-top":"",
         "margin-bottom": ""
     });
     $(".SpreadsGridTitle .TitleInner").css("padding-top", "");

    }

}


/* - Generic Session Variable Methods ------------------------------------------------------------------------------------------------------------------------------------------------------*/

var ClientTempSessionVariables = {};    // This is a local store of the Session Variables that will save us from going to the Server each time we want to get a value
var UseLocalStorage = true;             // Config switch to use either Local Storage on the browser or use the Server side Session Storage Objects

function UpdateSessionVariable(variableName, newValue, forceServerPost, successCallback, errorCallback) {
    if (UseLocalStorage) {
        $.jStorage.set(variableName, newValue);
        
        if (successCallback)
            successCallback();
    }
    else {
        if ((forceServerPost !== null && forceServerPost !== undefined && forceServerPost) || ClientTempSessionVariables === null || ClientTempSessionVariables === undefined || ClientTempSessionVariables[variableName] === null || ClientTempSessionVariables[variableName] === undefined || (ClientTempSessionVariables[variableName] !== newValue)) {
            // Build the URL used to set Session Variables
            var reqUrl = ''
            if (typeof baseURL != 'undefined')
                reqUrl = baseURL;
            reqUrl += "/session/AddVariable";

            // Send the request
            $.ajax({
                url: reqUrl,
                data: { name: variableName, value: newValue },
                type: "POST",
                cache: false,
                async: true,
                timeout: 10000,
                dataType: "json",
                xhrFields: { withCredentials: true },
                crossDomain: true,
                success: function (data, textStatus, jqXHR) {
                	checkAndRedirectForAjaxError(jqXHR, false, 'Global.js: UpdateSessionVariable');
                    // Update the temporary client-side session variables
                    ClientTempSessionVariables = data

                    if (successCallback)
                        successCallback(data, textStatus, jqXHR);
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    if (errorCallback)
                        errorCallback(jqXHR, textStatus, errorThrown);
                }
            });
        }
    }    
}

function GetSessionVariable(variableName, forceServerGet, successCallback, errorCallback) {
    if (UseLocalStorage) {
        if (successCallback)
            successCallback($.jStorage.get(variableName));
        else
            return $.jStorage.get(variableName);        
    }
    else {
        // If we need to force a refresh or the variable doesn't exist in the jQuery temp ClientTempSessionVariables store, then refresh it
        if (forceServerGet || ClientTempSessionVariables === null || ClientTempSessionVariables === undefined || ClientTempSessionVariables[variableName] === null || ClientTempSessionVariables[variableName] === undefined) {
            var reqUrl = ''
            if (typeof baseURL != 'undefined')
                reqUrl = baseURL;
            reqUrl += "/session/GetVariables";

            $.ajax({
                url: reqUrl,
                type: "POST",
                cache: false,
                async: true,
                timeout: 5000,
                dataType: "json",
                xhrFields: { withCredentials: true },
                crossDomain: true,
                success: function (data, textStatus, jqXHR) {
                	checkAndRedirectForAjaxError(jqXHR, false, 'Global.js: GetSessionVariable');
                    ClientTempSessionVariables = data;
                    // Return the value if it exists
                    if (ClientTempSessionVariables !== null && ClientTempSessionVariables !== undefined && ClientTempSessionVariables[variableName] !== undefined) { // Allow this to return a null value as it is valid
                        if (successCallback)
                            successCallback(ClientTempSessionVariables[variableName], data, textStatus, jqXHR);
                    }
                    else {
                        if (errorCallback)
                            errorCallback(jqXHR, textStatus);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    if (errorCallback)
                        errorCallback(jqXHR, textStatus, errorThrown);
                }
            });
        }
        else {
            // Return the value if it exists
            if (successCallback)
                successCallback(ClientTempSessionVariables[variableName]);
        }
    }
}

/* - Continue Shopping Methods ------------------------------------------------------------------------------------------------------------------------------------------------------*/

function UpdateContinueShopping(shoppableUrl) {
    var newValue;

    if (typeof shoppableUrl != "undefined")
        newValue = shoppableUrl;
    else
        newValue = window.location.href;

    // Check the current value and update it if the values are different
    GetSessionVariable(
        "ContinueShopping",
        false,
        function (UrlReturned) { // SUCCESS CALLBACK
            var allowUpdate = true;

            // Don't bother re-adding it if it was the last one to be added
            if (UrlReturned != null && UrlReturned != undefined && UrlReturned == newValue) {
                allowUpdate = false;
            }

            if (allowUpdate) {
                UpdateContinueShoppingAndShoppingHistory(newValue);
            }
        },
        function () { // ERROR CALLBACK
            // Just update it anyway on error (there is an issue with the Get, so Setting it is safer than ignoring it)
            UpdateContinueShoppingAndShoppingHistory(newValue);
        }
    );
}

function UpdateContinueShoppingAndShoppingHistory(newValue) {
    UpdateSessionVariable('ContinueShopping', newValue);

    // If we are using LocalStorage, then we need to manually update the ShoppingHistory too 
    // Note this is replicating server-side logic that is in place in the non-LocalStorage version of this method
    if (UseLocalStorage) {
        GetSessionVariable(
            "ShoppingHistory",
            false,
            function (returnedHistory) {
                var tempHistory = [];
                if (returnedHistory !== null) {
                    tempHistory = returnedHistory;
                }
                tempHistory.push(newValue);

                // We only want to keep a small history, so get rid of the first item
                if (tempHistory.length > 2)
                    tempHistory.shift();

                UpdateSessionVariable("ShoppingHistory", tempHistory);
            }
        );
    }

}

function ContinueShopping(boolSuppressTransition) {
    // Try to get hold of the Continue Shopping Session Variable, if it doesn't exist, then take the user to the homepage
 
    var suppressTransition = true;
    if (boolSuppressTransition != undefined)
        suppressTransition = boolSuppressTransition;

    // Default to the Base Url if it is available, otherwise default it to the root
    var urlToLoad = '/';
    if (typeof siteBaseUrl != 'undefined')
        urlToLoad = siteBaseUrl;

    GetSessionVariable(
        "ContinueShopping",
        false,
        function (UrlReturned) { // SUCCESS CALLBACK
            if (UrlReturned != null && UrlReturned != undefined)
                urlToLoad = UrlReturned;
            LoadContinueShoppingUrl(urlToLoad, suppressTransition)
        },
        function () { // ERROR CALLBACK
            LoadContinueShoppingUrl(urlToLoad, suppressTransition)
        }
    );
}

function LoadContinueShoppingUrl(urlToLoad, suppressTransition) {
    // Check whether the path is going to load up in HTTPS and force it to load in HTTP
    if (urlToLoad.indexOf('http:') < 0) {
        // First check whether this is an absolute path in HTTPS
        if (urlToLoad.indexOf('https:') == 0) {
            if (typeof siteBaseUrl != 'undefined') {
                var fullUrlToLoad = new UrlHelper(urlToLoad);
                urlToLoad = siteBaseUrl + fullUrlToLoad.Path() + fullUrlToLoad.Query() + fullUrlToLoad.Hash();
            }
            else
                urlToLoad = 'http' + urlToLoad.substring(5);
        }
        // Otherwise, it must be a relative path, so check if we are in HTTPS and change it accordingly
        else if (window.location.protocol === 'https:') {
            if (typeof siteBaseUrl != 'undefined')
                urlToLoad = siteBaseUrl + urlToLoad;
            else {
                var fullUrlToLoad = new UrlHelper(urlToLoad);
                fullUrlToLoad.Protocol('http:');
                urlToLoad = fullUrlToLoad.FullUrl();
            }
        }        
    }

    if (suppressTransition)
        window.location = urlToLoad;
    else
        LoadHTMLContent(urlToLoad);
}

function ShopMore() {
    ContinueShopping(true);
    return false;
}

/* - General Helpers------------------------------------------------------------------------------------------------------------------------------------------------------*/

function UrlHelper(urlToProcess) {
    this._protocol = '',
    this._host = '',
    this._port = '',
    this._path = '',
    this._query = '',
    this._hash = '';
    this._rawUrl = '';

    if (urlToProcess != undefined) {
        var urlLeftToProcess = urlToProcess;
        var indexTemp = 0;

        this._rawUrl = urlLeftToProcess;

        // Protocol & Host
        
        if (urlLeftToProcess.substring(0, 4) == 'http') {
            var slashSplit = urlLeftToProcess.split('/');
            this._protocol = slashSplit[0];
            this._host = slashSplit[2].split(':')[0].split('?')[0].split('#')[0];
            if (slashSplit[2].split(':').length > 1)
                this._port = slashSplit[2].split(':')[1].split('?')[0].split('#')[0];
            urlLeftToProcess = urlLeftToProcess.substring(this._protocol.length + 2 + this._host.length + 1 + this._port.length);
        }

        if (urlLeftToProcess.substring(0, 1) == '/')
            urlLeftToProcess = urlLeftToProcess.substring(1);

        // Path

        indexTemp = urlLeftToProcess.indexOf('?');
        if (indexTemp > 0) {
            this._path = urlLeftToProcess.substring(0, indexTemp);
            urlLeftToProcess = urlLeftToProcess.substring(indexTemp);
        }
        else {
            indexTemp = urlLeftToProcess.indexOf('#');
            if (indexTemp > 0) {
                this._path = urlLeftToProcess.substring(0, indexTemp);
                urlLeftToProcess = urlLeftToProcess.substring(indexTemp);
            }
            else {
                this._path = urlLeftToProcess;
                urlLeftToProcess = '';
            }
        }

        if (urlLeftToProcess.substring(0, 1) == '?')
            urlLeftToProcess = urlLeftToProcess.substring(1);

        // Query & Hash

        indexTemp = urlLeftToProcess.indexOf('#');
        if (indexTemp > 0) {
            this._query = urlLeftToProcess.substring(0, indexTemp);
            urlLeftToProcess = urlLeftToProcess.substring(indexTemp);
            if (urlLeftToProcess.substring(0, 1) == '#')
                this._hash = urlLeftToProcess.substring(1);
            urlLeftToProcess = '';
        }
        else {
            this._query = urlLeftToProcess;
            urlLeftToProcess = '';
        }


    }

    this.Protocol = function (newval) {
        if (newval == undefined) {
            if (this._protocol == '')
                return window.location.protocol + '//';
            else
                return this._protocol + '//';
        }
        else {
            this._protocol = newval;
        }
    }

    this.Host = function (newval) {
        if (newval == undefined) {
            if (this._host == '')
                return window.location.hostname;
            else
                return this._host;
        }
        else {
            this._host = newval;
        }
    }

    this.Port = function (newval) {
        if (newval == undefined) {
            if (this._port == '') {
                if (window.location.port == '')
                    return '';
                else
                    return ':' + window.location.port;
            }
            else
                return ':' + this._port;
        }
        else {
            this._port = newval;
        }
    }

    this.Path = function(newval) {
        if (newval == undefined) {
            if (this._path == '')
                return '';
            else
                return '/' + this._path;
        }
        else {
            this._path = newval;
        }
    }

    this.Query = function(newval) {
        if (newval == undefined) {
            if (this._query == '')
                return '';
            else
                return '?' + this._query;
        }
        else {
            this._query = newval;
        }
    }

    this.Hash = function(newval) {
        if (newval == undefined) {
            if (this._hash == '')
                return '';
            else
                return '#' + this._hash;
        }
        else {
            this._hash = newval;
        }
    }

    this.FullUrl = function() {
        return this.Protocol() + this.Host() + this.Port() + this.Path() + this.Query() + this.Hash();
    }

    this.ServerUrl = function () {
        return this.Protocol() + this.Host() + this.Port() + this.Path() + this.Query();
    }

    this.AddQueryParam = function (name, value) {
        this._query += '&' + name + '=' + value;
    }
}


function ConsoleLog(obj) {
    if (window.console && console.log) {
        console.log(obj);
    }
}

function ScrollToPoint(scrollPoint) {
    if (scrollPoint != 'undefined' && scrollPoint != null && (parseInt(scrollPoint) > 100))
        $('html, body').animate({ scrollTop: scrollPoint }, 400);
}

// Check's if an 500 error has occurred during an AJAX call and if so to track it and redirect the user to a friendly error page
function checkAndRedirectForAjaxError(jqXHR, initGaAccount, label) {
	if (jqXHR.getResponseHeader('X-Error500Initiated') == 'True') {
		if (initGaAccount == true) {
			GoogleAnalytics(GAAccount);
		}
		TrackGAEvent('500 AJAX - Internal Server Error', jqXHR.getResponseHeader('X-Error500Message'), label);
		window.location = '/error';
	}
}


/*
* ----------------------------- JSTORAGE -------------------------------------
* Simple local storage wrapper to save data on the browser side, supporting
* all major browsers - IE6+, Firefox2+, Safari4+, Chrome4+ and Opera 10.5+
*
* Copyright (c) 2010 Andris Reinman, andris.reinman@gmail.com
* Project homepage: www.jstorage.info
*
* Licensed under MIT-style license:
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/

/**
* $.jStorage
*
* USAGE:
*
* jStorage requires Prototype, MooTools or jQuery! If jQuery is used, then
* jQuery-JSON (http://code.google.com/p/jquery-json/) is also needed.
* (jQuery-JSON needs to be loaded BEFORE jStorage!)
*
* Methods:
*
* -set(key, value[, options])
* $.jStorage.set(key, value) -> saves a value
*
* -get(key[, default])
* value = $.jStorage.get(key [, default]) ->
*    retrieves value if key exists, or default if it doesn't
*
* -deleteKey(key)
* $.jStorage.deleteKey(key) -> removes a key from the storage
*
* -flush()
* $.jStorage.flush() -> clears the cache
*
* -storageObj()
* $.jStorage.storageObj() -> returns a read-ony copy of the actual storage
*
* -storageSize()
* $.jStorage.storageSize() -> returns the size of the storage in bytes
*
* -index()
* $.jStorage.index() -> returns the used keys as an array
*
* -storageAvailable()
* $.jStorage.storageAvailable() -> returns true if storage is available
*
* -reInit()
* $.jStorage.reInit() -> reloads the data from browser storage
*
* <value> can be any JSON-able value, including objects and arrays.
*
**/

(function ($) {
    if (!$ || !($.toJSON || Object.toJSON || window.JSON)) {
        throw new Error("jQuery, MooTools or Prototype needs to be loaded before jStorage!");
    }

    var 
    /* This is the object, that holds the cached values */
        _storage = {},

    /* Actual browser storage (localStorage or globalStorage['domain']) */
        _storage_service = { jStorage: "{}" },

    /* DOM element for older IE versions, holds userData behavior */
        _storage_elm = null,

    /* How much space does the storage take */
        _storage_size = 0,

    /* function to encode objects to JSON strings */
        json_encode = $.toJSON || Object.toJSON || (window.JSON && (JSON.encode || JSON.stringify)),

    /* function to decode objects from JSON strings */
        json_decode = $.evalJSON || (window.JSON && (JSON.decode || JSON.parse)) || function (str) {
            return String(str).evalJSON();
        },

    /* which backend is currently used */
        _backend = false,

    /* Next check for TTL */
        _ttl_timeout,

    /**
    * XML encoding and decoding as XML nodes can't be JSON'ized
    * XML nodes are encoded and decoded if the node is the value to be saved
    * but not if it's as a property of another object
    * Eg. -
    *   $.jStorage.set("key", xmlNode);        // IS OK
    *   $.jStorage.set("key", {xml: xmlNode}); // NOT OK
    */
        _XMLService = {

            /**
            * Validates a XML node to be XML
            * based on jQuery.isXML function
            */
            isXML: function (elm) {
                var documentElement = (elm ? elm.ownerDocument || elm : 0).documentElement;
                return documentElement ? documentElement.nodeName !== "HTML" : false;
            },

            /**
            * Encodes a XML node to string
            * based on http://www.mercurytide.co.uk/news/article/issues-when-working-ajax/
            */
            encode: function (xmlNode) {
                if (!this.isXML(xmlNode)) {
                    return false;
                }
                try { // Mozilla, Webkit, Opera
                    return new XMLSerializer().serializeToString(xmlNode);
                } catch (E1) {
                    try {  // IE
                        return xmlNode.xml;
                    } catch (E2) { }
                }
                return false;
            },

            /**
            * Decodes a XML node from string
            * loosely based on http://outwestmedia.com/jquery-plugins/xmldom/
            */
            decode: function (xmlString) {
                var dom_parser = ("DOMParser" in window && (new DOMParser()).parseFromString) ||
                        (window.ActiveXObject && function (_xmlString) {
                            var xml_doc = new ActiveXObject('Microsoft.XMLDOM');
                            xml_doc.async = 'false';
                            xml_doc.loadXML(_xmlString);
                            return xml_doc;
                        }),
                resultXML;
                if (!dom_parser) {
                    return false;
                }
                resultXML = dom_parser.call("DOMParser" in window && (new DOMParser()) || window, xmlString, 'text/xml');
                return this.isXML(resultXML) ? resultXML : false;
            }
        };

    ////////////////////////// PRIVATE METHODS ////////////////////////

    /**
    * Initialization function. Detects if the browser supports DOM Storage
    * or userData behavior and behaves accordingly.
    * @returns undefined
    */
    function _init() {
        /* Check if browser supports localStorage */
        var localStorageReallyWorks = false;
        if ("localStorage" in window) {
            try {
                window.localStorage.setItem('_tmptest', 'tmpval');
                localStorageReallyWorks = true;
                window.localStorage.removeItem('_tmptest');
            } catch (BogusQuotaExceededErrorOnIos5) {
                // Thanks be to iOS5 Private Browsing mode which throws
                // QUOTA_EXCEEDED_ERRROR DOM Exception 22.
            }
        }
        if (localStorageReallyWorks) {
            try {
                if (window.localStorage) {
                    _storage_service = window.localStorage;
                    _backend = "localStorage";
                }
            } catch (E3) { /* Firefox fails when touching localStorage and cookies are disabled */ }
        }
        /* Check if browser supports globalStorage */
        else if ("globalStorage" in window) {
            try {
                if (window.globalStorage) {
                    _storage_service = window.globalStorage[window.location.hostname];
                    _backend = "globalStorage";
                }
            } catch (E4) { /* Firefox fails when touching localStorage and cookies are disabled */ }
        }
        /* Check if browser supports userData behavior */
        else {
            _storage_elm = document.createElement('link');
            if (_storage_elm.addBehavior) {

                /* Use a DOM element to act as userData storage */
                _storage_elm.style.behavior = 'url(#default#userData)';

                /* userData element needs to be inserted into the DOM! */
                document.getElementsByTagName('head')[0].appendChild(_storage_elm);

                _storage_elm.load("jStorage");
                var data = "{}";
                try {
                    data = _storage_elm.getAttribute("jStorage");
                } catch (E5) { }
                _storage_service.jStorage = data;
                _backend = "userDataBehavior";
            } else {
                _storage_elm = null;
                return;
            }
        }

        _load_storage();

        // remove dead keys
        _handleTTL();
    }

    /**
    * Loads the data from the storage based on the supported mechanism
    * @returns undefined
    */
    function _load_storage() {
        /* if jStorage string is retrieved, then decode it */
        if (_storage_service.jStorage) {
            try {
                _storage = json_decode(String(_storage_service.jStorage));
            } catch (E6) { _storage_service.jStorage = "{}"; }
        } else {
            _storage_service.jStorage = "{}";
        }
        _storage_size = _storage_service.jStorage ? String(_storage_service.jStorage).length : 0;
    }

    /**
    * This functions provides the "save" mechanism to store the jStorage object
    * @returns undefined
    */
    function _save() {
        try {
            _storage_service.jStorage = json_encode(_storage);
            // If userData is used as the storage engine, additional
            if (_storage_elm) {
                _storage_elm.setAttribute("jStorage", _storage_service.jStorage);
                _storage_elm.save("jStorage");
            }
            _storage_size = _storage_service.jStorage ? String(_storage_service.jStorage).length : 0;
        } catch (E7) { /* probably cache is full, nothing is saved this way*/ }
    }

    /**
    * Function checks if a key is set and is string or numberic
    */
    function _checkKey(key) {
        if (!key || (typeof key != "string" && typeof key != "number")) {
            throw new TypeError('Key name must be string or numeric');
        }
        if (key == "__jstorage_meta") {
            throw new TypeError('Reserved key name');
        }
        return true;
    }

    /**
    * Removes expired keys
    */
    function _handleTTL() {
        var curtime, i, TTL, nextExpire = Infinity, changed = false;

        clearTimeout(_ttl_timeout);

        if (!_storage.__jstorage_meta || typeof _storage.__jstorage_meta.TTL != "object") {
            // nothing to do here
            return;
        }

        curtime = +new Date();
        TTL = _storage.__jstorage_meta.TTL;
        for (i in TTL) {
            if (TTL.hasOwnProperty(i)) {
                if (TTL[i] <= curtime) {
                    delete TTL[i];
                    delete _storage[i];
                    changed = true;
                } else if (TTL[i] < nextExpire) {
                    nextExpire = TTL[i];
                }
            }
        }

        // set next check
        if (nextExpire != Infinity) {
            _ttl_timeout = setTimeout(_handleTTL, nextExpire - curtime);
        }

        // save changes
        if (changed) {
            _save();
        }
    }


    ////////////////////////// PUBLIC INTERFACE /////////////////////////

    $.jStorage = {
        /* Version number */
        version: "0.1.7.0",

        /**
        * Sets a key's value.
        *
        * @param {String} key - Key to set. If this value is not set or not
        *              a string an exception is raised.
        * @param {Mixed} value - Value to set. This can be any value that is JSON
        *              compatible (Numbers, Strings, Objects etc.).
        * @param {Object} [options] - possible options to use
        * @param {Number} [options.TTL] - optional TTL value
        * @returns the used value
        */
        set: function (key, value, options) {
            _checkKey(key);

            options = options || {};

            if (_XMLService.isXML(value)) {
                value = { _is_xml: true, xml: _XMLService.encode(value) };
            } else if (typeof value == "function") {
                value = null; // functions can't be saved!
            } else if (value && typeof value == "object") {
                // clone the object before saving to _storage tree
                value = json_decode(json_encode(value));
            }
            _storage[key] = value;

            if (!isNaN(options.TTL)) {
                this.setTTL(key, options.TTL);
                // also handles saving
            } else {
                _save();
            }
            return value;
        },

        /**
        * Looks up a key in cache
        *
        * @param {String} key - Key to look up.
        * @param {mixed} def - Default value to return, if key didn't exist.
        * @returns the key value, default value or <null>
        */
        get: function (key, def) {
            _checkKey(key);
            if (key in _storage) {
                if (_storage[key] && typeof _storage[key] == "object" &&
                        _storage[key]._is_xml &&
                            _storage[key]._is_xml) {
                    return _XMLService.decode(_storage[key].xml);
                } else {
                    return _storage[key];
                }
            }
            return typeof (def) == 'undefined' ? null : def;
        },

        /**
        * Deletes a key from cache.
        *
        * @param {String} key - Key to delete.
        * @returns true if key existed or false if it didn't
        */
        deleteKey: function (key) {
            _checkKey(key);
            if (key in _storage) {
                delete _storage[key];
                // remove from TTL list
                if (_storage.__jstorage_meta &&
                  typeof _storage.__jstorage_meta.TTL == "object" &&
                  key in _storage.__jstorage_meta.TTL) {
                    delete _storage.__jstorage_meta.TTL[key];
                }
                _save();
                return true;
            }
            return false;
        },

        /**
        * Sets a TTL for a key, or remove it if ttl value is 0 or below
        *
        * @param {String} key - key to set the TTL for
        * @param {Number} ttl - TTL timeout in milliseconds
        * @returns true if key existed or false if it didn't
        */
        setTTL: function (key, ttl) {
            var curtime = +new Date();
            _checkKey(key);
            ttl = Number(ttl) || 0;
            if (key in _storage) {

                if (!_storage.__jstorage_meta) {
                    _storage.__jstorage_meta = {};
                }
                if (!_storage.__jstorage_meta.TTL) {
                    _storage.__jstorage_meta.TTL = {};
                }

                // Set TTL value for the key
                if (ttl > 0) {
                    _storage.__jstorage_meta.TTL[key] = curtime + ttl;
                } else {
                    delete _storage.__jstorage_meta.TTL[key];
                }

                _save();

                _handleTTL();
                return true;
            }
            return false;
        },

        /**
        * Deletes everything in cache.
        *
        * @return true
        */
        flush: function () {
            _storage = {};
            _save();
            return true;
        },

        /**
        * Returns a read-only copy of _storage
        *
        * @returns Object
        */
        storageObj: function () {
            function F() { }
            F.prototype = _storage;
            return new F();
        },

        /**
        * Returns an index of all used keys as an array
        * ['key1', 'key2',..'keyN']
        *
        * @returns Array
        */
        index: function () {
            var index = [], i;
            for (i in _storage) {
                if (_storage.hasOwnProperty(i) && i != "__jstorage_meta") {
                    index.push(i);
                }
            }
            return index;
        },

        /**
        * How much space in bytes does the storage take?
        *
        * @returns Number
        */
        storageSize: function () {
            return _storage_size;
        },

        /**
        * Which backend is currently in use?
        *
        * @returns String
        */
        currentBackend: function () {
            return _backend;
        },

        /**
        * Test if storage is available
        *
        * @returns Boolean
        */
        storageAvailable: function () {
            return !!_backend;
        },

        /**
        * Reloads the data from browser storage
        *
        * @returns undefined
        */
        reInit: function () {
            var new_storage_elm, data;
            if (_storage_elm && _storage_elm.addBehavior) {
                new_storage_elm = document.createElement('link');

                _storage_elm.parentNode.replaceChild(new_storage_elm, _storage_elm);
                _storage_elm = new_storage_elm;

                /* Use a DOM element to act as userData storage */
                _storage_elm.style.behavior = 'url(#default#userData)';

                /* userData element needs to be inserted into the DOM! */
                document.getElementsByTagName('head')[0].appendChild(_storage_elm);

                _storage_elm.load("jStorage");
                data = "{}";
                try {
                    data = _storage_elm.getAttribute("jStorage");
                } catch (E5) { }
                _storage_service.jStorage = data;
                _backend = "userDataBehavior";
            }

            _load_storage();
        }
    };

    // Initialize jStorage
    _init();

})(window.$ || window.jQuery);