﻿// ------------------------------------------------------------------------------------------ //
// Name: Header
// Authors: Rich Howard & Amar Mehan
// Copyright: Next PLC
// Description: A collection of functions and plugins used by the Header.
//              Contains triggers and plugins for Mega Nav and resizeHeader.
//              The majority of code lives in megaNav which follows the generic jQuery plugin pattern.
// ------------------------------------------------------------------------------------------ //

// Enable support for CORS (Cross Origin Resource Sharing).
jQuery.support.cors = true;

var HidePrimaryNavigation = false;

// -----------------------------------------TRIGGERS----------------------------------------- //

//function loadTriggers() {
//    // ONCE THE PAGE HAS LOADED, GO THROUGH AND INITIALIZE ALL OF OUR CONTENT THAT WE DIDN'T WANT TO LOAD AS PART OF THE INITAL PAGE WEIGHT
//    $(window).ready(function () {
//        // For anything other than IE6 and below, build up the Mega Nav
//        if (!($.browser.msie && $.browser.version < "7.0")) {
//            try {
//                $('#MainNavigation').megaNav();
//            } catch (e) {
//            }            
//        }

//        $('#newsearch').bind('submit', function (e) {
//            return submitSearch();
//        });
//    });
//}

// WHEN THIS FILE IS PARSED FIRE THE loadTriggers ABOVE
//loadTriggers();


$(function () {
    if (!($.browser.msie && $.browser.version < 7)) {
        try {
            $('#MainNavigation').megaNav();
        } catch (e) {
        }
    }

    $('#newsearch').bind('submit', function (e) {
        return submitSearch();
    });
});

// -----------------------------------------PLUGINS----------------------------------------- //

// MEGA NAV PLUGIN
(function ($) {
    //This is for fine tuning - as we're animating a large/compex item we need to 
    //fine tune the interval at which the animation happens.
   // jQuery.fx.interval = 35;
    
    // Settings
    var secondaryNavHeight = 402,
        primaryNavWidth = 976,
        slideTransitionSpeed = 400,
        slideEasing = 'easeInOutCubic',
        slideDistance = 550;
    

    // Globals for this plugin
    var primaryOpenTimer,
        primaryCloseTimer,
        secondaryTimer,
        tertiaryTimer,
        slideTimer,
        anchorTimer,
        liveItemIndex,
        targetItemIndex,
        mouseIsOver,
        elementAnimating,
        quaternaryElemHovered = null,
        primaryElemOpening = null,
        elemAwaitingSlide = null,
        slideInProgress = false,
        currentNavData = null,
        incomingNavData = null,
        outgoingNavData = null;

        var transitionSupport = false;
        //Detect IE 9 and below here.
        //There are more complete methods of detecting css transion support but they are more intensive
        //than just hard coding no support for IE9 and below. The CSS transitions will degrade gracefully 
        //anyway in browsers that we apply transitions to. This just covers us for most common browser use.
        if ($.browser.msie && $.browser.version < 10) {
           transitionSupport = false;
        }



    // Methods for this plugin
    var methods = {

        // -----------------------------------------INIT AND DESTROYS----------------------------------------- //

        // Init Method - sets up the Mega Nav ready for use
        init: function (options) {                        
            return this.each(function () {
                // Only do the following if the page actually contains the required elements
                if ($(this).length > 0) {
                    // Declare $this so we can use it within functions within functions and load any data stored by the initialized plugin
                    var $this = $(this),
                        data = $this.data('megaNavData');

                    // If the plugin hasn't been initialized yet, then do it
                    if (!data) {

                    //Close any open nav item when user clicks away from it
                        $(document).bind('click', function() {
                            if(!mouseIsOver) {
                               if($this.children('div.MainNavigation').children('ul.PrimaryNavigation').children('li.Department.Active').size() > 0) {
                                   targetItemIndex = -1;
                                        var el = $this.children('div.MainNavigation').children('ul.PrimaryNavigation').children('li.Department.Active');
                                       
                                       methods.verticalOut(el);
                                       
                                       // methods.primaryNavigationDeselected({ element:el, closeNow: true });
                                        liveItemIndex = -1;
                                        $(".PageHeader").removeClass("mouseOver");

                                        if (HidePrimaryNavigation)
                                            HeaderScrollState();
                                }   
                            }
                        });
                        
                    //Close any open nav item when window scrolls
                         $(window).scroll(function () {
                               if($this.children('div.MainNavigation').children('ul.PrimaryNavigation').children('li.Department.Active').size() > 0) {
                                         targetItemIndex = -1;
                                        var el = $this.children('div.MainNavigation').children('ul.PrimaryNavigation').children('li.Department.Active');
                                          methods.verticalOut(el);
                                        
                                        //methods.primaryNavigationDeselected({ element:el, closeNow: true });
                                        liveItemIndex = -1;
                                        $(".PageHeader").removeClass("mouseOver");
                                        
                                        if (HidePrimaryNavigation)
                                            HeaderScrollState();
                            }
                        });

    if(!isTouchEnabled){
                             $this.children('div.MainNavigation.MegaNavEnabledNavigation').children('ul.PrimaryNavigation').children('li.Department').children('a.DepartmentLink').each(function(){
                                    $(this).hoverIntent(topLevelConfig);
                            });
                
                
                            $this.children('div.MainNavigation.MegaNavEnabledNavigation').children('ul.PrimaryNavigation').children('li.Department').children('a.DepartmentLink').bind('click', function (event) {

                                return false;
                            });


        }else{

                            $this.children('div.MainNavigation.MegaNavEnabledNavigation').children('ul.PrimaryNavigation').children('li.Department').children('a.DepartmentLink').bind('click', function (event) { 
                                if($(this).parent().hasClass("Active")){
                                    methods.quickHideSecondaryNav();
                                  }else{
                                    methods.primaryNavigationSelected({ element: $(this).parent() });
                                  }

                              return false;
            });

        }
                   



                        // For the PrimaryNavigation, we want it to appear on mouse click 
                        //Remove onclick event for primary nav items
//                        $('div.MainNavigation ul.PrimaryNavigation li.Department').each(function() {
//                            var link = $(this).find('a.DepartmentLink');
//                            $(link).unbind('click');
//                            var origOnClick = $(link).attr('onClick');
//                            $(link).attr('origOnClick', origOnClick);
//                            $(link).removeAttr("onclick");
//                        });
//                        $this.children('div.MainNavigation.MegaNavEnabledNavigation').children('ul.PrimaryNavigation').children('li.Department').children('a.DepartmentLink').bind('click', function (event) {
//                            //TrackLinkID(this);
//                            methods.primaryNavigationSelected({ element: $(this).parent() });
//                            return false;
//                        });
                    }
                }
            });            
        },
        topHover: function(){
                     $(this).addClass("deptHover");
                    if($(this).parent().hasClass("Active")){return false;}

                     methods.primaryNavigationSelected({ element: $(this).parent() });

                     return false;
        },
        topHoverOut: function(obj){


  
         if($(this).hasClass("DepartmentLink")){
             $(this).removeClass("deptHover");
         }

                if(!mouseIsOver){


                     if($(obj).hasClass("SecondaryNavigation")){
                  

                            setTimeout(function(){
                                       var sn = $(obj);

                                       var parentStillActive = false;
                                        
                                       if(sn.parent().find("a.DepartmentLink").hasClass("deptHover")){
                                     
                                            parentStillActive = true;
                                       }
                              

                                         if(!mouseIsOver && !parentStillActive){
                                            sn.removeClass("SNAnimateDown").removeClass("SNStaticDown").removeClass("SNStaticLive");
                                            sn.parent().removeClass("Active"); 
                                         }
                            },400);


                     }else{
               
                    

                      var  sn = $(this).parent().find(".SecondaryNavigation");
                         sn.removeClass("SNAnimateDown").removeClass("SNStaticDown").removeClass("SNStaticLive");
                         sn.parent().removeClass("Active"); 
                     }

             
               
                }
        },
        // When a department is hovered away from, this function will be called (accepts an 'element' param that is the 'li.Department' object)
        departmentInit: function (params) {



            // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element);
            
            //Allow menu to be closed by clicking away from it
            $(element).children('div.SecondaryNavigation').bind('mouseleave', function() {
                mouseIsOver = false;
                methods.topHoverOut($(this));
            });

            $(element).children('div.SecondaryNavigation').bind('mouseover', function() {
                mouseIsOver = true;
            });

            $(element).children('div.SecondaryNavigation').find(".ProductsContainer").bind('mouseover', function() {
                
                $(element).children('div.SecondaryNavigation').find(".CollectionsContainer ").addClass("grayscale");

               });

                $(element).children('div.SecondaryNavigation').find(".ProductsContainer").bind('mouseleave', function() {

                    $(element).children('div.SecondaryNavigation').find(".CollectionsContainer ").removeClass("grayscale");
               });


               if($(element).find('div.ProductsContainer').find('.TertiaryNavigation').length){
             
                $(element).find('div.ProductsContainer').addClass("withTertiary");
               }


            // When the mouse enters an li, we want to make sure the first child of each Navigation level is set to active by default
            // Note we use the children method and not find or the generic jQuery selector because we only want direct decendents (find will traverse the object)
            $(element).children('div.SecondaryNavigation').children('div.ComponentContainer').children('ul.Component').children('li.ComponentItem')
            .children('div.TertiaryNavigation').children('ul.Component').children('li.ComponentItem')
            .children('div.QuaternaryNavigation').bind('mouseenter', function () {
                methods.quaternaryNavigationSelected({ element: $(this) });
            });

            if(isTouchEnabled){

             $(element).children('div.SecondaryNavigation').children('div.ComponentContainer').children('ul.Component').children('li.ComponentItem')
                .children('div.TertiaryNavigation').children('ul.Component').children('li.ComponentItem').children("div.Text").find("a").bind('click', function () {
                    
                    //$(this).children("div.Text").find("a").click();
                     methods.quickHideSecondaryNav();

                });

            
            }else{
            
          

                $(element).children('div.SecondaryNavigation').children('div.ComponentContainer').children('ul.Component').children('li.ComponentItem')
                .children('div.TertiaryNavigation').children('ul.Component').children('li.ComponentItem').bind('mouseenter', function () {
     
                    if (!(methods.slideComponent({ element: $(this) })))
                        methods.tertiaryNavigationSelected({ element: $(this) });
                });

            }
          

            
            var config = {    
                over: secondaryHover, // function = onMouseOver callback (REQUIRED)    
                timeout: 100, // number = milliseconds delay before onMouseOut    
                out: secondaryHoverOut,
                 sensitivity: 15, 
                 interval: 50
                };

      


            $(element).children('div.SecondaryNavigation').children('div.ComponentContainer').children('ul.Component').children('li.MegaNavEnabled').each(function() {
             $(this).hoverIntent(config);
            });

            function  secondaryHover() {
         
             if(!isTouchEnabled){
        
                 if (!(methods.slideComponent({ element: $(this) })))
                                 methods.secondaryNavigationSelected({ element: $(this), forceNoDelay: false, animateColExpand: false });
            
             }
              
            
            }

            function  secondaryHoverOut() {
                //Do nothing for now - needs to be passed in as hoverIntent parameter
                return false;
            }

              if(isTouchEnabled){

               $(element).children('div.SecondaryNavigation').find('li.ComponentItem > div.Text').each(function(){
                 
                          var textBlock = $(this);
                       
                          if(textBlock.closest("li").find(".TertiaryNavigation").length){

                              $(textBlock).bind('click', function (event) {
                                    var innerLink = $(this).find("a");
                                    if($(this).parent().hasClass("Active")){


                                    var tempLink = innerLink.clone();
                                    var handlerString = innerLink.attr("data-click");
                                    tempLink.attr("onclick",handlerString);
                                     
                                    tempLink.click();
                                  
                                        methods.quickHideSecondaryNav();

                                    }else{
                                        methods.secondaryNavigationSelected({ element: $(this).parent(), forceNoDelay: false, animateColExpand: false });
                                   
                                        //var handlerString = innerLink.attr("data-click");
                                        //innerLink.attr("onclick",handlerString);

                                        }
                              });

                        }else{
                      
                          $(textBlock).bind('click', function (event) { 
                    
                            //var innerLink = $(this).find("a");
                      
                            // innerLink.click();
                           // methods.quickHideSecondaryNav();


                          });
                        }



               });

                 $(element).children('div.SecondaryNavigation').find('li.ComponentItem > div.Text > a').each(function () {

                        var anchor = $(this);

                         if(anchor.closest("li").find(".TertiaryNavigation").length){

                             var clickHander = anchor.attr("onclick");
                             anchor.removeAttr("onclick");
                             anchor.attr("data-click",clickHander);

                             $(anchor).bind('click', function (event) {

                                    var parentLI = $(this).closest("li");
                
//                                    if(!parentLI.hasClass("Active")){
//                                        $(this).parent().click();
//                                    }else{
//                                     methods.quickHideSecondaryNav();
//                                    }
                                $(this).parent().click();

                              return false;

                            });

                         }else{
                            $(anchor).bind('click', function (event) {
                                     methods.quickHideSecondaryNav();
                            });
                         
                         }

                });

              }
            

            if(!isTouchEnabled){
       
                    // When the user clicks on the are around a link, trigger the link click
                    $(element).children('div.SecondaryNavigation').find('li.ComponentItem > div.Text > a').each(function () {

                        var anchor = $(this);

                        $(anchor).bind('click', function (event) {
                            event.stopPropagation();
                            methods.secondaryNavigationAnchorClicked({ element: $(this), anchor: anchor });
                        });

                        $(anchor).parent().bind('click', function (event) {
                            clearTimeout(anchorTimer);

                            anchorTimer = setTimeout(
                                function () {
                                    if ($(anchor).attr('onclick'))
                                        $(anchor).trigger('click');
                                    else
                                    {
                                        var pathToOpen = $(anchor).attr('href');
                                        if (pathToOpen.indexOf(location.host) == -1 && pathToOpen.indexOf("http://") == 0) {
                                            window.open(pathToOpen, "_blank");
                                        }
                                        else
                                            window.location = pathToOpen;
                                        methods.secondaryNavigationAnchorClicked({ element: $(this), anchor: anchor });
                                    }
                                }
                                , 100
                            );
                        });
                    });
            }

            $(element).find('div.QuaternaryNavigation a, li.GlobalSizeLinks a').bind('click',function (event) {
                    $('.Department').each(function () {
                        methods.primaryNavigationDeselected({ element: $(this), closeNow: true });
                    });
            });

            // If we have Components and Products then we may be animating, so lets float the Products Right to help us
            if (($(element).children('div.SecondaryNavigation').children('div.CollectionsContainer').size() > 0) && ($(element).children('div.SecondaryNavigation').children('div.ProductsContainer').size() > 0)) {
                $(element).children('div.SecondaryNavigation').children('div.ProductsContainer').css('float', 'right');
            }

        },

        // Destroy Method
        destroy: function () {
            return this.each(function() {
                var $this = $(this),
                    data = $this.data('megaNavData');
                    $(window).unbind('.megaNavData');
                    data.megaNavData.remove();
                    $this.removeData('megaNavData');
            });
        },
        
        // -----------------------------------------PRIMARY NAV BOUND EVENTS----------------------------------------- //

        // When a department is hovered away from, this function will be called (accepts an 'element' param that is the 'li.Department' object)
        primaryNavigationDeselected: function (params) {
        //return false;
            // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element),
                closeNow = params.closeNow;

         

            if (closeNow)
                methods.primaryNavigationCollapse({ element: element });
            else {
                // Wait a bit, then slide the SecondaryNavigation closed, then remove the Active class
                primaryCloseTimer = setTimeout(
                    function () {
                        methods.primaryNavigationCollapse({ element: element });
                    },
                    400
                );
            }
        },

        // When a department is hovered over, this function will be called (accepts an 'element' param that is the 'li.Department' object)
        primaryNavigationSelected: function (params) {
            
            // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element);
         
          
            
           // clearTimeout(primaryOpenTimer);

             if (element.hasClass('Active') && (element.hasClass('MegaNavEnabled'))) {
                methods.verticalOut(element);
                    //methods.primaryNavigationCollapse(params);
                    return false;
              }

            TrackLinkID(element.children("a"));


            // If this department is already active or this is not a Mega Nav, then go to the landing page
            if (!(element.hasClass('Active')) && (element.hasClass('MegaNavEnabled'))) {
          
                var closeOtherDept = false;

                // Close any open Departments
                if (element.parent().children('li.Active').size() > 0) {
                    closeOtherDept = true;
                }

                // Load this department - the primaryElemOpening will make sure we don't open and leave it open if we hover away before this department has finished loading
                primaryElemOpening = element;

                targetItemIndex = element.index();
                if(closeOtherDept) {
                    //var closeElement = element.parent().children('li.Active');
                    //methods.primaryNavigationDeselected({ element:closeElement, closeNow: true });
                }
            
                methods.loadSecondaryNavigation({ element: element });

            }

            


        },
        
        // -----------------------------------------PRIMARY NAV ACTIONS----------------------------------------- //

        // This function actually expands out the PrimaryNavigation
        primaryNavigationCollapse: function (params) {

           methods.quickHideSecondaryNav();

            return false;

           // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element);

                element.removeClass("Active");

            var isFading = false;
            //Calculate animation direction
            var animationDirection = "-=";
            if(liveItemIndex > targetItemIndex) {
                animationDirection = "+=";
            }
            
            //If there is no target item, fade current item out as we have no left/right context
            if(targetItemIndex == -1) {
                element.children('div.SecondaryNavigation').fadeOut(300, function () {
                        element.children('div.SecondaryNavigation').css('left', -9999).css('right', 'auto');
                               // If we have Components and Products in the container we are closing we need to stop it from floating right
                                if (($(element).children('div.SecondaryNavigation').children('div.CollectionsContainer').size() > 0) && ($(element).children('div.SecondaryNavigation').children('div.ProductsContainer').size() > 0)) {
                                    $(element).children('div.SecondaryNavigation').children('div.ProductsContainer').css('float', 'left');
                                }
                                element.removeClass('Active');

                                // Make the Primary Nav Collapse if we are not at the top of the page
                                if (HidePrimaryNavigation)
                                    HeaderScrollState();
                });

                return false;
            }

            //Else - need to animate within context of next selected item
            element.children('div.SecondaryNavigation').animate(
                {
                    left: animationDirection + slideDistance,
                    opacity: 0
                },slideTransitionSpeed,slideEasing,
                function(){
                    element.children('div.SecondaryNavigation').css('left', -9999).css('right', 'auto');
                    if (($(element).children('div.SecondaryNavigation').children('div.CollectionsContainer').size() > 0) 
                    && ($(element).children('div.SecondaryNavigation').children('div.ProductsContainer').size() > 0)) 
                            {
                                $(element).children('div.SecondaryNavigation').children('div.ProductsContainer').css('float', 'left');
                            }
                                element.removeClass('Active');
                });
        },
        //This method quickly hides the secondary nav, regardless of browser
        quickHideSecondaryNav: function(){
        
         if(elementAnimating){
            return false;
        }

        setTimeout(function(){

                $("#MainNavigation div.SecondaryNavigation").each(function(){

                    $(this).removeClass("SNAnimateDown").removeClass("SNStaticDown").removeClass("SNStaticLive");
                    $(this).parent().removeClass("Active");
                });

            },100);

        },
        
        // This function loads SecondaryNavigation data and then calls the primaryNavigationExpand function
        loadSecondaryNavigation: function (params) {
      
        if(elementAnimating){
            return false;
        }
            // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element);
      
            // If we have already downloaded the content, then show it, otherwise download it
            if (element.children('div.SecondaryNavigation').hasClass('ContentLoaded')) {
        
                methods.primaryNavigationExpand({ element: element });
            }
            else {
            
                // Figure out the path and hostname.
                var link = "";
                var host = "";
                var anchorLink = "";
                
//                if (element.children('div.DepartmentText').children('a.DepartmentLink').size() > 0)
//                    link = element.children('div.DepartmentText').children('a.DepartmentLink')[0];
//                else if (element.children('a.DepartmentLink').size() > 0)
                    link = element.children('a.DepartmentLink')[0]
                                
                host = siteAssetsUrl;
                anchorLink = link.pathname;
                
                //Make sure we have slash before given path
                if(anchorLink.substring(0,1) != "index.html")
                    anchorLink = "/" + anchorLink;
                
                //debugger;
                var parentLinkID = $(link).attr("data-link-id");
                var parentLinkName = $(link).attr("data-link-name");

                var path = host + '/menu/meganav' + anchorLink + '?contentonly=true&parentLinkID=' + parentLinkID + '&parentLinkName=' + parentLinkName;
                
                if (host.indexOf("https") != -1) {
                    path += "&SecureAssets=true";
                }

                //Expand the nav now so user isn't waiting for something to happen. Then we can bind the data
                //as sooon as it is ready
               methods.primaryNavigationExpand({ element: element });

                // Send the request
                $.ajax({
                    url: path,
                    type: "GET",
                    async: true,
                    timeout: 10000,
                    crossDomain: true,
                    success: function (data, textStatus, jqXHR) {
						checkAndRedirectForAjaxError(jqXHR, false, 'Header.js: loadSecondaryNavigation');
                        //element.children('div.SecondaryNavigation').html(data);  
                        currentNavData = data;
                        methods.measureMenu(data, element);
                        primaryElemOpening = null;
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                     
                        element.removeClass('MegaNavEnabled');
                        primaryElemOpening = null;

                        // There isn't a meganav for this department, so reinstate the onclick and trigger it
                        $(link).unbind('click');
                        var origOnClick = $(link).attr('data-onclick');
                        $(link).attr('onclick', origOnClick);
                        $(link).removeAttr("origOnClick");
                        $(link).trigger('click');
                    }
                });
            }
        },

        // This function actually expands out the PrimaryNavigation
        primaryNavigationExpand: function (params) {
           
          
          //methods.horizontalTransition(params);
          //methods.maskedHorizontalTransition(params);
          methods.verticalTransition(params);

        },
        //Vertically animate out the secondary navigation
        verticalOut:function(element){

         if(elementAnimating){
            return false;
        }

  
          if(!transitionSupport){
            methods.quickHideSecondaryNav();
            return false;
          }

            //var element = $(params.element);
            element.removeClass("Active");
            var outgoingNav =  element.children('div.SecondaryNavigation');

            var maskingRegionOut = $("<div class=\"MaskingRegion\" />");

            outgoingNav.removeClass("SNAnimateDown");
            outgoingNav.wrap(maskingRegionOut);
            outgoingNav.addClass("SNStaticDown");

            setTimeout(function(){
                outgoingNav.addClass("SNAnimateUp");
            },10);

             setTimeout(function(){
                outgoingNav.unwrap();
                outgoingNav.removeClass("SNStaticUp").removeClass("SNAnimateUp").removeClass("SNStaticDown");
            },510);
      
        },
        //Horizontally animate out the secondary navigation
        horizontalOut: function(params){

        var element = $(params.element);
   
        var outgoingNav =  element.children('div.SecondaryNavigation');

             outgoingNav.addClass("SNOpacityOut");
             element.removeClass("Active");
              setTimeout(function(){
                  outgoingNav.removeClass("SNOpacityOut").removeClass("SNAnimateLeft")
                 .removeClass("SNAnimateRight").removeClass("SNStaticLeft")
                 .removeClass("SNStaticRight").removeClass("SNAnimateLive")
                 .removeClass("SNHiddenLive").removeClass("SNOpacityIn");
            },900);
        },

        verticalTransition: function(params){

                  var element = $(params.element);
                  var incomingLink = element;
                  var outgoingLink = $('ul.PrimaryNavigation').children(".Active");

                  var incomingNav = element.children('div.SecondaryNavigation');
                  var outgoingNav = outgoingLink.find('div.SecondaryNavigation');

                  var outgoingIndex = -1;
                   
                  incomingLink.addClass("Active");
                  outgoingLink.removeClass("Active");

                  if(transitionSupport){
                  elementAnimating = true;
                      if(outgoingLink.length){
                        //Animate old menu out
                        var maskingRegionOut = $("<div class=\"MaskingRegion\" />");
                         outgoingNav.removeClass("SNAnimateDown");
                        outgoingNav.wrap(maskingRegionOut);
                        outgoingNav.addClass("SNStaticDown");
                           setTimeout(function(){
                                outgoingNav.addClass("SNAnimateUp");
                            },10);
                        
                         

                        //Clean up old menu and animate in new
                        setTimeout(function(){

                            outgoingNav.unwrap();
                            outgoingNav.removeClass("SNStaticUp");
                            outgoingNav.removeClass("SNAnimateUp");
                            outgoingNav.removeClass("SNStaticDown");
                           
                            //Now animate new menu in
                            var maskingRegion = $("<div class=\"MaskingRegion\" />");
                            incomingNav.wrap(maskingRegion);
                            incomingNav.addClass("SNStaticUp");
                            setTimeout(function(){
                                incomingNav.addClass("SNAnimateDown");
                            },10);

                            setTimeout(function(){
                                incomingNav.unwrap();
                                elementAnimating = false;
                            },500);

                            if(!incomingNav.hasClass("ContentLoaded")){
                               // var loadingGif = $("<img src=\"/Images/Structural/Header/Navigation/Common/ajax_bar.gif\" class=\"loadingBar\" />");
                                //incomingNav.append(loadingGif);
                                //Don't bind the data straight away as this will cause the menu to stutter
                                //wait until the animation is complete
                                setTimeout(function(){
                                    methods.bindMenuData(element);
                                },500);
                            }

                        },400);


                      }else{
                             var maskingRegion = $("<div class=\"MaskingRegion\" />");
                            incomingNav.wrap(maskingRegion);
                            incomingNav.addClass("SNStaticUp");
                            setTimeout(function(){
                                incomingNav.addClass("SNAnimateDown");
                            },10);

                            setTimeout(function(){
                                incomingNav.unwrap();
                                incomingNav.removeClass("SNStaticUp");
                                elementAnimating = false;
                            },500);

                            if(!incomingNav.hasClass("ContentLoaded")){
                               // var loadingGif = $("<img src=\"/Images/Structural/Header/Navigation/Common/ajax_bar.gif\" class=\"loadingBar\" />");
                                //incomingNav.append(loadingGif);
                                //Don't bind the data straight away as this will cause the menu to stutter
                                //wait until the animation is complete
                                setTimeout(function(){
                                    methods.bindMenuData(element);
                                },500);
                            }
                      
                      }

                  }else{                       
                        outgoingNav.removeClass("SNStaticLive");
                        incomingNav.addClass("SNStaticLive");

                        if(!incomingNav.hasClass("ContentLoaded")){
                            //var loadingGif = $("<img src=\"/Images/Structural/Header/Navigation/Common/ajax_bar.gif\" class=\"loadingBar\" />");
                           // incomingNav.append(loadingGif);
                            methods.bindMenuData(element);
                        }
                }
        
        },
        maskedHorizontalTransition: function(params){
        
          var element = $(params.element);
          var incomingLink = element;
          var outgoingLink = $('ul.PrimaryNavigation').children(".Active");

          var incomingNav = element.children('div.SecondaryNavigation');
          var outgoingNav = element.parent().children('li.Active').children('div.SecondaryNavigation');
          var outgoingIndex = -1;
          if(outgoingLink.length){
            outgoingIndex = outgoingLink.index();
          }
          var incomingIndex = incomingLink.index();

              outgoingLink.removeClass("Active");
              incomingLink.addClass("Active");

          if(transitionSupport){
        
              //If there is no outgoing link, just fade element in
              if(outgoingIndex == -1){
            
                incomingNav.addClass("SNHiddenLive");
                setTimeout(function(){
                    incomingNav.addClass("SNOpacityIn");
                    if(!incomingNav.hasClass("ContentLoaded")){
                        var loadingGif = $("<img src=\"/Images/Structural/Header/Navigation/Common/ajax_bar.gif\" class=\"loadingBar\" />");
                        incomingNav.append(loadingGif);
                        //Don't bind the data straight away as this will cause the menu to stutter
                        //wait until the animation is complete
                        setTimeout(function(){
                            methods.bindMenuData(element);
                        },550);
                    }
                },10);
                //incomingNav.addClass("SNStaticLive");
                
              }else{

                    incomingNav.addClass("SNStaticLive");

                    var maskingRegion = $("<div class=\"MaskingRegion\" />");

                    outgoingNav.wrap(maskingRegion);
                    outgoingNav.addClass("SNStaticPreSwipe");

                 setTimeout(function(){
                    outgoingNav.addClass("SNSwipeRight");
                 },10);
       
                //If we haven't yet loaded the menu content
                if(!incomingNav.hasClass("ContentLoaded")){
                    var loadingGif = $("<img src=\"/Images/Structural/Header/Navigation/Common/ajax_bar.gif\" class=\"loadingBar\" />");
                    incomingNav.append(loadingGif);
                    //Don't bind the data straight away as this will cause the menu to stutter
                    //wait until the animation is complete
                    setTimeout(function(){
                        methods.bindMenuData(element);
                    },550);
                }
                //Restore outgoing nav to default state after animation
                 setTimeout(function(){
                 outgoingNav.unwrap();
                        outgoingNav.removeClass("SNAnimateLeft");
                        outgoingNav.removeClass("SNAnimateRight");
                        outgoingNav.removeClass("SNStaticLeft");
                        outgoingNav.removeClass("SNStaticRight");
                        outgoingNav.removeClass("SNAnimateLive");
                        outgoingNav.removeClass("SNHiddenLive");
                        outgoingNav.removeClass("SNOpacityIn");
                        outgoingNav.removeClass("SNStaticPreSwipe");
                        outgoingNav.removeClass("SNSwipeRight");
                        outgoingNav.removeClass("SNStaticLive");
                    },1600);

              }
          
          }else{
          
            outgoingNav.removeClass("SNStaticLive");
            incomingNav.addClass("SNStaticLive");

            if(!incomingNav.hasClass("ContentLoaded")){
                var loadingGif = $("<img src=\"/Images/Structural/Header/Navigation/Common/ajax_bar.gif\" class=\"loadingBar\" />");
                incomingNav.append(loadingGif);
                methods.bindMenuData(element);
            }

          }
        
        
        },
        horizontalTransition: function(params){
          var element = $(params.element);
          var incomingLink = element;
          var outgoingLink = $('ul.PrimaryNavigation').children(".Active");

          var incomingNav = element.children('div.SecondaryNavigation');
          var outgoingNav = element.parent().children('li.Active').children('div.SecondaryNavigation');
          var outgoingIndex = -1;
          if(outgoingLink.length){
            outgoingIndex = outgoingLink.index();
          }
          var incomingIndex = incomingLink.index();

              outgoingLink.removeClass("Active");
              incomingLink.addClass("Active");

          if(transitionSupport){
        
              //If there is no outgoing link, just fade element in
              if(outgoingIndex == -1){
            
                incomingNav.addClass("SNHiddenLive");
                setTimeout(function(){
                    incomingNav.addClass("SNOpacityIn");
                    if(!incomingNav.hasClass("ContentLoaded")){
                        var loadingGif = $("<img src=\"/Images/Structural/Header/Navigation/Common/ajax_bar.gif\" class=\"loadingBar\" />");
                        incomingNav.append(loadingGif);
                        //Don't bind the data straight away as this will cause the menu to stutter
                        //wait until the animation is complete
                        setTimeout(function(){
                            methods.bindMenuData(element);
                        },550);
                    }
                },10);
                //incomingNav.addClass("SNStaticLive");
                
              }else{
          
                //Calulate where we animate in from
                if(outgoingIndex < incomingIndex){
                  
                    outgoingNav.addClass("SNStaticLeft");
                    incomingNav.addClass("SNStaticRight");
                }else{
                   
                    outgoingNav.addClass("SNStaticRight");
                    incomingNav.addClass("SNStaticLeft");
                }
                //Animate in from either left or right
                setTimeout(function(){
                    incomingNav.addClass("SNAnimateLive");
                    incomingNav.removeClass("SNStaticLeft");
                    incomingNav.removeClass("SNStaticRight");

                },10);
                //If we haven't yet loaded the menu content
                if(!incomingNav.hasClass("ContentLoaded")){
                    var loadingGif = $("<img src=\"/Images/Structural/Header/Navigation/Common/ajax_bar.gif\" class=\"loadingBar\" />");
                    incomingNav.append(loadingGif);
                    //Don't bind the data straight away as this will cause the menu to stutter
                    //wait until the animation is complete
                    setTimeout(function(){
                        methods.bindMenuData(element);
                    },550);
                }
                //Restore outgoing nav to default state after animation
                 setTimeout(function(){
                        outgoingNav.removeClass("SNAnimateLeft");
                        outgoingNav.removeClass("SNAnimateRight");
                        outgoingNav.removeClass("SNStaticLeft");
                        outgoingNav.removeClass("SNStaticRight");
                        outgoingNav.removeClass("SNAnimateLive");
                        outgoingNav.removeClass("SNHiddenLive");
                        outgoingNav.removeClass("SNOpacityIn");
                    },600);

              }
          
          }else{
          
            outgoingNav.removeClass("SNStaticLive");
            incomingNav.addClass("SNStaticLive");

            if(!incomingNav.hasClass("ContentLoaded")){
                var loadingGif = $("<img src=\"/Images/Structural/Header/Navigation/Common/ajax_bar.gif\" class=\"loadingBar\" />");
                incomingNav.append(loadingGif);
                methods.bindMenuData(element);
            }

          }
        
        },

        measureMenu: function(data, element){
       
        var incomingNav = $(element).find('div.SecondaryNavigation');

        var wrapper = $("<div />");

        $(wrapper).html(data);

            var colCount = 0;
            var targetWidth = 0;
            //Count number of columns in this secondary nav item
            //Hard code target width here as we can't actually measure the content without binding to
            //the page - this way is quicker. Just need to make sure that the widths below correspond to the target CSS classes
            //Given width's include border and left/right margin
            $(wrapper).children(".ComponentContainer").each(function(){

                if($(this).hasClass("Cols-1")){
                    colCount += 1;
                    targetWidth += 183;
                }

                if($(this).hasClass("Cols-2")){
                    colCount += 2;
                    targetWidth += 350;
                }

                if($(this).hasClass("Cols-3")){
                    colCount += 3;
                    targetWidth += 533;
                }
                
                if($(this).hasClass("Cols-4")){
                    colCount += 4;
                }

            });

            //If the column count is less than 5, we should measure the menu as it may not extend to the full extent of the page
             if(colCount < 5){
                incomingNav.width(targetWidth);
                incomingNav.find(".Cols-3").remove();

                var pMenuWidth = 976;

                var targetLeft = element.offset().left;

                if(targetLeft + targetWidth > pMenuWidth){
                    targetLeft = (pMenuWidth - targetWidth) - 10;
                }


                incomingNav.css("left",targetLeft);
             }
        
        },
        bindMenuData: function(element){
 
        var sNav = element.children('div.SecondaryNavigation');

        if(!sNav.length){
            sNav = element.find('div.SecondaryNavigation');
        }
    
         if(currentNavData){

         sNav.empty();

            sNav.html(currentNavData);
            sNav.addClass('ContentLoaded');
            currentNavData = null;

            // Foreach Component Container, find the first element and set it to active
            sNav.children('div.ComponentContainer').each(function () {
                // Only open up the Collections and Products by default
                if ($(this).hasClass('CollectionsContainer') || $(this).hasClass('ProductsContainer')) {
                    methods.secondaryNavigationSelected({ element: $(this).children('ul.Component').children('li.MegaNavEnabled').first(), forceNoDelay: true, animateColExpand: false });
                }

                // Load any promo images if required
                if ($(this).hasClass('PromotionsContainer')) {
                    element.find('img[data-src]').each(function () {
                        if (!($(this).attr('src'))) {
                            var imgSrc = $(this).attr('data-src');
                            $(this).attr('src', imgSrc);
                            $(this).load(function () {
                                $(this).parent().parent().fadeTo(200, 1.0);
                            });
                        }
                    });
                }
            });

            // Init the department so we get all the bindings

             //if ($.browser.msie && $.browser.version < 9) {
             
             //Delay initialising the menu inner functionality - gives the browser 
             //a chance to bind the full menu to the page without stuttering
               // setTimeout(function(){ },200);

                methods.departmentInit({ element: element });
//             }else{
//                methods.departmentInit({ element: element });
//             }


          

          }else{
              setTimeout(function(){
                methods.bindMenuData(element);
              },10);
          }
          //////////////////////

          

        
        },
                
        // -----------------------------------------SECONDARY NAV----------------------------------------- //
        
        // When a secondaryNavigation element is hovered over, this function will be called (accepts an 'element' param that is the 'li.ComponentItem' object)
        secondaryNavigationSelected: function (params) {

          
            // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element),
                container = element.parent().parent(),
                useActiveChild = false,
                forceNoDelay = params.forceNoDelay,
                animateColExpand = (params.animateColExpand === false) ? false : true;

            clearTimeout(primaryCloseTimer);
            clearTimeout(secondaryTimer);

            // If a Quaternary Nav element is hovered over, then it would have created a lock (quaternaryElemHovered)
            // This is to stop us from selecting a default value for a secondary or tertiary element when hovering back into a collections container from another container
            if (quaternaryElemHovered != null)
                return false;

            if (container.hasClass('ProductsContainer'))
                useActiveChild = true;

            // If we have a products container and it is in an expanded state, then we want to put a delay in before setting defaluts
            if (!forceNoDelay && useActiveChild && (container.children('ul').size() > 1) && (container.hasClass('Cols-3')) && !(element.parent().hasClass('ActiveChild'))) {
                secondaryTimer = setTimeout(
                    function () {
                        methods.secondaryNavigationSelectDefault({ element: element, container: container, useActiveChild: useActiveChild, animateColExpand: true });
                    },
                    100
                );
            }
            else
                methods.secondaryNavigationSelectDefault({ element: element, container: container, useActiveChild: useActiveChild, animateColExpand: animateColExpand });

        },

        // When a secondaryNavigation element is hovered over, this function will be called (accepts an 'element' param that is the 'li.ComponentItem' object)
        secondaryNavigationSelectDefault: function (params) {
            // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element),
                container = $(params.container),
                useActiveChild = params.useActiveChild,
                animateColExpand = params.animateColExpand,
                alreadyActiveChild = false;

            // SWITCH - if this is enabled, then we will check if there is enough space before setting the element as active
            var checkSpace = true,
                availableCols = 0;

            clearTimeout(secondaryTimer);

            if (useActiveChild) {
                // Clear any UL's with ActiveChild - we need to do this otherwise the Prodcuts won't render properly
                methods.setAllInactive({ element: element.parent().parent() });
                if (element.parent().hasClass('ActiveChild'))
                    alreadyActiveChild = true;
                methods.setAllInactiveChild({ element: element.parent().parent(), alreadyActiveChild: alreadyActiveChild });
            }
            else if (container.hasClass('CollectionsContainer')) {
                methods.setInactiveSiblings({ element: element });
            }
            else {
                // First of all clear any active elements
                methods.setAllInactive({ element: element.parent() });
            }

            // Check if there is enough space to show the element
            if (checkSpace)
                availableCols = methods.columnUsage({ element: element.parent().parent() }).colsAvailable;
            
            // Make this item active and set its parent to active
           // if ((container.hasClass('CollectionsContainer')) || (container.hasClass('ProductsContainer') && availableCols > 0)) {
            if ((container.hasClass('CollectionsContainer')) || container.hasClass('ProductsContainer')) {
            
                if (animateColExpand && !(alreadyActiveChild))
                {
                    if(element.parent().prev().length)
                    {
                        element.parent().addClass('ActiveChild',350);
                        element.addClass('Active');
                    }else{
                   
                        setTimeout(function(){
                        element.parent().addClass('ActiveChild');
                        element.addClass('Active');

                        },100);
                    }

                       

                    }else{
                    element.parent().addClass('ActiveChild');
                    element.addClass('Active');
                    }
            }

            // Foreach ComponentItem, find the first element and set it to active
            element.children('div.TertiaryNavigation').each(function () {
                if ($(this).children('ul.Component').children('li.Active').size() == 0)
                    methods.tertiaryNavigationSelected({ element: $(this).children('ul.Component').children('li.MegaNavEnabled').first() });
            });
        },

        // When a secondaryNavigation anchor is clicked on we need to do the same as what the hover did (this is for touch screen support)
        secondaryNavigationAnchorClicked: function (params) {

        methods.quickHideSecondaryNav();

               // Close the footer if it's visible.
                var curLiveFooterItem = $("li.FooterSection.Active");
                if (curLiveFooterItem.length) {
                    var openMenuItem = $(curLiveFooterItem).find(".opened");
                    footerItemOut(openMenuItem, curLiveFooterItem);
                }

            //Reset nav item selectors
            targetItemIndex = -1;
            liveItemIndex = -1;

             clearTimeout(anchorTimer);

            return false;

            // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element),
                anchor = $(params.anchor);

         
            // We could be dealing with a touch screen, so lets make the element active if we can
            if (!($(element).hasClass('Active')) && ($(element).hasClass('MegaNavEnabled'))) {
                if ($(element).parent().parent().hasClass('TertiaryNavigation')) {
                    if (!(methods.slideComponent({ element: $(element) })))
                        methods.tertiaryNavigationSelected({ element: $(element) });
                }
                else if ($(element).parent().parent().parent().hasClass('SecondaryNavigation')) {
                    if (!(methods.slideComponent({ element: $(element) })))
                        methods.secondaryNavigationSelected({ element: $(element) });
                }
                else {
                    $('.Department').each(function () {
                        methods.primaryNavigationDeselected({ element: $(this), closeNow: true });
                    });
                }
            }
            else {
                $('.Department').each(function () {
                    methods.primaryNavigationDeselected({ element: $(this), closeNow: true });
                });
            }
        },

        // When a tertiaryNavigation element is hovered over, this function will be called (accepts an 'element' param that is the 'li.ComponentItem' object)
        tertiaryNavigationSelected: function (params) {

          // $(params.element).children("div.Text").find("a").click();

             
            // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element);

            // SWITCH - if this is enabled, then we will check if there is enough space before setting the element as active
            var checkSpace = true;

            clearTimeout(primaryCloseTimer);
            clearTimeout(secondaryTimer);

            if (quaternaryElemHovered != null)
                return false;

               

            if (element.hasClass('MegaNavEnabled')) {
                // First of all clear any active elements
                methods.setAllInactive({ element: element.parent() });

                 
                // If there is enough space, show the element
                if (checkSpace || methods.columnUsage({ element: element.parent().parent().parent().parent().parent() }).colsAvailable > 0) {

                   


                    element.addClass('Active');
                    element.find('img[data-src]').each(function() {
                        if (!($(this).attr('src')))
                        {
                            var imgSrc = $(this).attr('data-src');
                            $(this).attr('src', imgSrc);
                            $(this).load(function() {
                                $(this).parent().parent().fadeTo(200,1.0);
                            });
                        }
                    });
                }
            }
        },

        // When a quaternaryNavigation element is hovered over, this function will be called (accepts an 'element' param that is the 'li.ComponentItem' object)
        quaternaryNavigationSelected: function (params) {

         
            // Set some variable values
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element);

            clearTimeout(primaryCloseTimer);
            clearTimeout(secondaryTimer);
            clearTimeout(slideTimer);

            // If this has been selected, then we need to put a lock on for a few moments, otherwise we'll be triggering a whole load of calculations we don't need to
            if (quaternaryElemHovered === null) {
                quaternaryElemHovered = element;
                tertiaryTimer = setTimeout(
                    function () {
                        quaternaryElemHovered = null;
                    }
                    , 30
                );
            }
        },
        
        // -----------------------------------------HELPERS----------------------------------------- //

        // Set All Inactive - removes the 'Active' class from any decendents (accepts an 'element' param that is any MegaNav object)
        setAllInactive: function (params) {
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element);

            // For Each Component Container
            element.find("li.Active").each(function () {
                $(this).removeClass('Active');
            });
        },

        // Set All Inactive Child - removes the 'ActiveChild' class from any decendents (accepts an 'element' param that is any MegaNav object)
        setAllInactiveChild: function (params) {
  
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element);

            // For Each Component Container
            element.find("ul.ActiveChild").each(function () {


            if($(this).prev().length && ! params.alreadyActiveChild){
              $(this).removeClass('ActiveChild',350);
            }else{
              $(this).removeClass('ActiveChild');
            }
            


              
            });
        },

        // Set Inactive Siblings- removes the 'Active' class from any decendents of siblings (accepts an 'element' param that is any MegaNav object)
        setInactiveSiblings: function (params) {
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element);

            // For Each Component Container
            element.parent().children().each(function () {
                if ($(this)[0] !== $(element)[0]) {
                    $(this).find('li.Active').each(function () {
                        $(this).removeClass('Active');
                    });
                    $(this).removeClass('Active');
                }
            });
        },

        // Column Usage - returns the number of empty columns on screen (accepts an 'element' param that is a 'Component' object)
        columnUsage: function (params) {
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element),
            colsVisible = 0,
                colsAvailable = 0,
                colsFillable = 0,
                colsMinFill = 0,
                componentsUsed = 0;

            // Find out how many elements this container has and compare it to how many Components it contains and what level we are at
            try {
                colsVisible = parseInt(element.attr('class').split(' Cols-')[1].split(' ')[0]);
            }
            catch (err) {
                colsVisible = 0;
            }

            componentsUsed = element.children().size();
            colsMinFill = componentsUsed;

            if (element.hasClass('CollectionsContainer')) {
                colsMinFill = (2 * componentsUsed);
                colsFillable = (2 * componentsUsed) + 1;
            }
            else if (element.hasClass('ProductsContainer'))
                colsFillable = componentsUsed + 1;

            colsAvailable = colsVisible - colsMinFill;

            return { colsAvailable: colsAvailable, colsFillable: colsFillable, colsMinFill: colsMinFill, colsVisible: colsVisible, componentsUsed: componentsUsed };
        },

        // GetWidthFromClass - returns the width for a given class
        getWidthFromClass: function (params) {
            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element),
                newClass = params.newClass;

            if ((element.hasClass('CollectionsContainer')) && newClass === 'Cols-3')
                return 590;
            /*else if ((element.hasClass('CollectionsContainer')) && newClass === 'Cols-2')
            return 415;*/
            else if ((element.hasClass('ProductsContainer')) && newClass === 'Cols-3')
                return 590;
            else if (newClass === 'Cols-3')
                return 525;
            else if (newClass === 'Cols-2')
                return 350;
            else
                return 175;
        },

        // Slide Component - collapses an available Component and expands a selected Component to be wider (accepts an 'element' param that is a 'Component' object)
        slideComponent: function (params) {

        ////////////////////////////IMPORTANT///////////////////////////////////////////////////////////////
        //THE SLIDE MECHANISM HAS BEEN DISABLED (POSSIBLY TEMPORARILY).  
        return false;
        ////////////////////////////////////////////////////////////////////////////////////////////////////


            var $this = $(this),
                data = $this.data('megaNavData'),
                element = $(params.element),
                elementContainer = element.parent(),
                availableCols = 0,
                fillableCols = 0,
                minFillableCols = 0,
                visibleCols = 0,
                usedComponents = 0,
                maxCols = 5,
                allowSlide = false,
                collapsableElem,
                expandableElem,
                hasCollections = false,
                hasProducts = false,
                elemAwaitingSlideIsChild = false;
                
            if (slideInProgress)
                return false;

            // Check if the elemAwaitingSlide is a child of this - if it is then we need to escape outta here (with a return true - because this is a slideComponent that is being handled by its child)
            if (elemAwaitingSlide != null) {
                element.children('div.TertiaryNavigation').children('ul.Component').children('li').each(function () {
                    if ($(this)[0] === $(elemAwaitingSlide)[0]) {
                        elemAwaitingSlideIsChild = true;
                    }
                });
            }
            if (elemAwaitingSlideIsChild)
                return true;

            // Stop any other slideComponents from firing if required
            clearTimeout(slideTimer);
            clearTimeout(secondaryTimer);

            // If this is a TertiaryNavigation element, then we need to override the container so it has the correct value
            if (elementContainer.parent().hasClass('TertiaryNavigation'))
                elementContainer = element.parent().parent().parent().parent();

            // Go through each visible ComponentContainer and figure out how many columns are required
            elementContainer.parent().parent().children('.ComponentContainer').each(function () {
                var colUsage = methods.columnUsage({ element: $(this) });

                if ($(this).hasClass('CollectionsContainer'))
                    hasCollections = true;
                if ($(this).hasClass('ProductsContainer'))
                    hasProducts = true;

                var thisCurElem = false;
                if ($(this).attr('class') === elementContainer.parent().attr('class'))
                    thisCurElem = true;

                // Update the aggregates
                availableCols += colUsage.colsAvailable;
                fillableCols += colUsage.colsFillable;
                minFillableCols += colUsage.colsMinFill;
                visibleCols += colUsage.colsVisible;
                usedComponents += colUsage.componentsUsed;

                if (thisCurElem) {
                    if (colUsage.colsFillable != colUsage.colsVisible)
                        expandableElem = { elem: $(this), newClass: 'Cols-' + colUsage.colsFillable, oldClass: 'Cols-' + colUsage.colsVisible, colsFillable: colUsage.colsFillable, colsMinFill: colUsage.colsMinFill, colsVisible: colUsage.colsVisible };
                }
                else {
                    if (colUsage.colsMinFill != colUsage.colsVisible)
                        collapsableElem = { elem: $(this), newClass: 'Cols-' + colUsage.colsMinFill, oldClass: 'Cols-' + colUsage.colsVisible, colsFillable: colUsage.colsFillable, colsMinFill: colUsage.colsMinFill, colsVisible: colUsage.colsVisible };
                }

            });

            // Only do a slide if this SecondaryNavigation has got both Collections and Products (other components are not dynamic)
            if (hasCollections && hasProducts)
                allowSlide = true;

            if (allowSlide) {
                // Figure out whether columns are required
                var colsRequired = visibleCols;
                if (expandableElem != null)
                    colsRequired = visibleCols - expandableElem.colsMinFill + expandableElem.colsFillable;
                else
                    allowSlide = false;

                // If the element we are expanding is the same as the one we are collapsing, then we want to ignore the collapse
                if ((expandableElem != null) && (collapsableElem != null) && ($(expandableElem.elem).attr('class') === $(collapsableElem.elem).attr('class')))
                    colsRequired = visibleCols;
            }

            // Collapse or expand the ContentContainer as required
            if (allowSlide) {
                // First find out whether we need to make room and collapse a ContentContainer if required
                if (colsRequired > maxCols) {
                    if ((collapsableElem != null) && (collapsableElem.oldClass != collapsableElem.newClass) && (expandableElem.oldClass != expandableElem.newClass)) {
                        elemAwaitingSlide = element;

                        slideTimer = setTimeout(function () {
                            // Make sure nothing else is sliding
                            clearTimeout(slideTimer);
                            slideInProgress = true;

                            // Before we do any sliding, make sure the width of the outer div is static
                            var currSecNavWidth = $(expandableElem.elem.parent()).width();
                            $(expandableElem.elem.parent()).width(currSecNavWidth);

                            if ($(collapsableElem.elem).hasClass('ProductsContainer')) {
                                methods.setAllInactive({ element: collapsableElem.elem.children('ul.Component') });
                            }

                            if ($(expandableElem.elem).hasClass('ProductsContainer'))
                                $(expandableElem.elem).addClass('ExpandedState');
                            else
                                $(expandableElem.elem).removeClass('ExpandedState');

                            // Set the width to be the old width
                            $(collapsableElem.elem).width(methods.getWidthFromClass({ element: collapsableElem.elem, newClass: collapsableElem.oldClass }));

                            // Change the class, so we can set the defaults
                            if ($(collapsableElem.elem).hasClass('ProductsContainer')) {
                                $(collapsableElem.elem).removeClass(collapsableElem.oldClass).addClass(collapsableElem.newClass);
                                methods.secondaryNavigationSelected({ element: collapsableElem.elem.children('ul.Component').first().children('li.MegaNavEnabled').first(), forceNoDelay: true, animateColExpand: false });
                            }
                            else if ($(collapsableElem.elem).hasClass('CollectionsContainer') && ($.browser.msie && $.browser.version < "8.0")) {
                                // Note this is for IE7 and less only - if we need to change this section, change the callback of the collapse below too
                                $(collapsableElem.elem).removeClass(collapsableElem.oldClass).addClass(collapsableElem.newClass);
                                methods.setAllInactive({ element: collapsableElem.elem.children('ul.Component').children('li.ComponentItem').children('div.TertiaryNavigation') });
                            }

                            // Do the collapse
                            $(collapsableElem.elem).animate(
                                { width: methods.getWidthFromClass({ element: collapsableElem.elem, newClass: collapsableElem.newClass }) },
                                350,
                                function () {
                                    if ($(collapsableElem.elem).hasClass('CollectionsContainer') && !($.browser.msie && $.browser.version < "8.0")) {
                                        // Note this is for all browsers except IE7 and less - if we need to change this section, change the else if a few lines above
                                        $(collapsableElem.elem).removeClass(collapsableElem.oldClass).addClass(collapsableElem.newClass);
                                        methods.setAllInactive({ element: collapsableElem.elem.children('ul.Component').children('li.ComponentItem').children('div.TertiaryNavigation') });
                                    }
                                }
                            );

                            // Do the expand
                            $(expandableElem.elem).animate(
                                { width: methods.getWidthFromClass({ element: expandableElem.elem, newClass: expandableElem.newClass }) },
                                350,
                                function () {
                                    $(expandableElem.elem).removeClass(expandableElem.oldClass).addClass(expandableElem.newClass);
                                    if ($(expandableElem.elem).hasClass('CollectionsContainer') || $(expandableElem.elem).hasClass('ProductsContainer')) {
                                        if (element.parent().parent().hasClass('TertiaryNavigation'))
                                            methods.tertiaryNavigationSelected({ element: element });
                                        else
                                            methods.secondaryNavigationSelected({ element: element, forceNoDelay: true, animateColExpand: true });
                                    }
                                    slideInProgress = false;
                                }
                            );
                                
                            elemAwaitingSlide = null;
                        }, 500);

                        return true;
                    }
                }
            }
            return false;
        }
    };

    // This is the main function for the megaNav that accepts a method name e.g. $('#MainNavigation').megaNav('init');
    $.fn.megaNav = function (method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            // If we haven't specified a method, then just run the init code by default
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist in Next.jQuery.megaNav');
        }
    };

      var topLevelConfig = {    
                over: methods.topHover,   
                timeout: 350,  
                out: methods.topHoverOut,
                sensitivity: 7,
                interval: 90
           };

})(jQuery);


// -----------------------------------------FUNCTIONS----------------------------------------- //


window.onscroll = function () {																												                        // Fired when user scrolls the page



    if (HidePrimaryNavigation) {
        SpreadGridHeaderScrollState();
        HeaderScrollState();
    }
}

function HeaderScrollState() { 

    if ($(document).scrollTop() == 0) {
        ExpandNav();
        PositionBreadcrumb("Down");
    } else {
        CollapseNav(false);
        PositionBreadcrumb("Up");
    }

}

function SpreadGridHeaderScrollState() {

    if ($(document).scrollTop() == 0) {

        var st = $("#SpreadsGridTitle");
   

        $(st).animate({
            top: 35
        }, 400, 'easeOutCubic');

    } else {

     $("#SpreadsGridTitle").animate({
         top: 0
     }, 400, 'easeOutCubic');
    }

}

function PositionBreadcrumb(pos) {

    var bn = $("section.BreadcrumbNavigation");
    switch  (pos){
                case "Down":
                            if($(bn).hasClass("down")){
                                    return false;
                            }

                                $(bn).animate({ top: 86 }, 400, 'easeOutCubic');
                             $(bn).addClass("down");
                             $(bn).removeClass("up");
                             break;

                case "Up":
                            if($(bn).hasClass("up")){
                                    return false;
                            }

                                $(bn).animate({ top: 51 }, 400, 'easeOutCubic');
                            $(bn).addClass("up");
                            $(bn).removeClass("down");
                            break;
            }

}

function ExpandNav() {
  
    if (!HidePrimaryNavigation) {
        return false;
    }

    if ($(".PageHeader").hasClass("Expanded")) {
        return false;
    }
    

    if ($(".PageHeader").addClass("home")) {
        $(".PageHeader").height(86);
    } else {
        $(".PageHeader").height(116);
    }

    $(".HeaderNavigation").animate({
                                    top: 50
                                    }, 400, 'easeOutCubic')

    $(".PageHeader").addClass("Expanded");

}

function CollapseNav(forceClose) {

    if (!HidePrimaryNavigation) {
        return false;
    }

    if ($(document).scrollTop() == 0) {
        return false;
    }

    if( $(".PageHeader").hasClass("mouseOver")){
       return false;
    }

    // Don't collapse if any of the Mega Nav's are open
    if ($('#MainNavigation li.Department.Active').size() > 0) {
        return false;
    }

   if ($(".PageHeader").hasClass("Expanded")) {

       if ($(".PageHeader").addClass("home")) {
           $(".PageHeader").height(52);
       } else {
           $(".PageHeader").height(82);
       }


       $(".HeaderNavigation").animate({
           top: 14
       }, 400, 'easeOutCubic');
        $(".PageHeader").removeClass("Expanded");

    } else {
    return false;
    }
}

//Need 2 different configs for hover intent on the header as different elements trigger cololapse and expand
var headerExpandConfig = {
    over: ExpandNav,
    timeout: 20,
    out: blank
};

var headerCollapseConfig = {
    over: blank,
    timeout: 250,
    out: CollapseNav
};

function blank() {
    return false;
}

$(document).ready(function () {
    if (HidePrimaryNavigation) {
        $(".PageHeader").addClass("Expanded");
        $(".PageHeader").hoverIntent(headerCollapseConfig);
        $(".HeaderTopBar").hoverIntent(headerExpandConfig);
    }

})

function resizeHeader(className) {
    if (!$(".PageHeader").hasClass("Locked")) {
        var Animation = createAnimation();
        var scrolltimer = 500
        switch (className) {
            case "Small":
                if ($(".PageHeader").hasClass("Large")) {
             
                    addToAnimation(Animation, '$(".PageHeader").addClass("Locked")', 0, false)
                    //addToAnimation(Animation, '$(".SiteLogo").fadeOut(500)', 0, false)
                    addToAnimation(Animation, '$(".HeaderNavigation").animate({"top": "0"},500)', 0, false);
                    //if (!$(".MiniBag").hasClass("Open")) {
                    //    addToAnimation(Animation, '$(".MiniBag").animate({"top": "' + (40 - $(".MiniBag").height()) + '"}, 500)', 500, false);
                    //}
                    //addToAnimation(Animation, '$(".HeaderTop").animate({ "padding-top": "0px", "padding-bottom": "0px" }, 500);', 0, false)
                    //addToAnimation(Animation, '$(".HeaderTopBar").animate({ "height": "40px" }, 500);', 0, false)
                    //addToAnimation(Animation, '$(".HeaderSpacer").animate({"height": "40px" }, 500);', 500, true);

                    addToAnimation(Animation, '$(".HeaderNavigation").addClass("Hidden")', 0, false);
                    //addToAnimation(Animation, '$(".PageHeader").removeClass("Large").addClass("Small")', 0, false);

                    //addToAnimation(Animation, '$(".SiteLogoLarge").addClass("Hide")', 0, false)
                    //addToAnimation(Animation, '$(".SiteLogoSmall").removeClass("Hide")', 0, false)
                    //addToAnimation(Animation, '$(".SiteLogo").fadeIn(500)', 500, true)

                    //addToAnimation(Animation, '$(".HeaderSpacer").removeClass("Large").addClass("Small")', 0, false);
                    //addToAnimation(Animation, '$(".HeaderSpacer").removeAttr("style")', 0, false);
                    //addToAnimation(Animation, '$(".HeaderTop").removeAttr("style")', 0, false);
                    //addToAnimation(Animation, '$(".HeaderTopBar").removeAttr("style")', 0, false);
                    addToAnimation(Animation, '$(".HeaderNavigation").removeAttr("style")', 0, false);
                    //addToAnimation(Animation, '$(".SiteLogo").removeAttr("style")', 0, false);
                    addToAnimation(Animation, '$(".PageHeader").removeClass("Locked")', 0, false);
                    runAnimation(Animation);
                }
                break;
            case "Large":
                if ($(".PageHeader").hasClass("Small")) {
                   
                    addToAnimation(Animation, '$(".PageHeader").addClass("Locked")', 0, false)
                    //addToAnimation(Animation, '$(".SiteLogo").fadeOut(500)', 500, false)
                    addToAnimation(Animation, '$(".HeaderNavigation").animate({"top": "55px"},500)', 500, false);

                    //addToAnimation(Animation, '$(".HeaderTop").animate({ "padding-top": "8px", "padding-bottom": "8px" }, 500);', 500, false)
                    //addToAnimation(Animation, '$(".HeaderTopBar").animate({ "height": "56px" }, 500);', 0, false)
                    //addToAnimation(Animation, '$(".HeaderSpacer").animate({"height": "96px" }, 500);', 500, true);

                    addToAnimation(Animation, '$(".HeaderNavigation").removeClass("Hidden")', 0, false);
                    //addToAnimation(Animation, '$(".PageHeader").removeClass("Small").addClass("Large")', 0, true)

                    //if (!$(".MiniBag").hasClass("Open")) {
                    //    addToAnimation(Animation, '$(".MiniBag").animate({"top": "' + (56 - $(".MiniBag").height()) + '"}, 500)', 500, false);
                    //}

                    //addToAnimation(Animation, '$(".SiteLogoSmall").addClass("Hide")', 0, false)
                    //addToAnimation(Animation, '$(".SiteLogoLarge").removeClass("Hide")', 0, false)
                    //addToAnimation(Animation, '$(".SiteLogo").fadeIn(500)', 500, true)

                    //addToAnimation(Animation, '$(".HeaderSpacer").removeClass("Small").addClass("Large")', 0, false);
                    //addToAnimation(Animation, '$(".HeaderSpacer").removeAttr("style")', 0, false);
                    //addToAnimation(Animation, '$(".HeaderTop").removeAttr("style")', 0, false);
                    //addToAnimation(Animation, '$(".HeaderTopBar").removeAttr("style")', 0, false)
                    addToAnimation(Animation, '$(".HeaderNavigation").removeAttr("style")', 0, false)
                    //addToAnimation(Animation, '$(".SiteLogo").removeAttr("style")', 0, false);
                    addToAnimation(Animation, '$(".PageHeader").removeClass("Locked")', 0, false)
                    runAnimation(Animation);
                }
                break;
        }
    }
}

function changeNavMode(className) {
    if (!$(".PageHeader").hasClass("Locked") && !$(".HeaderNavigation").hasClass("Secure")) {
        var Animation = createAnimation();
        var scrolltimer = 500
        switch (className) {
            case "Hide":
                if (!$(".HeaderNavigation").hasClass("Hidden")) {
                   
                    addToAnimation(Animation, '$(".PageHeader").addClass("Locked")', 0, false)                  // Apply Transition Lock
                    addToAnimation(Animation, '$(".HeaderNavigation").animate({"top": "-=' + $(".PageHeader .HeaderNavigation").height() + '"},500)', 500, false);    // Hide The Navigation
                    addToAnimation(Animation, '$(".BreadcrumbNavigation").animate({"top": "-=' + $(".PageHeader .HeaderNavigation").height() + '"}, 500)', 500, false);
                    addToAnimation(Animation, '$(".PageHeader").animate({"height": "-=' + $(".PageHeader .HeaderNavigation").height() + '"}, 500)', 500, true);
                    addToAnimation(Animation, '$(".HeaderNavigation").addClass("Hidden")', 0, false);           // Add The Hidden Class To The Navigation
                    addToAnimation(Animation, '$(".PageHeader").removeClass("Locked")', 0, false);              // Remove Transition Lock
                    runAnimation(Animation);
                }
                break;
            case "Show":
                if ($(".HeaderNavigation").hasClass("Hidden")) {
                   
                    addToAnimation(Animation, '$(".PageHeader").addClass("Locked")', 0, false)                      // Apply Transition Lock
                    addToAnimation(Animation, '$(".HeaderNavigation").animate({"top": "+=' + $(".PageHeader .HeaderNavigation").height() + '"},500)', 500, false);    // Hide The Navigation
                    addToAnimation(Animation, '$(".BreadcrumbNavigation").animate({"top": "+=' + $(".PageHeader .HeaderNavigation").height() + '"}, 500)', 500, false);
                    addToAnimation(Animation, '$(".PageHeader").animate({"height": "+=' + $(".PageHeader .HeaderNavigation").height() + '"}, 500)', 500, true);

                    addToAnimation(Animation, '$(".HeaderNavigation").removeClass("Hidden")', 0, false);            // Remove the Hidden class from the navigation
                    addToAnimation(Animation, '$(".HeaderNavigation").removeAttr("style")', 0, false)               // Clean Up Dynamically Added Styles
                    addToAnimation(Animation, '$(".PageHeader").removeClass("Locked")', 0, false)                   // Remove The Transition Lock
                    runAnimation(Animation);
                }
                break;
        }
    }
}


function ShowNavigation() {
    if (HidePrimaryNavigation && $(document).scrollTop() != 0 && $(".HeaderNavigation").hasClass("Hidden")) {

      
        var Animation = createAnimation();
        //addToAnimation(Animation, '$(".HeaderNavigation").animate({"top": "' + ($(".PageHeader").height() - 1) + '"},500)', 500, true);
        addToAnimation(Animation, '$(".HeaderNavigation").animate({"top": "+=' + $(".PageHeader .HeaderNavigation").height() + '"},500)', 500, true);    // Hide The Navigation
        addToAnimation(Animation, '$(".HeaderNavigation").removeClass("Hidden")', 0, false);
        addToAnimation(Animation, 'if (mouseOverHeader == false) { HideNavigation() }', 0, false)
        runAnimation(Animation);
    }
}

function HideNavigation() {

    if ($('ul.PrimaryNavigation li.Department.Active').length > 0) {
        return false;
    }

    if (HidePrimaryNavigation && $(document).scrollTop() != 0 && !$(".HeaderNavigation").hasClass("Hidden")) {
   
        var Animation = createAnimation();
        addToAnimation(Animation, '$(".HeaderNavigation").animate({"top": "-=' + $(".PageHeader .HeaderNavigation").height() + '"},500)', 500, true);    // Hide The Navigation
        addToAnimation(Animation, '$(".HeaderNavigation").addClass("Hidden")', 0, false);
        runAnimation(Animation);
    }

}

function ShowBreadcrumbBar(Animation) {
    addToAnimation(Animation, '$(".PageHeader").addClass("Large")', 0, false);
    addToAnimation(Animation, '$(".PageHeader .BreadcrumbNavigation").fadeIn(250);', 250, true);

    return Animation
}

function HideBreadcrumbBar(Animation) {
    addToAnimation(Animation, '$(".PageHeader").addClass("Large")', 0, false);
    addToAnimation(Animation, '$(".PageHeader .BreadcrumbNavigation").fadeIn(250);', 250, true);

    return Animation
}

function UpdateBreadcrumbTrail(BCHTML) {

    $("section.Breadcrumbs").html(BCHTML);

    $("ul.Breadcrumbs li").last().addClass("lastBreadcrumb");

    BreadcrumbResize();

}

//Function determines the available space for the breadcrumb navigation, and sets a width dependant on this
//If there is not enough space for the full breadcrumb, then the overflow is hidden, and an ellipsis is displayed
function BreadcrumbResize() {

    //Static variables
    var bcrumbHolderWidth = 900; //bcrumbholderwidth set to the full available space for the breadcrumb, if no socialbookmarks are displayed
    var SocialBookmarkWidth = 160; //variable also includes additional spacing so that the breadcrumb and socialbookmarks have space between them

    //Element variables
    var $bcrumbHolder = $(".BreadcrumbsHolder");
    var $bcrumbList = $bcrumbHolder.find("ul.Breadcrumbs");
    var $bcrumbLi = $bcrumbList.find("li");
    var $bcrumbEllipsis = $(".BreadcrumbEllipsis");
    

    if (AddThisEnabled) {
        //AddThis is enabled, therefore reduced the bcrumbholder width by the width of the socialbookmarkwidth variable
        bcrumbHolderWidth = bcrumbHolderWidth - SocialBookmarkWidth;
    }
    
    $bcrumbHolder.width(bcrumbHolderWidth);

    //Following loop determines the total length of all the Li elements matching the $bcrumbLi variable selector.
    var totalLiLength = 0;
    $bcrumbLi.each(function (i, e) {
        totalLiLength += $(e).outerWidth(true) + 2; //+2 has been added as a fix for IE7. Without this, it seems the outerWidth() for IE7 can be too small.
    });

    //If the totalLiLength > $bcrumbholder width, then a width needs to be set on the $bcrumbList, and the ellipsis should be shown.
    if (totalLiLength > $bcrumbHolder.width()) {
        $bcrumbList.width(totalLiLength);
        $bcrumbEllipsis.show();
    }
    //Else statements reverse changes made in the If statement
    else {
        $bcrumbList.css("width", "auto");
        $bcrumbEllipsis.hide();          
    }

}

/*function hidePrimaryNavigation() {
    $(".HeaderNavigation").animate({ "top": "0" }, 500)
    $(".HeaderNavigation").addClass("Hidden");
}

function showPrimaryNavigation() {
    var topPosition = $(".HeaderTopBar").height() - 8
    $(".HeaderNavigation").animate({ "top": topPosition }, 500)
    $(".HeaderNavigation").removeClass("Hidden");
}*/

/*function checkOut_Click() {
    $.ajax({
        url: "/bag/aptransfer",
        type: "POST",
        cache: false,
        async: true,
        error: null,
        success: window.location = "http://end-edws08/TransferSession.asp"
    });
}
*/
function submitSearch() {
    var searchAction = $('#newsearch').attr('action'),
        searchTerm = $('#newsearch .SearchBox').val(),
        searchParams = { w: searchTerm },
        numParams = 0,
        requestString = '';

    $('#newsearch input').each(function () {
        if ($(this).attr('type') !== 'submit')
            addParam($(this).attr('name'), $(this).attr('value'))
    });

    return LoadHTMLContent(searchAction + requestString, searchTerm, null, true, null, {}, null, 'clearSearchBox()');
    //return LoadHTMLContent(searchAction, searchTerm, null, true, null, requestString);
    //LoadHTMLContent(Path, Title, Transition, AddToHistory, ScrollPoint, DocState, FormData, completionCallback)

    // Helper for requestParams() (this is contained within submitSerarch() because it needs access to some of its variables)
    function addParam(newParamName, newParamValue) {
        var beginSequence = '?';
        var paramSeperator = '&';
        var paramAssignmentSeperator = '=';

        if (numParams == 0)
            requestString += beginSequence;
        else
            requestString += paramSeperator;

        // Add the value
        var paramValue = newParamValue.replace('#','%23') + '';
        requestString += newParamName + paramAssignmentSeperator + paramValue;
        numParams++;
    }
}

/* 

Left in - in case fixes cannot be applied at XSLT layer for HTML encoded entity display.

function decodeHtmlEntities()  {
    // Get the text nodes we're interested in
    function getTextNodes(directParent) {
        var subArr = $([]);
        $(directParent).contents().each(function() {                            
            if(this.nodeType !== 3){ 
                var subNodes = getTextNodes(this);
                for(var i = 0; i < subNodes.length; i++){
                    subArr.push(subNodes[i]);
                }
                subArr.push();
            } else {
                if((this.nodeValue.indexOf("&") > -1) || (this.nodeValue.indexOf("#") > -1)){
                    subArr.push(this);
                }
            }                            
        });
        return subArr;                        
    }           
            
    // Replace each text node with a decoded text node                      
    getTextNodes('header, section.Content').each(function() { 
        var decoded = $('<div/>').html(this.nodeValue).text(); 
        $(this).replaceWith(document.createTextNode(decoded)); 
    });
}
*/

function clearSearchBox() {
    $('#newsearch .SearchBox').val('');
    $('#newsearch .SearchBox').blur();
}



$(function () {
    setNavItemWidths();
});

//Span primary nav full width and make padding equal for each link
function setNavItemWidths() {
    //UL is set to float left so will only extend as far as content pushes it
    var ulWidth = $("ul.PrimaryNavigation").width();
    //Get number of links in primary nav
    var itemCount = $("ul.PrimaryNavigation li.Department").length;
    //Set required width of primary nav
    var targetWidth = 974;
    //Calc how short menu is at present
    var missingWidth = targetWidth - ulWidth;
    //Calc required left and right padding for each link in nav
    var requiredPadding = Math.floor((missingWidth / itemCount) / 2);
    //Set padding on each item
    $("ul.PrimaryNavigation li.Department").each(function () {
        $(this).find("a span").css("padding-left", requiredPadding).css("padding-right", requiredPadding);
    });
    //Now measure the ul again
    ulWidth = $("ul.PrimaryNavigation").width();
    missingWidth = targetWidth - ulWidth;
    //If there's still any remaining width for the nav, add an additional 1px padding left and right to
    //the first x number of links where x is the remaining width divided by 2.
    //Get the number of items we can add 1px more padding to
    var addMorePaddingToItemsCount = Math.floor(missingWidth / 2);
    var i = 0;
    //Loop through the items
    $("ul.PrimaryNavigation li.Department").each(function () {
        if (i < addMorePaddingToItemsCount) {
            $(this).find("a span").css("padding-left", requiredPadding + 1).css("padding-right", requiredPadding + 1);
        }
        i++;
    });
    //UL Primary nav should now span the full header width with each link having (more or less) the same padding
    
    //IE9 Doesn't quite calculate the width correctly (or rather it wraps content when it's set incorrectly)
    //Force the width here once we've completed other calculations to prevent wrapping in IE
    //Don't target IE only though as this target width is correct so may as well set on all browsers *+2 allows for ul padding
      $("ul.PrimaryNavigation").width(targetWidth + 2);

      //Now set visibility to visible - this prevents flash of squashed menu before sizing has been applied
    $("ul.PrimaryNavigation").css("visibility","visible");
}
