﻿
// The following method will check if the user came from a search page
function checkSearchBreadcrumbs() {
    if (PagePopped && PagePoppedData !== null) {
        swapToSearchBreadcrumb('HistoryObject');
    }
    else {
        GetSessionVariable(
            'ShoppingHistory',
            false,
            function (varValue, data, textStatus, jqXHR) {
                var lastPageUrl = 'index.html';

                // Try to use the last value in session
                if (varValue.length != 'undefined' && varValue.length != null && varValue[varValue.length - 1] != 'undefined' && varValue[varValue.length - 1] != null)
                    lastPageUrl = varValue[varValue.length - 1];

                // If the page has refreshed, used the 2nd to last value in session
                if ((lastPageUrl === window.location.href) && (varValue.length != 'undefined' && varValue.length != null && varValue.length > 1 && varValue[varValue.length - 2] != 'undefined' && varValue[varValue.length - 2] != null))
                    lastPageUrl = varValue[varValue.length - 2];

                if (checkIfUrlIsSearch(lastPageUrl)) {
                    //ConsoleLog('USE SEARCH BREADCRUMBS BASED ON SESSION', lastPageUrl);
                    swapToSearchBreadcrumb('Session');
                    BreadcrumbResize();
                }
                else {
                    // Leave the defaults
                    useDefaultBreadcrumbs();
                }
            },
            function () {
                // Leave the defaults
                useDefaultBreadcrumbs();
            }
        );
    }
}

function checkIfUrlIsSearch(urlToCheck) {
    var fullUrl = new UrlHelper(urlToCheck);

    if ((fullUrl.Host() == window.location.hostname) && ((fullUrl.Path().indexOf('search') > -1) || (fullUrl.Path().indexOf('shop/index.html') > -1))) {
        return true;
    }
    else
        return false;
}

function swapToSearchBreadcrumb(breadcrumbType) {
    var newBreadcrumbItem = $('<li class="Breadcrumb"></li>');
    var tempProdPageText = '';

    if (breadcrumbType === 'HistoryObject' && PagePoppedData.DocState.hiddenSearchbreadcrumb !== undefined && PagePoppedData.DocState.hiddenSearchbreadcrumb !== null) {
        // Get rid of the current breadcrumb
        $('ul.Breadcrumbs li.Breadcrumb').each(function () {
            $(this).off('click');
            if ($(this).children('a').size() === 0)
                tempProdPageText = $(this).text();
            if (!$(this).hasClass('bcHome'))
                $(this).remove();
        });

        // Append the search breadcrumb to the page
        $('ul.Breadcrumbs').append(unescape(PagePoppedData.DocState.hiddenSearchbreadcrumb));

        // Re-Append the current page breadcrumb to the page
        newBreadcrumbItem = $('<li class="Breadcrumb"></li>');
        newBreadcrumbItem.append(tempProdPageText);
        $('ul.Breadcrumbs').append(newBreadcrumbItem);

        cleanBreadcrumbsForOldBrowsers();
    }
    else if (breadcrumbType === 'Session') {
    GetSessionVariable(
            'SearchBreadcrumb',
            false,
            function (varValue, data, textStatus, jqXHR) {
                // First check whether the variable has been populated, otherwise we need to load the defaults
                if (varValue) {
                    // Get rid of the current breadcrumb
                    $('ul.Breadcrumbs li.Breadcrumb').each(function () {
                        $(this).off('click');
                        if ($(this).children('a').size() === 0 && $(this).text() !== null)
                            tempProdPageText = $(this).text();
                        if (!$(this).hasClass('bcHome'))
                            $(this).remove();
                    });

                    // Append the search breadcrumb to the page
                    $('ul.Breadcrumbs').append(unescape(varValue));

                    // Re-Append the current page breadcrumb to the page
                    newBreadcrumbItem = $('<li class="Breadcrumb lastBreadcrumb"></li>');
                    newBreadcrumbItem.append(tempProdPageText);
                    $('ul.Breadcrumbs').append(newBreadcrumbItem);

                    cleanBreadcrumbsForOldBrowsers();

                    // Replace State
                    if (typeof window.history.pushState != "undefined") {   // If we're navigating the site rather than clicking back or forward
                        addParamToDocState('hiddenSearchbreadcrumb', varValue);
                    }                    
                }
                else
                    useDefaultBreadcrumbs();

                // Update Continue Shopping
                UpdateContinueShopping();
            },
            function () {
                useDefaultBreadcrumbs();
            }
        );
    }
    else {
        useDefaultBreadcrumbs();
    }
}

function useDefaultBreadcrumbs() {
    if ($(".CurrentContent #ProductDefaultBreadcrumb").length) {
        var BCHTML = $(".CurrentContent #ProductDefaultBreadcrumb #BreadcrumbWrapper").html();
        if (BCHTML.length) {
            UpdateBreadcrumbTrail(BCHTML);
        }
        //Remove page params from page
        $(".CurrentContent #ProductDefaultBreadcrumb").remove();
        cleanBreadcrumbsForOldBrowsers();
    }

    // Update Continue Shopping
    UpdateContinueShopping();
}

function cleanBreadcrumbsForOldBrowsers() {
    $("ul.Breadcrumbs li").last().addClass("lastBreadcrumb");
    $("span.BreadcrumbSubItem").last().addClass("lastSubBreadcrumb");
}