﻿

var NextBasket = {
	SessionID: '',
	Data: { Version: 0 },
	NotifyChange: [],
	NotifyError: [],
	Loaded: false,
	UsingKeepAlive: false,
	KeepAlivePollTime: 60000,
	HostURL: "",
	InboundStack: [],
	OutboundStack: [],
	ItemsWaiting: false,
	NotifyWaiting: false,
	Init: function () {
		// Use baseURL if it exists (used by AccountPortal to post to MVC app).
		if (typeof baseURL != 'undefined') { NextBasket.HostURL = baseURL; }
		updateBagUI();
	},
	//Executes bag actions
	ExecuteBagAction: function (actionParams) {

		$.ajax({
			url: actionParams.actionPath,
			type: "POST",
			cache: false,
			data: actionParams.postData,
			async: true,
			error: function (data, textStatus, errorThrown) { NextBasket.LoadError(data, textStatus, errorThrown, actionParams.actionType, actionParams.callBack); },
			success: function (data, textStatus, jqXHR) { checkAndRedirectForAjaxError(jqXHR, false, 'ShoppingBag.js: ExecuteBagAction'); NextBasket.LoadSuccess(data, textStatus, jqXHR, actionParams.actionType, actionParams.loadBasketPage, actionParams.callBack); }
		});

	},
	//All bag actions are passed here and added to the stack of actions
	AddBagAction: function (actionParams) {

		//Add action to inbound stack
		NextBasket.InboundStack.push(actionParams);

		//If ItemsWaiting is set to false, we have not yet begun to process the items in the Inbound stack
		//Need to kick it off here
		if (!NextBasket.ItemsWaiting) {
			NextBasket.ItemsWaiting = true;
			//Get (and remove) first item from stack and send it off to be processed
			//In most cases we will be using the item we just added but if user has clicked 'add' multiple times,
			//we can loop through the items one by one
			var firstAction = NextBasket.InboundStack.shift();
			NextBasket.ExecuteBagAction(firstAction);
		}

	},
	ItemRemove: function (itemID) {
		var actionParams = {
			actionPath: "/bag/remove",
			postData: { id: itemID },
			actionType: "remove",
			loadBasketPage: false
		};
		NextBasket.AddBagAction(actionParams);
	},
	ItemAdd: function (itemID, optionNo, quantity, loadBasketPage, callBack) {
		//Build action paramters
		var actionParams = {
			actionPath: "/bag/add",
			postData: { id: itemID, option: optionNo, quantity: quantity },
			actionType: "add",
			loadBasketPage: loadBasketPage,
			callBack: callBack
		};
		//Pass to AddBagAction method
		NextBasket.AddBagAction(actionParams);
	},
	ItemAddMultiple: function (data, loadBasketPage, callBack) {

		var actionParams = {
			actionPath: "/bag/addmultiple",
			postData: { data: $.toJSON(data) },
			actionType: "add",
			loadBasketPage: loadBasketPage,
			callBack: callBack
		};

		NextBasket.AddBagAction(actionParams);

	},
	ItemAddWarranty: function (itemID, optionNo, warrantyID, warrantyOption, callBack) {

		var actionParams = {
			actionPath: "/bag/addwarranty",
			postData: { id: itemID, option: optionNo, warranty: warrantyID, warrantyoptionno: warrantyOption },
			actionType: "add",
			loadBasketPage: false,
			callBack: callBack
		};

		NextBasket.AddBagAction(actionParams);

	},
	ItemUpdateSize: function (itemID, optionNo) {
		$.ajax({
			url: "/bag/updatesize",
			type: "POST",
			cache: false,
			data: { id: itemID, option: optionNo },
			async: true,
			error: function (data, textStatus, errorThrown) { NextBasket.LoadError(data, textStatus, errorThrown, 'updatesize'); },
			success: function (data, textStatus, jqXHR) { checkAndRedirectForAjaxError(jqXHR, false, 'ShoppingBag.js: ItemUpdateSize'); NextBasket.LoadSuccess(data, textStatus, jqXHR, 'updatesize'); }
		});
	},
	ItemUpdateQuantity: function (itemID, quantity) {
		//alert(itemID + ' : ' + quantity);
		$.ajax({
			url: "/bag/updatequantity",
			type: "POST",
			cache: false,
			data: { id: itemID, quantity: quantity },
			async: true,
			error: function (data, textStatus, errorThrown) { NextBasket.LoadError(data, textStatus, errorThrown, 'updatequantity'); },
			success: function (data, textStatus, jqXHR) { checkAndRedirectForAjaxError(jqXHR, false, 'ShoppingBag.js: ItemUpdateQuantity'); NextBasket.LoadSuccess(data, textStatus, jqXHR, 'updatequantity'); }
		});
	},
	AddEVoucher: function (id, option, eVoucherTo, eVoucherFrom, eVoucherEmail, eVoucherMessage, ecardDeliveryDate) {

		var actionParams = {
			actionPath: "/bag/addevoucher",
			postData: { id: id, option: option, eVoucherTo: eVoucherTo, eVoucherFrom: eVoucherFrom, eVoucherEmail: eVoucherEmail, eVoucherMessage: eVoucherMessage, ecardDeliveryDate: ecardDeliveryDate },
			actionType: "addEvoucher",
			loadBasketPage: false
		};

		NextBasket.AddBagAction(actionParams);

	},

    Load: function () {

        if (isIOS) {
      
            $.ajax({
                url: NextBasket.HostURL + "/bag/get",
                type: "GET",
                timeout: 5000,
                cache: false,
                async: true,
                error: function (data, textStatus, errorThrown) { NextBasket.LoadError(data, textStatus, errorThrown, 'load'); },
                success: function (data, textStatus, jqXHR) { checkAndRedirectForAjaxError(jqXHR, false, 'ShoppingBag.js: Load'); NextBasket.LoadSuccess(data, textStatus, jqXHR, 'load'); },
                dataType: "json",
                xhrFields: { withCredentials: true },
                crossDomain: true
            });


        } else { 
        
                 $.ajax({
                    url: NextBasket.HostURL + "/bag/get",
                    type: "POST",
                    cache: false,
                    async: true,
                    error: function (data, textStatus, errorThrown) { NextBasket.LoadError(data, textStatus, errorThrown, 'load'); },
                    success: function (data, textStatus, jqXHR) { checkAndRedirectForAjaxError(jqXHR, false, 'ShoppingBag.js: Load'); NextBasket.LoadSuccess(data, textStatus, jqXHR, 'load'); },
                    dataType: "json",
                    xhrFields: { withCredentials: true },
                    crossDomain: true
                });
        }
       
    },
    LoadWithIncentives: function () {
        $.ajax({
            url: NextBasket.HostURL + "/bag/getincentives",
            type: "POST",
            cache: false,
            async: true,
            error: function (data, textStatus, errorThrown) { NextBasket.LoadError(data, textStatus, errorThrown, 'getincentives'); },
            success: function (data, textStatus, jqXHR) { checkAndRedirectForAjaxError(jqXHR, false, 'ShoppingBag.js: LoadWithIncentives'); NextBasket.LoadSuccess(data, textStatus, jqXHR, 'getincentives'); }
        });
    },
    KeepAlive: function () {
        $.ajax({
            url: "/bag/keepalive",
            type: "POST",
            cache: false,
            async: true,
            error: NextBasket.KeepAliveError,
            success: NextBasket.KeepAliveResponse
        });
    },
    NotifySuccess: function () {
        if (NextBasket.Loaded) {
            for (i = 0; i < NextBasket.NotifyChange.length; i++) {
                NextBasket.NotifyChange[i]();
            }
        };
    },
    KeepAliveResponse: function () {
        if (NextBasket.UsingKeepAlive) {
            window.setTimeout(NextBasket.KeepAlive, NextBasket.KeepAlivePollTime);
        };
    },
    KeepAliveError: function () {
        NextBasket.UsingKeepAlive = false;
    },
    AddItemNotify: function (resultItemArray, currentBag) {

		var itemObj = {
			itemArray: resultItemArray,
			currentBag: currentBag
		}

		NextBasket.OutboundStack.push(itemObj);

		if (!NextBasket.NotifyWaiting) {
			NextBasket.NotifyWaiting = true;
			// var nextNotifyItem = NextBasket.OutboundStack.shift();
			var nextNotifyItem = NextBasket.OutboundStack[0];
			notifyItemAdded(nextNotifyItem);
		}
	},
	LoadSuccess: function (data, textStatus, jqXHR, actionType, loadBasketPage, callBack) {

		if (callBack) {
			setTimeout(function () {
				callBack();
			}, 500);
		}
		if (NextBasket.SessionID === '')
			NextBasket.SessionID = data.SessionID;

		//First need to start the next action waiting to be sent (if one exists)
		if (NextBasket.InboundStack.length) {
			//Get next action and send to be executed
			var nextAction = NextBasket.InboundStack.shift();
			NextBasket.ExecuteBagAction(nextAction);
		} else {
			//Else - all items are processed
			NextBasket.ItemsWaiting = false;

			// Now we know we are on the last item, lets handle any errors
			NextBasket.NotifyErrors();
		}

		var hasOutOfStockItems = false;

		//debugger;
		switch (actionType) {
			case "add": case "addEvoucher":
				NextBasket.Data = data.Bag;
				NextBasket.Loaded = true;

				var newItemArr = [];
				for (var i = 0; i < data.ItemStates.length; i++) {
					if (data.ItemStates[i].State == "A" || data.ItemStates[i].State == "R") {
						newItemArr.push(data.ItemStates[i].Item);
						if (data.ItemStates[i].Message == "Sold Out.")
							hasOutOfStockItems = true;
					}
				}

				if (actionType == "addEvoucher") {
					hasOutOfStockItems = false;
				}

				var curBag = data.Bag;

				// If we are displaying the basket page then we need to update the count and total summary in the header, otherwise we need to show the notification
				if (loadBasketPage || hasOutOfStockItems)
					priceDial(curBag);
				else
					NextBasket.AddItemNotify(newItemArr, curBag);


				if (NextBasket.Data.LowerLimitReached || NextBasket.Data.IsShoppingBagFull) {
					notifyItemAdded = true; // this forces the shopping bag page to be loaded - Raj
				}
				break;
			default: // all other action types (remove, update etc) do not need to perform any specific action (currently) - Raj
				var returnedData = null;
				if (data.Bag != undefined)
					returnedData = data.Bag;
				else
					returnedData = data.ShoppingBag;

				var dataVersion = returnedData.Version;

				NextBasket.Data = returnedData;
				NextBasket.Loaded = true;
				NextBasket.NotifySuccess(); // this should come first, to display total amount at the top of the page - Raj

				if (typeof RefreshShoppingBag == 'function') {
					var forcePageRefresh = false;
					if (data.IgnoreBagVersion == true)
						forcePageRefresh = true;

					RefreshShoppingBag(forcePageRefresh);
				}
				break;
		}

		updateBagUI();
		saveBagCookieForVIP();

		if (!NextBasket.UsingKeepAlive) {
			NextBasket.UsingKeepAlive = true;
			//window.setTimeout(NextBasket.KeepAlive, NextBasket.KeepAlivePollTime); // Do Not Poll!
		}

		if (loadBasketPage || hasOutOfStockItems)
			LoadHTMLContent('/shoppingbag', 'Shopping Bag');
	},
	LoadError: function (data, textStatus, errorThrown, actionType, callBack) {

		if (callBack) {
			callBack();
		}

		// First, push the error onto the NotifyError array as JSON
		NextBasket.NotifyError.push({ Data: data, TextStatus: textStatus, ErrorThrown: errorThrown, ActionType: actionType });

		//On error, there may be more items waiting to be added, move on to these items
		if (NextBasket.InboundStack.length) {
			var nextAction = NextBasket.InboundStack.shift();
			NextBasket.ExecuteBagAction(nextAction);
		} else {
			//Else - all items are processed
			NextBasket.ItemsWaiting = false;

			// Now we know we are on the last item, lets handle any errors
			NextBasket.NotifyErrors();
		}
	},
	RegisterChange: function (func) {
		NextBasket.NotifyChange.push(func);
	},
	RegisterError: function (func) {
		NextBasket.NotifyError.push(func);
	},
	NotifyErrors: function () {
		if (NextBasket.NotifyError.length) {
			ConsoleLog('Errors were detected when receiving a shopping bag response');

			// Loop through each error
			for (i = 0; i < NextBasket.NotifyError.length; i++) {
				var gaErrorString = "Shopping Bag Error";

				// If we have a 513 status code then the session has been reset the maximum number of times, lets get the new bag and take the user to the error page
				if (NextBasket.NotifyError[i].Data.status == 513) {
					gaErrorString = "Shopping Bag Session Expiry Error";
					if (window.location.href.indexOf('error') === -1) {
						window.location = '/error';
					}
				}

				// Log the error to GA
				try {
					ConsoleLog(gaErrorString + ": " + NextBasket.NotifyError[i].ActionType + " - " + NextBasket.NotifyError[i].TextStatus + " - " + NextBasket.NotifyError[i].ErrorThrown);
					TrackGAEvent(gaErrorString, NextBasket.NotifyError[i].ActionType, NextBasket.NotifyError[i].TextStatus + " - " + NextBasket.NotifyError[i].ErrorThrown, 0);
				}
				catch (er) {
					//ConsoleLog('Error Logging to GA');
				}
			}

			// Empty the errors no we have dealt with them
			NextBasket.NotifyError = [];
		}
	}
};

function updateBagUI() {
    var icon =$(".BagSummaryIcon");
    var summaryText = $(".BagSummaryText");
    var trigger = $(".PageHeader .BagSummary .MiniBagTrigger");
    if (NextBasket.Data.ItemCount == 0) {
        if (!icon.hasClass("EmptyBag")) {
            icon.addClass("EmptyBag");
        }
        $(".BagSummaryItemCount span").html(" ");
        if (!summaryText.hasClass("EmptyBag")) {
            summaryText.addClass("EmptyBag");
        }
        if (!trigger.hasClass("Disabled")) {
            trigger.addClass("Disabled");
        }
        summaryText.html("Bag is empty");
    } else {
        if (icon.hasClass("EmptyBag")) {
            icon.removeClass("EmptyBag");
        }
        if (summaryText.hasClass("EmptyBag")) {
            summaryText.removeClass("EmptyBag");
        }
        if (trigger.hasClass("Disabled")) {
            trigger.removeClass("Disabled");
        }
    }
}

function CurrencyFormat (value) {
        var i = parseFloat(value);
        if (isNaN(i)) { i = 0.00; }
        var minus = '';
        if (i < 0) { minus = '-'; }
        i = Math.abs(i);
        i = parseInt((i + .005) * 100);
        i = i / 100;
        s = new String(i);
        if (s.indexOf('.') < 0) { s += '.00'; }
        if (s.indexOf('.') == (s.length - 2)) { s += '0'; }
        s = minus + s;
        return '£' + s;
}

function NextBasketItems(version) {
    this.Version = version;
    this.Items = [];
    this.MediaCode = '';
    this.ItemAdd = function (itemID, optionNo, quantity) {
        if (quantity === null || quantity === undefined)
            this.Items.push({ 'id': itemID, 'option': optionNo, 'quantity': 1 });
        else
            this.Items.push({ 'id': itemID, 'option': optionNo, 'quantity': quantity });
    };
}

//This method registers the new basket total and sets the value on the homepage.
NextBasket.RegisterChange(function () {
 
    var node = $('.BagSummaryText');
    var counterNode = $('.BagSummaryItemCount span');

    if (node.length) {
        node[0].innerHTML = CurrencyFormat(NextBasket.Data.FinalOrderValue); //NextBasket.CurrencyFormat()
    }

    if (counterNode.length) {
        $(counterNode).html(NextBasket.Data.ItemCount);
    }

    // Enable or disable the checkout button in the header.
    SetCheckoutButtonEnabledState();

});

//function RegisterShoppingBagEvents() - This has been moved to ShoppingBagPage.js - Raj

//Item Added Dialogue Settings
var addedToBagTranSpeed = 700;
var addedToBagHideDelay = 4000;

function notifyItemAdded(itemObj) {

    var itemArray = itemObj.itemArray;
    var curBag = itemObj.currentBag;

    //Build Item(s) details 
    var itemsWrapper = $("<div />");

    for (var i = 0; i < itemArray.length; i++) { 

    var curItem = itemArray[i];
    
    var itemWrapper = $("<div />");
    $(itemWrapper).addClass("itemWrapper");

    var itemImg = $("<img />");

    var imgUrl = cdnURL + "/common/items/default/default/itemimages/altitembag/" + curItem.ItemNumber + ".jpg";
    $(itemImg).attr('src', imgUrl);

    $(itemWrapper).append(itemImg);

    var itemDetail = $("<div />");
    $(itemDetail).addClass("itemDetail");

    var stockMessage = curItem.StockMessage;

    if (stockMessage.indexOf("In Stock") > -1) {
        stockMessage = "Available Now";
    }
     
    var itemStatus = $("<span />");
    $(itemStatus).addClass("itemStatus");
    $(itemStatus).addClass(curItem.StockStatus);
    $(itemStatus).html(stockMessage);
    $(itemDetail).append(itemStatus);
    
    var itemSize = $("<span />");
    $(itemSize).addClass("itemQty");
    $(itemSize).html("Size: <strong>" + curItem.SizeDescription + "</strong>");
    $(itemDetail).append(itemSize);

    //Price formatting
    var displayPrice = CurrencyFormat(curItem.Price);

    var itemPrice = $("<span />");
    $(itemPrice).addClass("itemPrice");
    $(itemPrice).html(displayPrice);
    $(itemDetail).append(itemPrice);

    $(itemWrapper).append(itemDetail);

    var clearDiv = $("<div style=\"clear:both;\"></div>");
    $(itemWrapper).append(clearDiv);

    itemsWrapper.append(itemWrapper);

    if (itemArray.length > 1 && i < (itemArray.length - 1)) {
        itemsWrapper.append("<div class=\"multipleBagItemSeperator\"></div>");
    }

    }

    //Remove any existing dialogue
    $(".addedToBagDialogue").remove();

    //Create new dialogue 
    var addedToBagDialogue = $("<div />");
    $(addedToBagDialogue).addClass("addedToBagDialogue");
    //Create inner contents
    var innerAddedToBagDialogue = $("<div />");
    $(innerAddedToBagDialogue).addClass("innerAddedToBagDialogue");
    $(addedToBagDialogue).append(innerAddedToBagDialogue);

    var notifyHeading = $("<h4 />");

    var headingText = "ITEM ADDED TO BAG";

    if (itemArray.length > 1) {
        headingText = "ITEMS ADDED TO BAG";
    }

    $(notifyHeading).text(headingText);
    $(innerAddedToBagDialogue).append(notifyHeading);

    var viewBagLink = $("<a href=\"/shoppingbag\"  onclick=\"this.blur();  return LoadHTMLContent(this.href, this.innerText);\" >View Bag</a>");
    $(viewBagLink).addClass("viewBagLink");
    $(innerAddedToBagDialogue).append(viewBagLink);

    var hr = $("<img  />");
    $(hr).addClass("hr");
    $(hr).attr("src", "../IMAGES/Structural/Dividers/216_Horizontal.png");
    $(innerAddedToBagDialogue).append(hr);
    $(innerAddedToBagDialogue).append(itemsWrapper);
    
    //Append to shopping bag total display
    $(".BagSummary").after(addedToBagDialogue);

    // Enable or disable the checkout button in the header.
    SetCheckoutButtonEnabledState();

    //If user hovers over dialogue, cancel auto close and close on mouse leave
    $(addedToBagDialogue).hover(
                function () { $.data(this, 'hover', true); },
                function () {

                    $.data(this, 'hover', false);
                    $(this).animate({
                        //top: "+=20",
                        opacity: "0"
                    },
                    addedToBagTranSpeed, 'easeInBack',
                            function () {
                                $(".addedToBagDialogue").remove();
                                //Now check if we need to notify of any more items
                                if (NextBasket.OutboundStack.length) {
                                    //Move on to next item but don't remove it from the stack
                                    //It will be removed once the animation is half way through
                                    //This way we have more sync between the add to bag animation
                                    //And re-enabling the add-to-bag link
                                    //Without this, we may end up re-enabling the add to bag link
                                    //before notifying the user the item was added.
                                    var nextNotifyItem = NextBasket.OutboundStack[0];
                                    notifyItemAdded(nextNotifyItem);

                                } else {
                                    NextBasket.NotifyWaiting = false;
                                }
                            });
                }
                ).data('hover', false);

    //Position bag to align with shopping bag total
    var summaryOffset = $(".BagSummary").offset();
    $(addedToBagDialogue).offset({ left: summaryOffset.left, top: summaryOffset.top + 100 });

    //Animate dialogue into view
    var animatedTotal = false;
    $(addedToBagDialogue).animate({
        top: "-=50",
        opacity: "1"
    },
        { duration: addedToBagTranSpeed,
            easing: 'easeOutBack',
            step: function (now, fx) {
                //Fire off price updating animation when we're half way through the dialogue animation
                if (fx.state > 0.5) {
                    if (!animatedTotal) {
                        //Remove last item from OutBoundStack
                        //This means we can re-enable add to bag buttons at the same time as the notify dialogue reaches the 
                        //top of its animation
                        NextBasket.OutboundStack.shift();
                        priceDial(curBag);
                        animatedTotal = true;
                    }
                }
            }
        });

        
        //If more notifications are waiting to display, only show current notification for 
        //a shorter time
        if (NextBasket.OutboundStack.length) {
            addedToBagHideDelay = 100;
        } else {
            addedToBagHideDelay = 4000;
        }


    //Remove dialogue from DOM after specified time
        setTimeout(
        function () {
          
            if (!$(addedToBagDialogue).data('hover')) {
                $(addedToBagDialogue).animate({
                    // top: "+=20",
                    opacity: "0"
                },
                addedToBagTranSpeed, 'easeInBack',
                function () {
                    $(addedToBagDialogue).remove();

                    //Now check if we need to notify of any more items
                    if (NextBasket.OutboundStack.length) {
                        //Move on to next item but don't remove it from the stack
                        //It will be removed once the animation is half way through
                        var nextNotifyItem = NextBasket.OutboundStack[0];
                        notifyItemAdded(nextNotifyItem);
                    } else {
                        NextBasket.NotifyWaiting = false;
                    }


                });
            }
        }, addedToBagHideDelay);
}

function priceDial(bag) {
    //Animate price total at same time
    var oldNode = $('.BagSummaryText');
    $(oldNode).css('position', 'relative');
    var nodeClone = $(oldNode).clone();

    $(nodeClone).html(CurrencyFormat(bag.FinalOrderValue)); //(NextBasket.CurrencyFormat());

    $(oldNode).after(nodeClone);

    $(oldNode).animate({
        top: "-=17"
    }, 500, function () {
        $(oldNode).remove();
    });
    $(nodeClone).animate({
        top: "-=17"
    }, 500, function () {
        $(nodeClone).removeAttr('style');
    });

    //Update item count
    var itemCount = bag.ItemCount;
    var currentItemCountSpan = $(".BagSummaryItemCount span");
    $(currentItemCountSpan).css('position', 'relative');
    var itemCountSpanClone = $(".BagSummaryItemCount span").clone();
    $(itemCountSpanClone).html(itemCount == 0 ? "" : itemCount);
    $(currentItemCountSpan).after(itemCountSpanClone);
    $(currentItemCountSpan).animate({
        top: "-=16"
    }, 500, function () {
        $(currentItemCountSpan).remove();
    });
    $(itemCountSpanClone).animate({
        top: "-=16"
    }, 500, function () {
        $(itemCountSpanClone).removeAttr('style');
    });
}

function SetCheckoutButtonEnabledState() {

    // Enable or disable the checkout button in the header.
    if (NextBasket.Data.ItemCount > 0) {
        $(".Button.Checkout").removeClass("Disabled");
        // $(".Button.Checkout").attr("onclick", "checkOut_Click(this);");

        // Shopping bag will always be http, never https.
        var httpUrl = NextBasket.HostURL.replace('https', 'http');
        $(".Button.Checkout").attr("href", httpUrl + "/shoppingbag");

    } else {
        $(".Button.Checkout").addClass("Disabled");
        $(".Button.Checkout").removeAttr("onclick");
        $(".Button.Checkout").removeAttr("href");
    }
}

//used during vip to make sure customers are given the option to complete their order when moving between sale site and main site
function saveBagCookieForVIP() {
	var nextMainSiteBagCookie = readCookie('MainSiteBag');
	var d;

	if (NextBasket.Data.ItemCount > 0) { //update cookie if items in bag
		var cookieData = "MainSiteBag=Quantity=" + NextBasket.Data.ItemCount + "&TotalValue=" + NextBasket.Data.OrderGoodsValue + "&SaleSiteRead=False;path=/;";
		document.cookie = cookieData;
	} else {
		d = new Date();
		if (nextMainSiteBagCookie) { //check if cookie exists before removing
			document.cookie = "MainSiteBag=;expires=" + d.toGMTString() + ";path=/;";
		}
	}
}


//Initialise the basket.
NextBasket.Init(); 

// The basket is now loaded in the Header.js document ready function, as it   
// was being called before the header markup was loaded in Account Portal.

//Load the basket.
//NextBasket.Load();
