﻿
function RefreshShoppingBag(forcePageRefresh) {
    if (forcePageRefresh)
        window.location = window.location.href;

    if ($("#currentID").val() != '-1' && $("#currentID").val() != undefined) {
        PopulateShoppingBag();
    }
    CheckIfShoppingBagIsEmpty();
    attatchShoppingBagPageEvents();
}

function GetOptions(select) {
    if (select.length > 1) return;
    var itemNumberFull = $(select).closest('tr').attr('class');
    var selectedValue = $(select).val();
    var strippedItemNumber = itemNumberFull.replace(/-/g, '');
    var i = 0;
    var selectedIndex = 0;

    $.ajax({
        url: "/item/" + strippedItemNumber,
        success: function (data, textStatus, jqXHR) {
        	checkAndRedirectForAjaxError(jqXHR, false, 'ShoppingBagPage.js: GetOptions');
            var newDdl = $(data);
            $('option:first', newDdl).remove();
            $(newDdl).find('option').each(function () { //this is purely a work around.
                if ($(this).val() == selectedValue)
                    selectedIndex = i;

                $(select).append($(this));
                i++;
            });

            $('option:first', select).remove();

            select.selectedIndex = selectedIndex;

            attatchShoppingBagPageEvents();
        }
    });
}

function CheckIfShoppingBagIsEmpty() {
    var rows = 0;
    var items = NextBasket.Data["Items"];
    if (items != null && items != undefined)
        rows = items.length;
    else
        rows = $("table#items > tbody > tr").length;
        
    if (rows == 0) {
        //$("div.GoToCheckout").attr('disabled', true);
        $("div#ShoppingBagContent").fadeOut('slow');
        $("div.totalsBackground").fadeOut('slow');
        $("div.Logout").css("margin-left", "0px");
        $("div.Logout").slideDown(800);
    }
    else {
        $("div.Logout").hide();
        $("div#ShoppingBagContent").show();
        $("div.totalsBackground").show();
        //$("div.GoToCheckout").removeAttr('disabled');
    }
    CheckIfUserCanCheckOut();
}

function CheckIfUserCanCheckOut() {
    var itemsLength = 0;
    var soldOutItems = 0;
    var items = NextBasket.Data["Items"];
    if (items != null && items != undefined) itemsLength = items.length;
    if (itemsLength > 0) {
        for (var i = 0; i < itemsLength; i++) {
            if (!items[i].CanOrder)
                soldOutItems++;
        }
    }
    if (itemsLength == soldOutItems) {
        $(".GoToCheckout .ButtonText a").text("Continue Shopping").attr("href", "index.html");
        $(".GoToCheckout .ButtonText a").addClass("ContinueShopping");
        //$("div.footerRHS").hide();
        $(".HeaderTop a.Checkout").removeAttr("href");
    }
    else {
        $(".GoToCheckout .ButtonText a").text("Go to Checkout").attr("href", "/secure/checkout/transfer");
        $(".GoToCheckout .ButtonText a").removeAttr("class");
        //$("div.footerRHS").show();
        $(".HeaderTop a.Checkout").attr("href", "/secure/checkout/transfer");
    }
    ToggleContinueShoppingLink(itemsLength != soldOutItems);
}

function ToggleContinueShoppingLink(canCheckOut) {
    $("section.BreadcrumbNavigation div.Content a.ContinueShopping").remove();

    if (canCheckOut) {
        //var bookMarks = $("section.SocialBookmarks");
        var a = $('<a href="index.html">Continue Shopping</a>');
        $(a).addClass("ContinueShopping");
        if ($.browser.version == 8.0) { // ie8 is sooooo ugly, it doesnt even have a hack 
            $(a).addClass("ie8");
        }
        $("section.BreadcrumbNavigation div.Content").append(a);
    }
}

function CheckIfShoppingBagIsFull() {
    if (NextBasket.Data.IsShoppingBagFull || NextBasket.Data.LowerLimitReached)
        $('div.bag-is-full').show();
    else
        $('div.bag-is-full').hide();
}

function PopulateShoppingBag() {
    var items = NextBasket.Data["Items"];
    $("table#items tbody tr").each(function () {
        var rowExists = false;
        var rowId = parseInt($(this).attr("id"));

        if (!isNaN(rowId)) { // if not a message row 
            var isWarraty = $(this).hasClass("warranty"); // is warranty row?
            var item = null;

            for (var i = 0; i < items.length; i++) {
                if (isWarraty)
                    item = items[i].WarrantyItem;
                else
                    item = items[i];

                if (item != null && item != 'undefined') {
                    if (item.ItemID == rowId) {
                        rowExists = true;
                        PopulateQuantity($(this), item);
                        $(".availabilityColumn div", this).text(item.StockMessage);
                        var itemTot = parseFloat(item.Price) * item.Quantity;
                        $(".totalColumn .expandoHeight p.price", this).text(CurrencyFormat(itemTot));
                        var imgPath = GetAvailabilityImagePath(this, item.StockStatus);
                        $(".availabilityColumn img", this).attr("src", imgPath);
                        break;
                    }
                }
            }
            if (!rowExists)
                RemoveRow($(this));
        }
    });

    $("table.totals thead .sbTotalsColRight").text(CurrencyFormat(NextBasket.Data.OrderGoodsValue));
    //$("table.totals tbody tr td span#deliveryTotal").html(CurrencyFormat(NextBasket.Data.DeliveryCharge));

    AddOrUpdateMultibuyRow();
    DisplayIncentiveValues();

    $("table.totals tfoot tr td.sbTotalsColRight").text(CurrencyFormat(NextBasket.Data.FinalOrderValue));
    $("div#title p span#itemCount").html(NextBasket.Data.ItemCount);
    $("div#title p span#totalAmount").html(CurrencyFormat(NextBasket.Data.OrderGoodsValue));

    //$(".footerRHS .totalText").html(" TOTAL " + CurrencyFormat(NextBasket.Data.OrderGoodsValue));

    if (NextBasket.Data.OrderGoodsValue == NextBasket.Data.FinalOrderValue) { // new spec - 683
        $("table.totals thead").hide(300);
        $("table.totals tbody").hide(300);
    }

    SetShoppingBagContentMarginBottom();

    $("#currentID").val("-1");
}

function SetShoppingBagContentMarginBottom() {
    var marginBottom = $("div.totalsBackground").height() + $("div.shoppingFooterWrapper").height() + 10;
    $("section.ShoppingBag #ShoppingBagContent").css("margin-bottom", marginBottom + "px");
}

function PopulateQuantity(row, item) {
    if (item.StockStatus != 'soldout' && item.CanUpdateQty) {
        if ($(".qtyColumn select", row).length > 0) {
            $(".qtyColumn select", row).val(item.Quantity);
        }
        else {
            var select = $("<select></select>");
            $(select).addClass($(row).attr("class"));
            for (var i = 1; i <= item.MaxQuantity; i++) {
                if (i == item.Quantity) {
                    select.append('<option value="' + i + '" selected="selected">' + i + '</option>');
                }
                else {
                    select.append('<option value="' + i + '">' + i + '</option>');
                }
            }
            $(".qtyColumn", row).text("");
            $(select).change(function () {
                $("#currentID").val($(row).attr("id")); // ($(this).closest('tr').attr('id'));
                NextBasket.ItemUpdateQuantity($(row).attr("id"), $(this).val());
            });
            $(".qtyColumn", row).append(select);
        }
    }
    else {
        $(".qtyColumn select", row).remove();
        $(".qtyColumn", row).text(item.Quantity);
    }
}

function AddOrUpdateMultibuyRow() {
    CheckIfShoppingBagIsFull();
    var multibuyRow = $("table.totals tbody tr td.saving");
    if (NextBasket.Data.MultiBuyDiscount > 0) {
        
        $("table.totals tbody").show(300);
        $("table.totals thead").show(300);

        

        if (multibuyRow.length == 0) {
            var row = '<tr><td class="sbTotalsColLeft saving">' + NextBasket.Data.MultiBuyDescription + '</td>' +
                  '<td class="sbTotalsColRight">-<span id="multiBuyDiscount">' + CurrencyFormat(NextBasket.Data.MultiBuyDiscount) + '</span></td></tr>';
            $("table.totals tbody").append(row);
        }
        else
            $("table.totals tbody tr td.sbTotalsColRight span#multiBuyDiscount").html(CurrencyFormat(NextBasket.Data.MultiBuyDiscount));
    }
    else
        $(multibuyRow).closest("tr").remove();
}


function DisplayIncentiveValues() {

    CheckIfShoppingBagIsFull();

    //Clear out any existsing instentive rows
    $("table.totals td.incentive").each(function () {
        $(this).remove();
    });

   // var incentiveRow = $("table.totals tbody tr td.incentive");



    if (NextBasket.Data.ChargesAndIncentives.length > 0) {

        for (var i = 0; i < NextBasket.Data.ChargesAndIncentives.length; i++) {
            var rowString = '<tr><td class="sbTotalsColLeft saving incentive">' + NextBasket.Data.ChargesAndIncentives[i].OfferTypeDescription + '</td>' +
                  '<td class="sbTotalsColRight">' + CurrencyFormat(NextBasket.Data.ChargesAndIncentives[i].AdditionalAmount) + '</td></tr>';
            var row = $(rowString);
            
            $("table.totals tbody").append(row);
            $("table.totals tbody").show(300);
            $("table.totals thead").show(300);

        }
    }

}

function RemoveRow(row) {
    var qtySelect = $('.qtyColumn select', row);
    $(qtySelect).find('option').each(function () { // this is a work around, as the previous value is cached - Raj
        $(this).remove();
    });

    if ($(row).next("tr.info").closest("tbody").is(":last-child")) {
        $(row).closest("tr td").addClass("lastRowCell");
    }
    $(row).next("tr.info").remove();
    $(row).next("tr.warranty").remove();

    // Raj - this is a work around to make next rows (in the table) to move upwards smoothly
    $(row).children("td").each(function () {
        $(this).wrapInner("<div></div>").children("div").animate({
            height: 0
        }, 800);

        $(this).animate({
            'padding-top': 0,
            'padding-bottom': 0
        }, 800);
    });
    // ---
    $(row).animate({ opacity: 0 }, 800, function () { $(row).remove(); });
}

function GetAvailabilityImagePath(row, stockStatus) {
    var path = $(".availabilityColumn img", row).attr("src");
    path = path.substring(0, path.lastIndexOf("index.html"));

    var imgName = "in_stock.gif";
    switch (stockStatus) {
        case "delayed":
            imgName = "delayed.gif";
            break;
        case "soldout":
            imgName = "sold_out.gif";
            break;
        default:
            break;
    }
    return path + "/" + imgName;
}

function ToggleTimerDisplay(mins) {
    if (mins <= 60) {
        $("div#timer").css("visibility", "visible");
        $("div#timer div#hours").hide();
        $("div#timer div.timeRemainingHrs").hide();
    }
    else {
        $("div#timer").css("visibility", "hidden");
    }
}

function attatchShoppingBagPageEvents() {

    $('.GoToCheckout').unbind();
    $('.ContinueShopping').unbind();

    $('.ContinueShopping').bind('click', function (e) {
        if ($(this).hasClass('ContinueShopping')) {
            e.preventDefault();
            ContinueShopping();
        }
    });
}

$(document).ready(function () {

   

});



ScriptsLoadedCallback = function () {
    $('.CarouselContent').NextCarousel({ VisibleItems: 5 });
    NextBasket.Load();
}

PageVisibleCallback = function () {

    $(".sizeColumn select").click(function () {
        GetOptions(this);
    });
    $(".sizeColumn select").change(function () {
        $("#currentID").val($(this).closest('tr').attr('id'));
        NextBasket.ItemUpdateSize($(this).closest('tr').attr('id'), $(this).val());
    });
    $(".qtyColumn select").change(function () {
        $("#currentID").val($(this).closest('tr').attr('id'));
        NextBasket.ItemUpdateQuantity($(this).closest('tr').attr('id'), $(this).val());
    });
    $("table#items .totalColumn .expandoHeight a.DeleteButton").click(function () {
        $("#currentID").val($(this).closest('tr').attr('id'));
        $("#isDelete").val("true");
        NextBasket.ItemRemove($(this).closest('tr').attr('id'));
        return false;
    });

    CheckIfShoppingBagIsEmpty();
    CheckIfShoppingBagIsFull();
    SetShoppingBagContentMarginBottom();

    // short-cut way to clear off previous breadcrumbs. so that it wont affect the way breacrumbs work - Raj
    var breadCrumb = '<li class="Breadcrumb">Shopping Bag</li>';
    var i = 0;
    $("ul.Breadcrumbs li").each(function () {
        if (i > 0)
            $(this).remove();
        i++;
    });
    $("ul.Breadcrumbs").append(breadCrumb);

    // expand height of div within td to full height of td

    $('div.expandoHeight').each(function () {
        // Get their parent td's height
        var tdHeight = $(this).closest('td').height();

        // Set the div's height to their parent td's height
        $(this).height(tdHeight);
    });

    // make current selection in drop down box match color of option

    $('.selectSize').change(function () {
        $(this).attr('style', $(this).find('option:selected').attr('style'));
    }).change();
    attatchShoppingBagPageEvents();


    (function ($) {
        $.fn.extend({

            countdownClock: function () {

                return this.each(function () {

                    var $this = $(this);

                    // todo construct whole strings (with placeholders)?

                    // todo topHeight should be 11 but looks better with 10
                    var h = 23, topHeight = 10, bottomHeight = 12, t1h = 10, t2h = 6, t3h = 2, t4h = 7, t5h = 12;

                    // t = time/transition
                    // T = Top, M = Middle, B = Bottom
                    // y = y position, h = height
                    // s = sprite

                    $this.t0Th = h.toString(); $this.t1Th = (topHeight - t1h).toString(); $this.t2Th = (topHeight - t2h).toString(); $this.t345Th = (topHeight).toString();
                    $this.t012345Ty = "0";

                    $this.t1Mh = t1h.toString(); $this.t2Mh = t2h.toString(); $this.t3Mh = t3h.toString(); $this.t4Mh = t4h.toString(); $this.t5Mh = t5h.toString();
                    $this.t1My = $this.t1Th; $this.t2My = $this.t2Th; $this.t345My = $this.t345Th; // todo don't need these again

                    $this.t12Bh = bottomHeight.toString(); $this.t3Bh = (bottomHeight - t3h).toString(); $this.t4Bh = (bottomHeight - t4h).toString(); $this.t5Bh = (bottomHeight - t5h).toString();
                    $this.t12By = $this.t345Th; $this.t3By = (topHeight + t3h).toString(); $this.t4By = (topHeight + t4h).toString(); $this.t5By = (topHeight + t5h).toString();

                    $this.tTsy = "0";
                    $this.t1Msy = (-h).toString(); $this.t2Msy = (-h - t1h).toString(); $this.t3Msy = (-h - t1h - t2h).toString();
                    $this.t4Msy = (-h - t1h - t2h - t3h).toString(); $this.t5Msy = (-h - t1h - t2h - t3h - t4h).toString();
                    // -Bsy = By
                    // Ty = Tsy

                    $this.displayClock($this);
                });
            }
        });


        $.fn.displayClock = function (el) {
            $.fn.getTime(el);
            setTimeout(function () { $.fn.displayClock(el); }, $.fn.delay());
        };

        $.fn.delay = function () {
            var now = new Date();
            var delay = (60 - now.getSeconds()) * 1000;

            return delay;
        };

        $.fn.getTime = function (el) {
            // edge-case tests
            //var now = new Date(2012, 11, 12, 21, 0);
            //var now = new Date(2012, 11, 12, 21, 1);

            // todo this get's the local user's time, could do with getting current uk time (send in page, get using ajax?)
            // check bst, other timezones etc.
            var now = new Date();
            now.setSeconds(0);

            // todo pass this into ctor
            var orderDeadlineHour = 21;
            var orderDeadline = new Date(now.getTime());
            orderDeadline.setHours(orderDeadlineHour, 0, 1, 0);
            if (now.getHours() >= orderDeadlineHour) {
                orderDeadline.setDate(orderDeadline.getDate() + 1);
            }

            var timeToGo = new Date(orderDeadline.getTime() - now.getTime());

            // todo rename
            now = timeToGo;
            var old = new Date(now.getTime());
            old.setMinutes(old.getMinutes() + 1);

            var now_hours = now.getDate() > 1 ? 24 : now.getHours();
            var now_minutes = now.getMinutes();
            var old_hours = (old.getDate() > 1 && old.getMinutes() == 0) ? 24 : old.getHours();
            var old_minutes = old.getMinutes();

            // timer should be displayed only just before 1 hour to order time cap (9pm) - Raj
            var tot_minutes = (now_hours * 60) + now_minutes;
            ToggleTimerDisplay(tot_minutes);

            if (tot_minutes > 60)
                return;

            // todo put standard digit handling into function

            now_hours = ((now_hours < 10) ? "0" : "") + now_hours;
            now_minutes = ((now_minutes < 10) ? "0" : "") + now_minutes;
            old_hours = ((old_hours < 10) ? "0" : "") + old_hours;
            old_minutes = ((old_minutes < 10) ? "0" : "") + old_minutes;

            var firstHourDigit = old_hours.substr(0, 1);
            var secondHourDigit = old_hours.substr(1, 1);
            var firstMinuteDigit = old_minutes.substr(0, 1);
            var secondMinuteDigit = old_minutes.substr(1, 1);

            var firstHourNewDigit = now_hours.substr(0, 1);
            var secondHourNewDigit = now_hours.substr(1, 1);
            var firstMinuteNewDigit = now_minutes.substr(0, 1);
            var secondMinuteNewDigit = now_minutes.substr(1, 1);

            // 0, 1, 2 ...
            var digitWidth = 24;
            // change name: exclude minute
            var secondMinuteDigitXPos = "-" + parseInt(secondMinuteDigit) * digitWidth;
            var secondMinuteNewDigitXPos = "-" + parseInt(secondMinuteNewDigit) * digitWidth;

            var fmdXPos = "-" + parseInt(firstMinuteDigit) * digitWidth;
            var fmdNewXPos = "-" + parseInt(firstMinuteNewDigit) * digitWidth;

            var shdXPos = "-" + parseInt(secondHourDigit) * digitWidth;
            var shdNewXPos = "-" + parseInt(secondHourNewDigit) * digitWidth;

            var fhdXPos = "-" + parseInt(firstHourDigit) * digitWidth;
            var fhdNewXPos = "-" + parseInt(firstHourNewDigit) * digitWidth;

            // todo need to set default style in css
            $.fn.digitT0(el, '#fhd', fhdXPos);
            $.fn.digitT0(el, '#shd', shdXPos);

            $.fn.digitT0(el, '#fmd', fmdXPos);
            $.fn.digitT0(el, '#smd', secondMinuteDigitXPos);

            // use class instead of style for digit url selection etc?
            // calc nums?

            setTimeout(function () {
                // t1
                $.fn.digitT1(el, '#fhd', fhdNewXPos, fhdXPos);
                $.fn.digitT1(el, '#shd', shdNewXPos, shdXPos);

                $.fn.digitT1(el, '#fmd', fmdNewXPos, fmdXPos);
                $.fn.digitT1(el, '#smd', secondMinuteNewDigitXPos, secondMinuteDigitXPos);

            }, 125);
            setTimeout(function () {
                $.fn.digitT2(el, '#fhd', fhdNewXPos, fhdXPos);
                $.fn.digitT2(el, '#shd', shdNewXPos, shdXPos);

                $.fn.digitT2(el, '#fmd', fmdNewXPos, fmdXPos);
                $.fn.digitT2(el, '#smd', secondMinuteNewDigitXPos, secondMinuteDigitXPos);

            }, 250);
            setTimeout(function () {
                // t3
                $.fn.digitT3(el, '#fhd', fhdNewXPos, fhdXPos);
                $.fn.digitT3(el, '#shd', shdNewXPos, shdXPos);

                $.fn.digitT3(el, '#fmd', fmdNewXPos, fmdXPos);
                $.fn.digitT3(el, '#smd', secondMinuteNewDigitXPos, secondMinuteDigitXPos);

            }, 375);
            setTimeout(function () {
                // t4
                $.fn.digitT4(el, '#fhd', fhdNewXPos, fhdXPos);
                $.fn.digitT4(el, '#shd', shdNewXPos, shdXPos);

                $.fn.digitT4(el, '#fmd', fmdNewXPos, fmdXPos);
                $.fn.digitT4(el, '#smd', secondMinuteNewDigitXPos, secondMinuteDigitXPos);

            }, 500);
            setTimeout(function () {
                // t5
                $.fn.digitT5(el, '#fhd', fhdNewXPos, fhdXPos);
                $.fn.digitT5(el, '#shd', shdNewXPos, shdXPos);

                $.fn.digitT5(el, '#fmd', fmdNewXPos, fmdXPos);
                $.fn.digitT5(el, '#smd', secondMinuteNewDigitXPos, secondMinuteDigitXPos);

            }, 625);

            setTimeout(function () {
                // back to t0
                $.fn.digitT0(el, '#fhd', fhdNewXPos);
                $.fn.digitT0(el, '#shd', shdNewXPos);

                $.fn.digitT0(el, '#fmd', fmdNewXPos);
                $.fn.digitT0(el, '#smd', secondMinuteNewDigitXPos);

            }, 750);
        };

        $.fn.digitT0 = function ($this, digitIdRoot, digitXPos) {
            $(digitIdRoot).attr('style', 'height:' + $this.t0Th + 'px; width:25px; top:' + $this.t012345Ty + 'px; background-position: ' + digitXPos + 'px ' + $this.tTsy + 'px;');
            $(digitIdRoot + 'm').attr('style', 'display: none;');
            $(digitIdRoot + 'b').attr('style', 'display: none;');
        };

        $.fn.digitT = function ($this, digitIdRoot, newDigitXPos, oldDigitXPos, Th, Mh, My, Msy, Bh, By) {
            if (newDigitXPos != oldDigitXPos) {
                $(digitIdRoot).attr('style', 'height:' + Th + 'px; width:25px; top:' + $this.t012345Ty + 'px; background-position: ' + newDigitXPos + 'px ' + $this.tTsy + 'px;');
                $(digitIdRoot + 'm').attr('style', 'height:' + Mh + 'px; width:25px; top:' + My + 'px; background-position: ' + oldDigitXPos + 'px ' + Msy + 'px;');
                $(digitIdRoot + 'b').attr('style', 'height:' + Bh + 'px; width:25px; top:' + By + 'px; background-position: ' + oldDigitXPos + 'px -' + By + 'px;');
            }
        };

        $.fn.digitT1 = function ($this, digitIdRoot, newDigitXPos, oldDigitXPos) {
            $.fn.digitT($this, digitIdRoot, newDigitXPos, oldDigitXPos, $this.t1Th, $this.t1Mh, $this.t1My, $this.t1Msy, $this.t12Bh, $this.t12By);
        };

        $.fn.digitT2 = function ($this, digitIdRoot, newDigitXPos, oldDigitXPos) {
            $.fn.digitT($this, digitIdRoot, newDigitXPos, oldDigitXPos, $this.t2Th, $this.t2Mh, $this.t2My, $this.t2Msy, $this.t12Bh, $this.t12By);
        };

        $.fn.digitT3 = function ($this, digitIdRoot, newDigitXPos, oldDigitXPos) {
            $.fn.digitT($this, digitIdRoot, newDigitXPos, oldDigitXPos, $this.t345Th, $this.t3Mh, $this.t345My, $this.t3Msy, $this.t3Bh, $this.t3By);
        };

        $.fn.digitT4 = function ($this, digitIdRoot, newDigitXPos, oldDigitXPos) {
            $.fn.digitT($this, digitIdRoot, newDigitXPos, oldDigitXPos, $this.t345Th, $this.t4Mh, $this.t345My, $this.t4Msy, $this.t4Bh, $this.t4By);
        };

        $.fn.digitT5 = function ($this, digitIdRoot, newDigitXPos, oldDigitXPos) {
            $.fn.digitT($this, digitIdRoot, newDigitXPos, oldDigitXPos, $this.t345Th, $this.t5Mh, $this.t345My, $this.t5Msy, $this.t5Bh, $this.t5By);
        };

    })(jQuery);

    $('#hours').countdownClock();



    setTimeout(function () {
        $('.BagSummaryText').html(CurrencyFormat(NextBasket.Data.FinalOrderValue));
    }, 500);


}

