//Speed of box fade in/out
var fSpeed = 400;
//Transition/animation speed of carousels
var tranSpeed = 300;
var currentTab;
var ULIndex = -1;
var intervalIndex = 0;
//Carousel animation interval
var cInterval = null;
var cIntervalTime = 7000;
//Disable hero navigation during animation
var isAnimating = false;
//Number of items to animate sub carousel by
var subCarouselIncrement = 1;
var carouselIntervalTimer;

//Hover delay config
var config = {
    over: slideIn,
    timeout: 10,
    out: slideOut
};

var fadeConfig = {
    over: fadeIn,
    timeout: 10,
    out: fadeOut
};


function PageInitialise() {

    //Only init hero carousel if there's more than 1 image/item
    if ($("ul.heroCarousel li").size() > 1) {

        clearInterval(cInterval);
        $(".heroCarouselDisplay").remove();
        //Build hero carousel
        heroCarousel();
        //Load hidden hero images
        setTimeout(function () { loadHeroImages(); }, 1000);
        //Set carousel animation interval
        //cInterval = setInterval(carouselAutoScroll, cIntervalTime);
        //Pause animation on hover (hover wraps up mouseenter() and mouseleave() event bindings)
        $(".heroCarousel li").hover(
                            function () {
                                clearInterval(cInterval);
                            },
                            function () {
                                cInterval = setInterval(carouselAutoScroll, cIntervalTime);
                            }
                       );

    }

    //Positon "show more" links
    if (!($.browser.msie && $.browser.version < 7)) {
        $(".showMoreWrapper").each(function () {
            var itemContentOffset = $(this).prev().offset();
            if ($(this).width() > $(this).prev().width()) {
                var offset = (itemContentOffset.left - ($(this).width() / 2)) + ($(this).prev().width() / 2) - 2;
                $(this).offset({ left: offset });
            }
        });
    }

    //Close sub carousel hover event
    $("a.closeSubCarousel").hover(
                            function () {
                                closeSubCarouselHover(this);
                            },
                            function () {
                                closeSubCarouselOut(this);
                            }
                       );


    //Handle 'show more' link click
    $("a.showMore").click(function () {
        var curSubCarousel = $(this).closest(".featureList").find(".showMoreWrapperOpen").next();
        var curLink = $(this);
        var linkWrapper = $(this).parent();
        var carouselWrapper = $(this).parent().next();
        var featureUL = $(this).parent().parent().parent();

        var contentWrapper = $("#ContentArea");
        var currentWrapperHeight = $(contentWrapper).height();
        var wrapperExpand = 255;


        //check if new carousel is being opened
        var newCarousel = false;
        if ($(featureUL).hasClass("open") && (!$(this).hasClass("active"))) {
            newCarousel = true;
        }

        //Current active UL
        ULIndex = $(featureUL).index();

        //Set current selected tab (by <li> index)
        currentTab = $(this).parent().parent().index();
        //Each carousel needs to be positioned in the same location.
        //position to parent offset
        var parentOffset = $(featureUL).offset();
        var targetOffset = parentOffset.left;
        //If a new tab has is being opened and a previous carousel is already opened, close this first
        if (newCarousel && $(featureUL).hasClass("open")) {
            if ($.browser.msie && $.browser.version < 7) {
                //IE6 Is too jumpy on the amination - click open/closed
                $(featureUL).height(300);
            }
            //Animate close/open when an existing tab is already open

            //            $(contentWrapper).animate({
            //                height: "-=" + wrapperExpand
            //            }, tranSpeed)

            //$(featureUL).switchClass("open", "closed", tranSpeed, function () {
            $(curSubCarousel).fadeOut(50, function () {
                //Once closed, show new carousel and style links
                $(featureUL).find(".showMore").removeClass("active");
                if (!($.browser.msie && $.browser.version < 7)) {
                    $(featureUL).find(".showMoreWrapper").removeClass("showMoreWrapperOpen");
                }
                $(featureUL).find(".showMore").find("span").text("Open");
                $(featureUL).find(".showMore").attr("title", "Open");
                $(curLink).addClass("active");
                $(curLink).find("span").text("Close");
                $(curLink).attr("title", "Close");
                $(featureUL).find(".subCarousel").hide();

                $(carouselWrapper).fadeIn(500);


                $(carouselWrapper).offset({ left: targetOffset });
                //Reopen tab with new content

                //                $(contentWrapper).animate({
                //                    height: "+=" + wrapperExpand
                //                }, tranSpeed)

                if ($.browser.msie && $.browser.version < 7) {
                    $(featureUL).height(550);
                }
                if (!($.browser.msie && $.browser.version < 7)) {
                    $(linkWrapper).addClass("showMoreWrapperOpen");
                }
                //                $(featureUL).switchClass("closed", "open", tranSpeed, function () {
                //                });
                // });

                scrollToCarousel(carouselWrapper);
            });

        } else {


            if ($(featureUL).hasClass("closed")) {

                if ($.browser.msie && $.browser.version < 7) {
                    $(featureUL).height(550);
                    $(featureUL).removeClass("closed");
                    $(featureUL).addClass("open");

                } else {
                    $(linkWrapper).addClass("showMoreWrapperOpen");
                    $(featureUL).switchClass("closed", "open", tranSpeed, function () {
                    });

                    $(contentWrapper).animate({
                        height: "+=" + wrapperExpand
                    }, tranSpeed);

                }
                $(curLink).addClass("active");
                $(carouselWrapper).show();
                $(curLink).find("span").text("Close");
                $(curLink).attr("title", "Close");

                scrollToCarousel(carouselWrapper);

            } else {

                if ($.browser.msie && $.browser.version < 7) {
                    $(featureUL).height(300);
                    $(featureUL).removeClass("open");
                    $(featureUL).addClass("closed");
                    $(featureUL).find(".showMore").removeClass("active");
                    $(curLink).find("span").text("Open");
                    $(curLink).attr("title", "Open");
                    //All tabs are closed, set active UL index to -1
                    ULIndex = -1;
                    $(carouselWrapper).hide();
                } else {
                    $(featureUL).switchClass("open", "closed", tranSpeed, function () {
                        $(featureUL).find(".showMore").removeClass("active");
                        $(curLink).find("span").text("Open");
                        $(curLink).attr("title", "Open");
                        //All tabs are closed, set active UL index to -1
                        ULIndex = -1;
                        $(carouselWrapper).hide();
                        $(linkWrapper).removeClass("showMoreWrapperOpen");
                    });


                    $(contentWrapper).animate({
                        height: "-=" + wrapperExpand
                    }, tranSpeed);

                }
            }
        }
        $(carouselWrapper).offset({ left: targetOffset });
        return false;
    });

    $(".subCarousel").each(function () {
        var ul = $(this).find("ul").first();
        carousel(ul);
    });

    //Handle ie and older browsers
    if ($.browser.msie) {
        ieActions();
    }
    //Create rollover states for sub feature blocks
    buildHoverBlocks();

    //Set image rollover for top level features
    $("div.topLevelItem").hoverIntent(config);
    //Set image rollover for sub carousel items
    $("div.subItem").hoverIntent(fadeConfig);

    // Redirect clicks on rollover block p's.
    $(".featureInfo p").click(function () {
        window.location.href = $(this).siblings("a").attr("href");
    });
}

function scrollToCarousel(carouselWrapper) {
    // If the bottom of the carousel wrapper is below the bottom of the screen, scroll so that it's all visible.
    if ($(carouselWrapper).offset().top - $(window).scrollTop() + $(carouselWrapper).height() > $(window).height())
        $("html,body").animate({ scrollTop: $(window).scrollTop() + $(carouselWrapper).height() }, "easeOutCubic");
}

function carouselAutoScroll() {
    //Navigating between pages can duplicate the interval
    //Check elapsed time from last interval
    var checkInterval = true;
    if (carouselIntervalTimer == null) {
        checkInterval = false;
        carouselIntervalTimer = new Date().getTime();
    }

    if (checkInterval) {
        var elapsed = new Date().getTime() - carouselIntervalTimer;
        if (elapsed < (cIntervalTime - 20)) { return false; }
    }

    carouselIntervalTimer = new Date().getTime();

    //If page isn't focused, remove scroll
    if (!$("body").hasClass("Focus")) {
        return false;
    }

    //If content from another URL is loaded, clear the interval
    if ($(".Homepage").length == 0) {
        clearInterval(cInterval);
        return false;
    }

    intervalIndex++;
    showHero(intervalIndex);
}



function resetHeroCarousel() {
    clearInterval(cInterval);
    cInterval = null;
    intervalIndex = 0;
    //carouselIntervalTimer = null;

}

//Load images that weren't loaded on page load
function loadHeroImages() {

    resetHeroCarousel();

    $("ul.heroCarousel li").each(function () {
        var heroImg = $(this).find("img").first();
        var src = "";
        if (!$(heroImg).attr("src")) {
            src = $(heroImg).attr("alt");
        }
        if (src.length) {
            $(heroImg).attr("src", src);
        }
    });

    cInterval = setInterval(carouselAutoScroll, cIntervalTime);
}

function showHero(index) {
    //prevent selection during animation
    if (isAnimating) {
        return false;
    }

    if ($('ul.PrimaryNavigation li.Department.Active').length > 0) {
        return false;
    }

    var heroUL = $(".heroCarousel");
    var heroCount = $(heroUL).children().length;
    var heroDisplayUL = $(".heroCarouselDisplay");
    var firstLI = $(heroDisplayUL).find("li").get(0);
    var currentHero = $(heroDisplayUL).find("li").get(1);
    var currentIndex = parseInt($(currentHero).attr("data-itemIndex"));

    //If user selects current, live hero, do nothing
    if (index == currentIndex) {
        return false;
    }

    //Animation has started
    isAnimating = true;

    //Handle next/previous 
    if (index == 'prev') { index = parseInt(currentIndex - 1); }
    if (index == 'next') { index = parseInt(currentIndex + 1); }

    var loopToStart = false;
    var loopToEnd = false;

    if (index >= heroCount) {
        index = 0;
        loopToStart = true;
    }

    if (index < 0) {
        index = heroCount - 1;
        loopToEnd = true;
    }
    //Get copy of next item
    var nextHero = $(heroUL).find('li[data-itemIndex="' + index + '"]').clone();


    intervalIndex = index;

    //Update selected link class
    $(".heroNav").find("li").each(function () {
        $(this).removeClass("active");
        if ($(this).index() == index + 1) {
            $(this).addClass("active");
        }
    });

    //If list is looping from start to finish, force animation to work from different direction so movement is continuous
    //Safe to change index here as we have already cloned the item
    if (loopToStart) {
        index = heroCount + 1;
    }
    if (loopToEnd) {
        index = -1;
    }


    if (currentIndex < index) {
        $(nextHero).insertAfter(currentHero);

        var targetOffset = $("#heroWrapper").offset();
        //$(heroDisplayUL).removeAttr("style");

        $(heroDisplayUL).offset({ left: targetOffset.left });

        //$(heroDisplayUL).offset({ left: 0 });

        $(heroDisplayUL).find("li").first().remove();
        $(heroDisplayUL).animate({
            left: '-=964px'
        }, 600, 'easeOutQuart', function () {
            //Animation has ended
            isAnimating = false;
        });
    }
    if (currentIndex > index) {
        $(firstLI).replaceWith(nextHero);
        var newFirstLI = $("<li />");
        $(newFirstLI).insertBefore(nextHero);

        var currentOffset = $(heroDisplayUL).offset();
        $(heroDisplayUL).offset({ top: currentOffset.top, left: (currentOffset.left - 964) })
        $(heroDisplayUL).find("li").last().remove();
        $(heroDisplayUL).animate({
            left: '+=964px'
        }, 600, 'easeOutQuart', function () {
            //Animation has ended
            isAnimating = false;
        });
    }

}




function closeSubCarouselHover(link) {


    $(link).find("span").first().animate({
        opacity: 1
    }, 500
     );


}

function closeSubCarouselOut(link) {

    //    $(link).animate({
    //        width: 10
    //    }, 200
    //     );

    $(link).find("span").first().animate({
        opacity: 0
    }, 500
     );
}


function closeCarousel(link) {
    var carouselWrapper = $(link).parent();
    var wrapperExpand = 255;
    var contentWrapper = $("#ContentArea");

    var targetUL = $(link).closest(".featureList");

    if ($.browser.msie && $.browser.version < 7) {
        $(targetUL).height(300);
        $(targetUL).removeClass("open");
        $(targetUL).addClass("closed");
        $(targetUL).find(".showMore").removeClass("active");
        $(targetUL).find(".showMoreWrapper").removeClass("showMoreWrapperOpen");
        $(targetUL).find("a.showMore span").text("Open");
        $(targetUL).find("a.showMore").attr("title", "Open");

        $(carouselWrapper).hide();
    } else {
        $(targetUL).switchClass("open", "closed", tranSpeed, function () {
            $(targetUL).find(".showMore").removeClass("active");

            $(carouselWrapper).hide();

            $(targetUL).find(".showMoreWrapper").removeClass("showMoreWrapperOpen");
            $(targetUL).find("a.showMore span").text("Open");
            $(targetUL).find("a.showMore").attr("title", "Open");
        });

    }


    $(contentWrapper).animate({
        height: "-=" + wrapperExpand
    }, tranSpeed);

}

//Different browsers handle fades more effectively than others - return most effective fade speeds based on browser
function getFadeSpeed(defaultSpeed) {
    var blockFadeSpeed = 300;
    if ($.browser.msie) {
        if ($.browser.version < 9) {
            blockFadeSpeed = 75;
        }
        if ($.browser.version < 8) {

            if (defaultSpeed) {
                blockFadeSpeed = defaultSpeed;
            } else {
                blockFadeSpeed = 100;
            }

        }

        if ($.browser.version < 7) {
            blockFadeSpeed = 0;
        }
    }

    return blockFadeSpeed;
}

//Slide feature item info in
function slideIn() {
    $(this).find(".featureInfo").first().animate({

        top: "-=120"
    }, 450, "easeOutBack");
}
//Slide feature item out
function slideOut() {
    $(this).find(".featureInfo").first().animate({

        top: "+=120"
    }, 450, "easeInBack");
}
//Fade sub carousel item in
function fadeIn() {
    var blockFadeSpeed = getFadeSpeed();

    $(this).find(".featureInfo").first().fadeOut(blockFadeSpeed);
    $(this).find(".infoOver").first().fadeIn(blockFadeSpeed);
}
//Fade sub carousel item out
function fadeOut() {
    var blockFadeSpeed = getFadeSpeed();
    $(this).find(".featureInfo").first().fadeIn(blockFadeSpeed);
    $(this).find(".infoOver").first().fadeOut(blockFadeSpeed);
}
//Create hover states for sub carousel items
function buildHoverBlocks() {

    $(".subItemInfo").each(function () {
        var fiClone = $(this).clone();
        var offset = $(this).offset();
        $(fiClone).addClass("infoOver");
        $(fiClone).find("h3").removeAttr("style");
        if ($.browser.msie) {
            if ($.browser.version < 9 && $.browser.version > 6) {
                $(fiClone).addClass("ie7");
            }
            if ($.browser.version < 7) {
                $(fiClone).addClass("ie6");
            }
        }

        $(this).parent().append(fiClone);
    });

}

function ieActions() {
    var version = $.browser.version;

    if (version < 7) {
        $(".featureList").height(300);
        $(".showMoreWrapper").addClass("wrapperIE6");
    }


}

function getIntFromPixelValue(pixelValue) {
    if (!pixelValue) { return 0; }
    pixelValue = pixelValue.replace('px', '');
    return parseInt(pixelValue);
}

function carousel(ul) {
    $(ul).wrap('<div class="carouselClip" />');
    var li = $(ul).find("li").first();
    //Get the true item width including padding and margin
    var liWidth = getIntFromPixelValue($(li).css("width"));
    var liPaddingLeft = getIntFromPixelValue($(li).css("padding-left"));
    var liPaddingRight = getIntFromPixelValue($(li).css("padding-left"));
    var marginLeft = getIntFromPixelValue($(li).css("margin-left"));
    var marginRight = getIntFromPixelValue($(li).css("margin-right"));
    var totalLIWidth = liWidth + liPaddingLeft + liPaddingRight + marginLeft + marginRight;

    var liCount = $(ul).children().length;

    var totalFrames = (Math.ceil(liCount / subCarouselIncrement)) - 3;
    $(ul).attr("data-totalFrames", totalFrames);
    $(ul).attr("data-currentFrame", 1);

    $(ul).width(liCount * totalLIWidth);

    var ulOffset = $(ul).offset();
    var arrowLeft = $("<a href=\"#\" class=\"carouselLeft\">Left</a>");
    var arrowRight = $("<a href=\"#\" class=\"carouselRight\">Right</a>");

    if ($.browser.msie && $.browser.version < 8) {
        $(arrowLeft).addClass("ie7");
        $(arrowRight).addClass("ie7");
    }

    if ($.browser.msie && $.browser.version < 7) {
        $(arrowLeft).addClass("ie6Left");
        $(arrowRight).addClass("ie6Right");
    }
    //Hide left pointing arrow on page load
    $(arrowLeft).hide();
    //Hide right arrow also if no scrolling is required
    if (liCount <= 4) {
        $(arrowRight).hide();
    }

    $(arrowLeft).click(function () {

        //Prevent adding animation while animating
        if ($(this).hasClass("isAnimating")) {
            return false;
        }

        $(this).addClass("isAnimating");
        var arrLeft = $(this);

        $(this).parent().find(".carouselRight").fadeIn(getFadeSpeed(1));
        var targetUL = $(this).parent().find(".carouselClip").find("ul");
        var ulFrames = $(targetUL).attr("data-totalFrames");
        var curUlFrame = $(targetUL).attr("data-currentFrame");
        curUlFrame--;
        $(targetUL).attr("data-currentFrame", curUlFrame);
        if (curUlFrame == 1) {
            $(this).fadeOut(getFadeSpeed(1));
        }
        $(this).parent().find(".carouselClip").find("ul").animate({
            left: "+=" + subCarouselIncrement * totalLIWidth
        }, 500, function () { $(arrLeft).removeClass("isAnimating"); });

        return false;
    });

    $(arrowRight).click(function () {

        if ($(this).hasClass("isAnimating")) {
            return false;
        }

        $(this).addClass("isAnimating");
        var arrRight = $(this);

        $(this).parent().find(".carouselLeft").fadeIn(getFadeSpeed(1));
        var targetUL = $(this).parent().find(".carouselClip").find("ul");
        var ulFrames = $(targetUL).attr("data-totalFrames");
        var curUlFrame = $(targetUL).attr("data-currentFrame");
        curUlFrame++;
        $(targetUL).attr("data-currentFrame", curUlFrame);
        if (curUlFrame == ulFrames) {
            $(this).fadeOut(getFadeSpeed(1));
        }
        $(targetUL).animate({
            left: "-=" + subCarouselIncrement * totalLIWidth
        }, 500, function () { $(arrRight).removeClass("isAnimating"); });
        return false;
    });

    //Add links
    $(ul).parent().before($(arrowLeft));
    $(ul).parent().before($(arrowRight));

}

function heroCarousel() {


    if ($("ul.heroCarousel li").size() == 1) {
        return false;
    }

    //Hide parent carousel
    $("ul.heroCarousel").css("display", "none");

    //Get Hero UL
    var heroUL = $("#heroWrapper").find(".heroCarousel").first();
    //Create hero nav container
    var heroNavWrapper = $("<div class=\"heroNavWrapper\" />");
    var heroNav = $("<ul class=\"heroNav\" />");
    var liCount = 0;
    //Loop through each hero item/create navigation
    var prevLink = $("<li class=\"previous\"><a href=\"#\" onclick=\"showHero('prev'); return false;\" >Previous</a></li>");
    $(heroNav).append(prevLink);
    $(heroUL).find("li").each(function () {
        $(this).attr("data-itemIndex", liCount);
        var classString = "";
        if (liCount == 0) {
            classString = " class=\"active\" ";
        } else {
            classString = "";
        }
        var li = $("<li" + classString + "><a href=\"#\" onclick=\"showHero(" + liCount + "); return false;\" >" + liCount + "</a></li>");
        $(heroNav).append(li);
        liCount++;
    });
    var nextLink = $("<li class=\"next\"><a href=\"#\" onclick=\"showHero('next'); return false;\" >Next</a></li>");
    $(heroNav).append(nextLink);
    $(heroNavWrapper).append(heroNav);
    $("#heroWrapper").prepend(heroNavWrapper);

    var carouselCopy = $("<ul class=\"heroCarouselDisplay\" />");
    var firstPlaceholderLI = $("<li class=\"first\" />");
    var lastPlaceholderLI = $("<li class=\"last\" />");
    var firstLi = $(heroUL).find("li").first().clone();
    $(carouselCopy).append(firstPlaceholderLI);
    $(carouselCopy).append(firstLi);
    $(carouselCopy).append(lastPlaceholderLI);
    $("#heroWrapper").append(carouselCopy);
    $(carouselCopy).attr("style", "left: -964px;");

}

var PageVisibleCallback = function () {
    cInterval = null;
    PageInitialise();
    UpdateContinueShopping();
}
