// Quickshop JS - version1 - 17/01/12

$(document).ready(function () {
    // hide delete button(s)
    $('a.DeleteRow').hide();

    // register delete row event 
    $('a.DeleteRow').live("click", (function () {
        clearUpTheRow($(this).closest("tr"));
        $(this).hide();
    }));
})

// Clear the row when remove button is clicked - I have to write this method becoz existing methods are causing problems in ie8 & 7
function clearUpTheRow(row) {
    ClearAddToBagError();
    $(row).animate({ opacity: 0.0 }, 600);

    $(".Desc", row).text("");
    $(".Item", row).html("");
    $(".Size select, input, span, div", row).remove();

    var rowId = $(row).attr("id");

    var size = '<input id="S' + rowId + '" class="ItemSize" type="text" value="">';
    $(".Size", row).append(size);

    var item = '<input id="I' + rowId + '" class="ItemNumber" data-error="" type="text" value="" maxlength="11"><div class="clearboth"><!-- DO NOT REMOVE --></div>';
    $(".Item", row).append(item);
    
    $(row).removeClass("NotFound").removeClass("Found");
    $(row).animate({ opacity: 1.0 }, 600);
    $("td.Item input.ItemNumber", row).focus();

    // Re-Init the row
    $(row).quickShopRow();
}

function getFormattedItem(chars) {
    var result = chars.replace(/-/g, '').replace(/ /g, '');
    return result;
}

// // VISUAL EFFECTS // //

// on focus 1st input, makes row .Active	
$('.ItemNumber').bind('focus', (function () {
    if ($(this).parent().parent().prev("tr").hasClass("Active")) {
        //$(this).parent().parent().find(".DeleteRow").animate({ opacity: 1.0 });
        $(this).parent().parent().addClass("Active", 1);
    };
}));

// click on row to make .Active	
$('#qsTable tr').bind('click', (function () {
    if ($(this).prev("tr").hasClass("Active")) {
        //$('.DeleteRow', this).animate({ opacity: 1.0 });
        $(this).addClass("Active", 1);
    };
}));

function addToBag(Position) {
    ClearAddToBagError();
    var bAddItemsToBag = true;

    // Get the Basket Version Number so we can create a NextBasketItems object
    // If the session was created without a bag, then it will be null, so check if the version exists before grabbing it from the bag
    var nextBasketVer = 0;
    if (NextBasket.Data !== null && NextBasket.Data.Version !== null)
        nextBasketVer = NextBasket.Data.Version;

    var itemstoadd = new NextBasketItems(nextBasketVer);

    for (i = 1; i <= 10; i++) {
        var itemrow,
            item,
		    option,
			optionText,
            optionSelect,
            itemFound;

        itemrow = $('#QS' + i);
        itemInput = $('#IQS' + i);
        item = $('#IQS' + i).val(); // document.getElementById('IQS' + i).value;
        option = $('#SQS' + i).val(); // document.getElementById('SQS' + i).value;
        optionText = $('#SQS' + i + ' option').filter(':selected').text();
        itemFound = ($('#QS' + i).hasClass('Found')) ? true : false; // Check whether the item has been validated
        optionSelect = $('#SQS' + i);

        if (itemrow.hasClass("NotFound")) {
            HighlightInputError(itemInput)
            bAddItemsToBag = false;
        }

        if (optionText == "--") {
            HighlightInputError(optionSelect);
            PrependSizeError($(itemrow).children(".Desc"));
            bAddItemsToBag = false;
        } else {
            optionSelect.removeClass("Error");
        	if (itemFound && item != null && item != "" && option != null && option != "") {
        		itemstoadd.ItemAdd(item, option);
        	}
        }
    }
    // If we want to add a media code, this is where we would do it
    //itemstoadd.MediaCode = '';
    if (bAddItemsToBag && itemstoadd.Items.length > 0) {
        NextBasket.ItemAddMultiple(itemstoadd, true);
    } else {
        ShowAddToBagError(Position);
        return false;
    }
}

function ShowAddToBagError(Position) {
    var targetSelector = '.AddToBagError.' + Position;
    var targetError = $(targetSelector);
    if (!targetError.hasClass("Show")) {
        var Animation = createAnimation()
        addToAnimation(Animation, '$("' + targetSelector + '").fadeIn(500);', 500, true);
        addToAnimation(Animation, '$("' + targetSelector + '").addClass("Show");', 0, true);
        addToAnimation(Animation, '$("' + targetSelector + '").removeAttr("style");', 0, false);
        runAnimation(Animation);
    }
}

function ClearAddToBagError() {
    var targetSelector = '.AddToBagError.Show';
    var Animation = createAnimation()
    addToAnimation(Animation, '$("' + targetSelector + '").fadeOut(500);', 500, true);
    addToAnimation(Animation, '$("' + targetSelector + '").removeClass("Show");', 0, true);
    addToAnimation(Animation, '$("' + targetSelector + '").removeAttr("style");', 0, false);
    runAnimation(Animation);
}

function AppendSizeError(target) {
    //target is a jQuery Object
    if (target.children(".NoSize").length == 0) {
        target.append('<div class="NoSize ErrorDesc">Please select a size for this item.</div>');
    }
}

function PrependSizeError(target) {
    //target is a jQuery Object
    if (target.children(".NoSize").length == 0) {
        target.prepend('<div class="NoSize ErrorDesc">Please select a size for this item.</div>');
    }
}

function ClearSizeError(target) {
    //target is a jQuery Object
    target.children(".NoSize").remove();
}

function HighlightInputError(target) {
    //target is a jQuery Object
    if (!target.hasClass("InputError")) {
        target.addClass("InputError");
    }
}

function ClearInputError(target) {
    //target is a jQuery Object
    if (target.hasClass("InputError")) {
        target.removeClass("InputError");
    }
}

function addDirToBag(itemNo) {

    var itemtoadd = new NextBasketItems(NextBasket.Data.Version);
    var item, option;

    item = itemNo;
    option = "01";
    itemtoadd.ItemAdd(item, option);

    NextBasket.ItemAddMultiple(itemtoadd, true);

}

function QSSelectChange(SelectBox) {
    ClearAddToBagError();
    targetIndex = $(SelectBox).attr("data-index");
    var targetSelect = $('#SQS' + targetIndex);
    var targetRow = $('#QS' + targetIndex);

    if (SelectBox.options[SelectBox.selectedIndex].text != "--") {
        ClearInputError($(SelectBox));
        ClearSizeError($(targetRow).children(".Desc"));
    } else {
        HighlightInputError($(SelectBox));
        PrependSizeError($(targetRow).children(".Desc"));
    }
}

function QSTextChange(InputBox) {
    ClearAddToBagError();
    ClearInputError($(InputBox));
}

// // HELPERS // //

// http://stackoverflow.com/questions/2897155/get-caret-position-within-an-text-input-field
new function ($) {
    $.fn.getCursorPosition = function () {
        var pos = 0;
        var input = $(this).get(0);

        if (input === undefined || input === null)
            return 0;

        // IE Support
        if (document.selection) {
            input.focus();
            var sel = document.selection.createRange();
            var selLen = document.selection.createRange().text.length;
            sel.moveStart('character', -input.value.length);
            pos = sel.text.length - selLen;
        }
        // Firefox support
        else if (input.selectionStart || input.selectionStart == '0')
            pos = input.selectionStart;

        return pos;
    }
} (jQuery);

// http://jsfiddle.net/mnbayazit/WpqsN/
new function ($) {
    $.fn.setCursorPosition = function (start, end) {
        return this.each(function () {
            if (this.setSelectionRange) {
                this.focus();
                this.setSelectionRange(start, end);
            } else if (this.createTextRange) {
                var range = this.createTextRange();
                range.collapse(true);
                range.moveEnd('character', end);
                range.moveStart('character', start);
                range.select();
            }
        });
    };
} (jQuery);

// ------------------------------------------------------------------------------------------ //
// Name: Quick Shop
// Author: Amar Mehan
// Copyright: Next PLC
// Description: A collection of functions used by the Quick Shop Page Rows
// ------------------------------------------------------------------------------------------ //


// -----------------------------------------PLUGINS----------------------------------------- //

// QUICK SHOP PLUGIN
(function ($) {

    // Methods for this plugin
    var methods = {

        // -----------------------------------------FUNCTIONS----------------------------------------- //

        // Initialize the row
        init: function (options) {
            return this.each(function () {
                var $this = $(this);
                var rowId = $this.attr('id');

                // If we want to trigger the validation and item get as the user is entering the item number, then uncomment the following block
                /*
                $this.find('.ItemNumber').bind('keyup paste cut', function (e) {
                    var el = $(this);
                    var keyCode = e.keyCode || e.which; // Raj - this is required to prevent 'tab' key press
                    if (e.type === 'paste') {

                        setTimeout(function () { // Raj - need a delay for mouse paste event, else it won't work
                            methods.validateEntry({ rowId: $this.attr('id'), elem: el });
                        }, 10);
                    }
                    else if (e.type === 'cut') {
                        setTimeout(function () { // Raj - need a delay for mouse cut event, else it won't work
                            methods.checkIfRowIsEmpty($this, el);
                        }, 10);
                    }
                    else {
                        methods.validateEntry({ rowId: $this.attr('id'), elem: el });
                        if (keyCode != 9) // if not tab key
                            methods.checkIfRowIsEmpty($this, el);
                    }
                });
                */

                // When the user moves out of the the ItemNumber textbox, trigger the validation and item get
                $this.find('.ItemNumber').bind('blur', function(e) {
                    var el = $(this);
                    methods.validateEntry({ rowId: rowId, elem: el, delayRequest: false });
                });
                // When the item size field is being used by the user, we need to lock out any replacement
                $this.find('.ItemSize').bind('keyup paste cut', function(e) {
                    $('#' + rowId).data('sizeBeingEdited', true);
                    
                    clearTimeout($('#' + rowId).data('rowEditTimer'));
                    $('#' + rowId).data('rowEditTimer', setTimeout(
                        function () {
                            $('#' + rowId).data('sizeBeingEdited', false);
                        }
                        , 2500
                    ));
                });
                

                $this.data('rowTimer', null);
                $this.data('rowID', rowId);
                $this.data('rowEditTimer', null);
                $this.data('sizeBeingEdited', false);
                $this.data('rowReplaceTimer', null);
            });
        },
        checkIfRowIsEmpty: function (row, ele) {
            if (ele.val().length < 1) $('a.DeleteRow', row).click();
        },
        validateEntry: function (options) {
            var $this = $(this),
                rowId = options.rowId,
                elem = options.elem,
                delayRequest = (options.delayRequest === false) ? options.delayRequest : true;

            var chars = $(elem).val().length;
            var item = $(elem).val();
            clearTimeout($('#' + rowId).data('rowTimer'));
            $('#' + rowId).data('rowTimer', null);

            // if more than 0 characters then ...
            if (chars > 0) {
                if (!methods.isValidFormat(item)) {
                    var row = $('#' + rowId);
                    methods.handleError(row, 'invaliditem');
                    return;
                }

                var delayTime = 100;
                if (delayRequest)
                    delayTime = 1500;

                $('#' + rowId).data('rowTimer', setTimeout(
                    function () {
                        clearTimeout($('#' + rowId).data('rowTimer'));
                        methods.getProductXml({ item: item, rowId: rowId });
                    }
                    , delayTime
                ));
            }
        },
        isValidFormat: function (chars) {
            var result = getFormattedItem(chars).substring(1, 5); // Raj - lipsy item starts with a char, so dont expect 1st char to be a digit
            if (isNaN(result))
                return false;
            else
                return true;
        },
        getProductXml: function (options) {
            var $this = $(this),
                item = options.item,
                rowId = options.rowId;

            // get rowNumber from rowID
            getNumberPattern = /\d+/.exec(rowId)[0];
            var rowNumber = rowId.match(getNumberPattern);
            targetRow = "#" + "QS" + rowNumber;

            clearTimeout($('#' + rowId).data('rowTimer'));
            $('#' + rowId).data('rowTimer', null);

            // remove any validation and display the loading symbol
            $(targetRow).find('.resultIcon').removeClass("valid").removeClass("error");
            $(targetRow).addClass('Loading');

            var formattedItem = getFormattedItem(item); // spaces in item number are allowed now - Raj

            // get fragment
            var request = $.get("/quickshop/" + formattedItem, "", function (returnedHtml) { });
            request.success(function (returnedHtml) {
                methods.replaceRow( { targetRow: targetRow, item: item, rowId: rowId, returnedHtml: returnedHtml, rowNumber: rowNumber});
            });
            request.error(function (response) {
                // 404s Will never fire here, you'll get a 200 response back for item not found. This is handled in the controller. You may however get 408 (Timeout) or 500 (Error)

                // In the event of an error, need to send the browser to the error page, and post in the details.
                window.location = "/error"; // TODO: post in the details
                //methods.handleError(targetRow, 'invaliditem'); // TODO: actually this is a server error...so ??? - Raj
            });
            request.complete(function (returnedHtml) {
                $(targetRow).removeClass('Loading'); // clear the loading symbol
                $("a.DeleteRow", targetRow).show(); // delete button should appear only after getting result - Raj (bug:78)
            });
        },

        handleError: function (row, errorType) {
            var textBox = $(row).children('.Item').children('input');
            $(row).children('.Item .resultIcon').remove();

            if (errorType == 'invaliditem') {
                var errorText = "Invalid item number. Please check and try again.";
                $(".Desc", row).text(errorText);
                textBox.attr("data-error", errorText);
                //debugger;
                textBox.addClass("InputError");
                textbox.attr("data-index", $(row).attr("data-index"));
                $(row).addClass("NotFound");
                $("a.DeleteRow", row).show();
            }

            textBox.validateControl('init', { popAlign: 'right' });
            textBox.validateControl('showValidationResult', textBox, false);

            textBox.removeAttr("style");
            textBox.addClass("adjustSize");
        },

        replaceRow: function (options) {
            var $this = $(this),
                targetRow = options.targetRow,
                item = options.item,
                rowId = options.rowId,
                returnedHtml = options.returnedHtml,
                rowNumber = options.rowNumber;
                
            // if the row has changed since we sent the request then we need to re-assess this field
            var newValue = $(targetRow).children('.Item').children('input').val();

            if (newValue !== item)
                methods.validateEntry({ rowId: rowId, elem: $(targetRow).children('.Item').children('input').first() });
            else {
                // assign fragment to variable
                var fragment = returnedHtml.replace(/QS\"/gi, 'QS' + rowNumber + '"'); // rewrite fragment IDs and label
                fragment = fragment.replace(/data-index=\"\"/gi, 'data-index="' + rowNumber + '"'); // rewrite data-index
                fragment = $(fragment);
                // make unique div, add content
                var tempDiv = $('<div>', { id: 'temp' + rowNumber });
                $(tempDiv).html(fragment);

                // find out which element currently has focus
                var currentFocus = '#' + $(document.activeElement).attr('id');
                var currentPosition = $(currentFocus).getCursorPosition();

                // find out what size the user entered in the textbox before the request was sent
                var sizeEntered = $(targetRow).children('.Size').children('input').first().val() + "";

                // target row and replace
                $(targetRow).attr('class',$(tempDiv).children('tr').attr('class'));
                $(targetRow).children('td.Item').replaceWith($(tempDiv).children('tr').children('td.Item'));
                $(targetRow).children('td.Desc').replaceWith($(tempDiv).children('tr').children('td.Desc'));
                $(targetRow).children('td.Delete').replaceWith($(tempDiv).children('tr').children('td.Delete'));
                                
                if ($(targetRow).hasClass('NotFound')) {
                    methods.handleError(targetRow, 'notfound');
                }
                else {
                    methods.replaceSize( { rowId:rowId, targetRow:targetRow, tempDiv:tempDiv } );
                }
                
                // Set the focus back to whatever had it a second ago
                methods.setFocus({ currentFocus:currentFocus, currentPosition:currentPosition });

                // Re-Init the row
                $(targetRow).quickShopRow();

            }
        },

        replaceSize: function (options) {
            var rowId = options.rowId,
                targetRow = options.targetRow,
                tempDiv = options.tempDiv;

            if ($('#' + rowId).data('sizeBeingEdited') !== true) {
                // find out which element currently has focus
                var currentFocus = '#' + $(document.activeElement).attr('id');
                var currentPosition = $(currentFocus).getCursorPosition();

                // This is mainly for IE9 - get rid of the focus for the element if we are changing it from a textbox to select or plain text - otherwise it will not let you select an option after it has been replaced
                if ($(currentFocus).attr('id') === $(targetRow).children('.Size').children('input').first().attr('id')) 
                    $(currentFocus).blur();

                // find out what size the user entered in the textbox before the request was sent
                var sizeEntered = $(targetRow).children('.Size').children('input').first().val() + "";

                // do the replace
                $(targetRow).children('td.Size').replaceWith($(tempDiv).children('tr').children('td.Size'));
                
                // get the user back into the state they were
                methods.setFocus({ currentFocus:currentFocus, currentPosition:currentPosition });
                methods.setSize({ targetRow:targetRow, sizeEntered:sizeEntered });
            }
            else {
                $('#' + rowId).data('rowReplaceTimer', setTimeout(
                    function () {
                        methods.replaceSize( { rowId:rowId, targetRow:targetRow, tempDiv:tempDiv } );
                    }
                    , 1000
                ));
            }
        },

        setSize: function (options) {
            var targetRow = options.targetRow,
                sizeEntered = options.sizeEntered;
                
            // Try to find the selected value from the value the user has entered
            var sizeOption = '--';
            $(targetRow).children('.Size').children('select').children('option').each(function () {
                if ($(this).text().toLowerCase() === sizeEntered.toLowerCase())
                    sizeOption = $(this).val();
                else if ((sizeOption === '--') && ($(this).text().toLowerCase().substring(0, sizeEntered.length) === sizeEntered.toLowerCase()))
                    sizeOption = $(this).val();
            });
            $(targetRow).children('.Size').children('select').first().val(sizeOption);
        },

        setFocus: function (options) {
            var currentFocus = options.currentFocus,
                currentPosition = options.currentPosition;

            // Set the focus
            $(currentFocus).focus();
            if ($(currentFocus).attr('type') !== 'hidden' && $(currentFocus).is('input'))
                $(currentFocus).setCursorPosition(currentPosition, currentPosition);
            else if ($(currentFocus).attr('type') === 'hidden')
                $(currentFocus).next().focus();
        }
    };

    // This is the main function for the quickShopRow that accepts a method name e.g. $('#QuickshopWrap').quickShopRow('init');
    $.fn.quickShopRow = function (method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            // If we haven't specified a method, then just run the init code by default
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist in Next.jQuery.quickShopRow');
        }
    };
})(jQuery);

// WHEN THIS FILE IS PARSED FIRE THE loadTriggers ABOVE
$('#qsTable > tbody > tr').each(function () {
    $(this).quickShopRow();
});

PageVisibleCallback = function () {
    UpdateContinueShopping();
}
